package com.adc.da.bs.customized.service;

import com.adc.da.bs.customized.dao.CustomizedDao;
import com.adc.da.bs.customized.vo.CustomizedServiceQueryVO;
import com.adc.da.util.http.PageParam;
import com.adc.da.util.utils.FileUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *  定制服务service
 *
 * @author 韩磊
 * @date 2019/3/22 8:47
 */
@Service
public class CustomizedService {
    @Autowired
    private CustomizedDao customizedDao;

    /**
     *  申请保存
     *
     * @author 韩磊
     * @date 2019/3/22 8:46
     * @param customizedServiceQueryVO
     * @param usermap
     * @return int
     */
    @Transactional(rollbackFor = Exception.class)
    public int createCustomizedService(CustomizedServiceQueryVO customizedServiceQueryVO, Map<String, Object> usermap) {

        Map<String, Object> map = new HashMap<String, Object>();
        map.put("phoneNum", customizedServiceQueryVO.getPhoneNum());
        map.put("contacter", customizedServiceQueryVO.getContacter());
        map.put("serviceType", customizedServiceQueryVO.getServiceType());
        map.put("content", customizedServiceQueryVO.getContent());
        map.put("userId", usermap.get("ID"));
        int n = customizedDao.createCustomizedService(map);
        return n;
    }

    /**
     *  申请记录查询列表
     *
     * @author 韩磊
     * @date 2019/3/22 8:46
     * @param usermap
     * @return java.util.Map<java.lang.String,java.lang.Object>
     */
    public Map<String, Object> getCustomizedServiceHistory(Map<String, Object> usermap) {
        Map<String, Object> map = new HashMap<String, Object>();
        List<Map<String, Object>> list = customizedDao.getCustomizedServiceHistoryList(usermap);
        map.put("rows", list);
        return map;
    }
}
