package com.adc.da.bs.cvt.validate.controller;

import com.adc.da.bs.cvt.validate.entity.ErrorMessageVO;
import com.adc.da.bs.cvt.validate.entity.ValidateVO;
import com.adc.da.bs.cvt.validate.service.ValidateService;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("validate/")
@Api(tags = "NERDS", description = "提供财税校验相关的 Rest API")
public class ValidateController {

    @Autowired
    private ValidateService validateService;

    @PostMapping("/val")
    @ApiOperation("财税校验接口")
    public ResponseMessage<List<ErrorMessageVO>> validate(@RequestBody ValidateVO validateVO){

        List<ErrorMessageVO> validateResult = new ArrayList<>();
        // 判断是否为外资
        if (validateVO.getChooseType() == 2 && validateVO.getIfImport() == 1){
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("");
            errorMessageVO.setErrorMsg("非公告车型无法识别");
            validateResult.add(errorMessageVO);
            return Result.success(validateResult);
        }
        // 校验参数为空的情况
        if ("".equals(validateVO.getCpId()) || "".equals(validateVO.getCpxh()) || "".equals(validateVO.getCpmc())
                || validateVO.getLength() == -1 || validateVO.getWeight() == -1 || validateVO.getSeats() == -1
                || validateVO.getHeightForRPoint() == -1 || "".equals(validateVO.getChooseType()) || "".equals(validateVO.getCnzz())
                || "".equals(validateVO.getCpType()) || "".equals(validateVO.getIfImport()) || validateVO.getNylx() == -1){
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("");
            errorMessageVO.setErrorMsg("公告返回的参数里有可能为空");
            validateResult.add(errorMessageVO);
            return Result.success(validateResult);
        }
        try {
            validateResult = validateService.validate(validateVO);
        } catch (Exception e) {
            return Result.error("程序异常，请等待稍后重试");
        }
        return Result.success(validateResult);
    }
}
