package com.adc.da.bs.cvt.validate.service;

import com.adc.da.bs.cvt.validate.constant.ValidateConstant;
import com.adc.da.bs.cvt.validate.entity.ErrorMessageVO;
import com.adc.da.bs.cvt.validate.entity.JYFA;
import com.adc.da.bs.cvt.validate.entity.ValidateVO;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class ValidateService {

    public List<ErrorMessageVO> validate(ValidateVO validateVO) {
        String ped = validateVO.getPed();
        String cr = validateVO.getCr();
        List<ErrorMessageVO> errorMsg = new ArrayList<>();
        List<JYFA> jyfaList = validateVO.getJyfaList();
        int e4Count = 0;
        int e5Count = 0;
        int e7Count = 0;
        int e13Count = 0;
        int e14Count = 0;
        int e21Count = 0;

        for (JYFA jyfa : jyfaList) {
            // 校验项目序号为1的项目
            if (validateVO.getCnzz().contains("锌空气蓄电池") && jyfa.getSeq() == ValidateConstant.E1SORT1.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("1");
                errorMessageVO.setErrorMsg(ValidateConstant.E1SORT1.getJyxm() + ValidateConstant.E1SORT1.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            } else if (validateVO.getCnzz().contains("超级电容器") && jyfa.getSeq() == ValidateConstant.E1SORT2.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("1");
                errorMessageVO.setErrorMsg(ValidateConstant.E1SORT2.getJyxm() + ValidateConstant.E1SORT2.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            } else if (validateVO.getCnzz().contains("锂离子动力蓄电池") || validateVO.getCnzz().contains("金属氢化物镍动力蓄电池")) {
                if (jyfa.getSeq() == ValidateConstant.E1SORT3.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("1");
                    errorMessageVO.setErrorMsg(ValidateConstant.E1SORT3.getJyxm() + ValidateConstant.E1SORT3.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                } else if (jyfa.getSeq() == ValidateConstant.E1SORT4.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("1");
                    errorMessageVO.setErrorMsg(ValidateConstant.E1SORT4.getJyxm() + ValidateConstant.E1SORT4.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                } else if (jyfa.getSeq() == ValidateConstant.E1SORT5.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("1");
                    errorMessageVO.setErrorMsg(ValidateConstant.E1SORT5.getJyxm() + ValidateConstant.E1SORT5.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                } else if (jyfa.getSeq() == ValidateConstant.E1SORT6.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("1");
                    errorMessageVO.setErrorMsg(ValidateConstant.E1SORT6.getJyxm() + ValidateConstant.E1SORT6.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            }
            // 校验项目序号为2的项目
            if (jyfa.getSeq() == ValidateConstant.E2SORT1.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("2");
                errorMessageVO.setErrorMsg(ValidateConstant.E2SORT1.getJyxm() + ValidateConstant.E2SORT1.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            } else if (jyfa.getSeq() == ValidateConstant.E2SORT2.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("2");
                errorMessageVO.setErrorMsg(ValidateConstant.E2SORT2.getJyxm() + ValidateConstant.E2SORT2.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验项目序号为3的项目
            if (jyfa.getSeq() == ValidateConstant.E3SORT1.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("3");
                errorMessageVO.setErrorMsg(ValidateConstant.E3SORT1.getJyxm() + ValidateConstant.E3SORT1.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            } else if (jyfa.getSeq() == ValidateConstant.E3SORT2.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("3");
                errorMessageVO.setErrorMsg(ValidateConstant.E3SORT2.getJyxm() + ValidateConstant.E3SORT2.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            } else if (jyfa.getSeq() == ValidateConstant.E3SORT3.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("3");
                errorMessageVO.setErrorMsg(ValidateConstant.E3SORT3.getJyxm() + ValidateConstant.E3SORT3.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            } else if (validateVO.getNylx() == 3 && jyfa.getSeq() == ValidateConstant.EA.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("3");
                errorMessageVO.setErrorMsg(ValidateConstant.EA.getJyxm() + ValidateConstant.EA.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验项目序号为4的项目
            if ((jyfa.getSeq() == ValidateConstant.E4SORT1.getSeq() && jyfa.getJylb().equals("■"))
                    || (jyfa.getSeq() == ValidateConstant.E4SORT2.getSeq() && jyfa.getJylb().equals("■"))) {
                e4Count += 1;
            }

            // 校验项目序号为5的项目
            if ((jyfa.getSeq() == ValidateConstant.E5SORT1.getSeq() && jyfa.getJylb().equals("■"))
                    || (jyfa.getSeq() == ValidateConstant.E5SORT2.getSeq() && jyfa.getJylb().equals("■"))) {
                e5Count += 1;
            }

            // 校验项目序号为6的项目
            if (jyfa.getSeq() == ValidateConstant.E6.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("6");
                errorMessageVO.setErrorMsg(ValidateConstant.E6.getJyxm() + ValidateConstant.E6.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验项目序号为7的项目
            if (validateVO.getNylx() == 1) {
                // 根据检验类型区分
                if (validateVO.getChooseType() == 1) {
                    // 推荐目录
                    if (jyfa.getSeq() == ValidateConstant.E7SORT2.getSeq() && jyfa.getJylb().equals("■")) {
                        ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                        errorMessageVO.setProjectSort("7");
                        errorMessageVO.setErrorMsg(ValidateConstant.E7SORT2.getJyxm() + ValidateConstant.E7SORT2.getJyyj() + "需填报。");
                        errorMsg.add(errorMessageVO);
                    }
                } else {
                    // 车船税购置税
                    if (jyfa.getSeq() == ValidateConstant.E7SORT1.getSeq() && jyfa.getJylb().equals("■")) {
                        e7Count += 1;
                    }
                    if (jyfa.getSeq() == ValidateConstant.E7SORT2.getSeq() && jyfa.getJylb().equals("■")) {
                        e7Count += 1;
                    }
                }
            } else if (validateVO.getNylx() == 2) {
                // 根据车型判断
                if ((validateVO.getCpType().equals("M1") || validateVO.getCpType().equals("M2"))
                        && validateVO.getWeight() <= 3500
                        && jyfa.getSeq() == ValidateConstant.E7SORT3.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("7");
                    errorMessageVO.setErrorMsg(ValidateConstant.E7SORT3.getJyxm() + ValidateConstant.E7SORT3.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                } else if ((validateVO.getCpType().equals("M1") || validateVO.getCpType().equals("M2"))
                        && validateVO.getWeight() > 3500
                        && jyfa.getSeq() == ValidateConstant.E7SORT4.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("7");
                    errorMessageVO.setErrorMsg(ValidateConstant.E7SORT4.getJyxm() + ValidateConstant.E7SORT4.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                } else if ((validateVO.getCpType().equals("N2") || validateVO.getCpType().equals("N3") || validateVO.getCpType().equals("M3"))
                        && validateVO.getWeight() <= 3500
                        && jyfa.getSeq() == ValidateConstant.E7SORT3.getSeq() && (jyfa.getJylb().equals("△") || jyfa.getJylb().equals("○"))) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("7");
                    errorMessageVO.setErrorMsg(ValidateConstant.E7SORT3.getJyxm() + ValidateConstant.E7SORT3.getJyyj() + "不应填报。");
                    errorMsg.add(errorMessageVO);
                } else if (validateVO.getCpType().equals("N1")
                        && validateVO.getWeight() > 3500
                        && jyfa.getSeq() == ValidateConstant.E7SORT4.getSeq() && (jyfa.getJylb().equals("△") || jyfa.getJylb().equals("○"))) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("7");
                    errorMessageVO.setErrorMsg(ValidateConstant.E7SORT4.getJyxm() + ValidateConstant.E7SORT4.getJyyj() + "不应填报。");
                    errorMsg.add(errorMessageVO);
                } else if (validateVO.getCpType().equals("N1") && validateVO.getWeight() <= 3500
                        && jyfa.getSeq() == ValidateConstant.E7SORT3.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("7");
                    errorMessageVO.setErrorMsg(ValidateConstant.E7SORT3.getJyxm() + ValidateConstant.E7SORT3.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                } else if ((validateVO.getCpType().equals("M3") || validateVO.getCpType().equals("N2") || validateVO.getCpType().equals("N3"))
                        && validateVO.getWeight() > 3500
                        && jyfa.getSeq() == ValidateConstant.E7SORT4.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("7");
                    errorMessageVO.setErrorMsg(ValidateConstant.E7SORT4.getJyxm() + ValidateConstant.E7SORT4.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            }

            // 校验项目序号为8的项目
            if (validateVO.getCpType().equals("M1")) {
                if (jyfa.getSeq() == ValidateConstant.E8.getSeq() && jyfa.getJylb().equals("■") && validateVO.getNylx() == 1) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("8");
                    errorMessageVO.setErrorMsg(ValidateConstant.E8.getJyxm() + ValidateConstant.E8.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            } else {
                if (jyfa.getSeq() == ValidateConstant.E8.getSeq() && (jyfa.getJylb().equals("△") || jyfa.getJylb().equals("○"))) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("8");
                    errorMessageVO.setErrorMsg(ValidateConstant.E8.getJyxm() + ValidateConstant.E8.getJyyj() + "不应填报。");
                    errorMsg.add(errorMessageVO);
                }
            }

            // 校验项目序号为9的项目
            if (validateVO.getCpType().equals("M1")) {
                if (jyfa.getSeq() == ValidateConstant.E9.getSeq() && jyfa.getJylb().equals("■")
                        && validateVO.getNylx() == 1 && validateVO.getSeats() <= 5) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("9");
                    errorMessageVO.setErrorMsg(ValidateConstant.E9.getJyxm() + ValidateConstant.E9.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            } else {
                if (jyfa.getSeq() == ValidateConstant.E9.getSeq() && (jyfa.getJylb().equals("△") || jyfa.getJylb().equals("○"))) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("9");
                    errorMessageVO.setErrorMsg(ValidateConstant.E9.getJyxm() + ValidateConstant.E9.getJyyj() + "不应填报。");
                    errorMsg.add(errorMessageVO);
                }
            }

            // 校验项目序号为10的项目
            if (validateVO.getNylx() == 3 && jyfa.getSeq() == ValidateConstant.EB.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("10");
                errorMessageVO.setErrorMsg(ValidateConstant.EB.getJyxm() + ValidateConstant.EB.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验项目序号为11的项目
            if (validateVO.getNylx() == 3 && jyfa.getSeq() == ValidateConstant.EC.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("11");
                errorMessageVO.setErrorMsg(ValidateConstant.EC.getJyxm() + ValidateConstant.EC.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验项目序号为12的项目
            if (validateVO.getNylx() == 3 && jyfa.getSeq() == ValidateConstant.EDSORT1.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("12");
                errorMessageVO.setErrorMsg(ValidateConstant.EDSORT1.getJyxm() + ValidateConstant.EDSORT1.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            } else if (validateVO.getNylx() == 3 && jyfa.getSeq() == ValidateConstant.EDSORT2.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("12");
                errorMessageVO.setErrorMsg(ValidateConstant.EDSORT2.getJyxm() + ValidateConstant.EDSORT2.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验项目序号为13的项目
            if (jyfa.getSeq() == ValidateConstant.EE.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("13");
                errorMessageVO.setErrorMsg(ValidateConstant.EE.getJyxm() + ValidateConstant.EE.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }
            if (jyfa.getSeq() == ValidateConstant.EF.getSeq() && jyfa.getJylb().equals("■")) {
                e13Count += 1;
            }
            if (jyfa.getSeq() == ValidateConstant.EG.getSeq() && jyfa.getJylb().equals("■")) {
                e14Count += 1;
            } else if (jyfa.getSeq() == ValidateConstant.EH.getSeq() && jyfa.getJylb().equals("■")) {
                e14Count += 1;
            }
            // 校验项目序号为15的项目
            if (validateVO.getCpType().equals("M1")) {
                if (jyfa.getSeq() == ValidateConstant.E28.getSeq() && jyfa.getJylb().equals("■")
                        && (validateVO.getNylx() == 1 || validateVO.getNylx() == 2)) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("15");
                    errorMessageVO.setErrorMsg(ValidateConstant.E28.getJyxm() + ValidateConstant.E28.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            } else if (validateVO.getCpType().equals("N1")) {
                if (validateVO.getWeight() <= 2500 && jyfa.getSeq() == ValidateConstant.E28.getSeq()
                        && (validateVO.getNylx() == 1 || validateVO.getNylx() == 2) && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("15");
                    errorMessageVO.setErrorMsg(ValidateConstant.E28.getJyxm() + ValidateConstant.E28.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            } else {
                if (jyfa.getSeq() == ValidateConstant.E28.getSeq() && (jyfa.getJylb().equals("△") || jyfa.getJylb().equals("○"))) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("15");
                    errorMessageVO.setErrorMsg(ValidateConstant.E28.getJyxm() + ValidateConstant.E28.getJyyj() + "不应填报。");
                    errorMsg.add(errorMessageVO);
                }
            }
            // 校验项目序号为15的项目
            if ((validateVO.getCpType().equals("M1") || validateVO.getCpType().equals("N1"))) {
                if ((validateVO.getNylx() == 1 || validateVO.getNylx() == 2) && validateVO.getHeightForRPoint() <= 700
                        && jyfa.getSeq() == ValidateConstant.E28.getSeq() && jyfa.getJylb().equals("■")){
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("15");
                    errorMessageVO.setErrorMsg(ValidateConstant.E28.getJyxm() + ValidateConstant.E28.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            } else {
                if (jyfa.getSeq() == ValidateConstant.E28.getSeq() && (jyfa.getJylb().equals("△") || jyfa.getJylb().equals("○"))) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("15");
                    errorMessageVO.setErrorMsg(ValidateConstant.E28.getJyxm() + ValidateConstant.E28.getJyyj() + "不应填报。");
                    errorMsg.add(errorMessageVO);
                }
            }

            // 校验项目序号为16的项目
            // 区分车辆类型
            if (validateVO.getCpType().equals("M2") || validateVO.getCpType().equals("M3")) {
                if (validateVO.getCpmc().contains("城市客车") && validateVO.getCnzz().equals("超级电容")
                        && jyfa.getSeq() == ValidateConstant.EL.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("16");
                    errorMessageVO.setErrorMsg(ValidateConstant.EL.getJyxm() + ValidateConstant.EL.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            } else {
                if (jyfa.getSeq() == ValidateConstant.EL.getSeq() && (jyfa.getJylb().equals("△") || jyfa.getJylb().equals("○"))) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("16");
                    errorMessageVO.setErrorMsg(ValidateConstant.EL.getJyxm() + ValidateConstant.EL.getJyyj() + "不应填报。");
                    errorMsg.add(errorMessageVO);
                }
            }

            // 校验项目序号为17的项目
            if (validateVO.getCpType().equals("M1")) {
                if (validateVO.getNylx() == 2 && jyfa.getSeq() == ValidateConstant.EM.getSeq()
                        && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("17");
                    errorMessageVO.setErrorMsg(ValidateConstant.EM.getJyxm() + ValidateConstant.EM.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            } else {
                if (jyfa.getSeq() == ValidateConstant.EM.getSeq() && (jyfa.getJylb().equals("△") || jyfa.getJylb().equals("○"))) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("17");
                    errorMessageVO.setErrorMsg(ValidateConstant.EM.getJyxm() + ValidateConstant.EM.getJyyj() + "不应填报。");
                    errorMsg.add(errorMessageVO);
                }
            }

            // 校验项目序号为18的项目
            if (jyfa.getSeq() == ValidateConstant.EN.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("18");
                errorMessageVO.setErrorMsg(ValidateConstant.EN.getJyxm() + ValidateConstant.EN.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }
            if (jyfa.getSeq() == ValidateConstant.EK.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("18");
                errorMessageVO.setErrorMsg(ValidateConstant.EK.getJyxm() + ValidateConstant.EK.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验项目序号为19的项目
            if (jyfa.getSeq() == ValidateConstant.E0.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("19");
                errorMessageVO.setErrorMsg(ValidateConstant.E0.getJyxm() + ValidateConstant.E0.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验公告序号为20的项目
            // 区分车辆类型
            if (validateVO.getCpType().equals("M2") || validateVO.getCpType().equals("M3")) {
                if (validateVO.getLength() >= 6 && validateVO.getCpmc().contains("客车") && (validateVO.getNylx() == 1 || validateVO.getNylx() == 2)
                        && jyfa.getSeq() == ValidateConstant.EJ.getSeq() && jyfa.getJylb().equals("■")) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("20");
                    errorMessageVO.setErrorMsg(ValidateConstant.EJ.getJyxm() + ValidateConstant.EJ.getJyyj() + "需填报。");
                    errorMsg.add(errorMessageVO);
                }
            } else {
                if (jyfa.getSeq() == ValidateConstant.EJ.getSeq() && (jyfa.getJylb().equals("△") || jyfa.getJylb().equals("○"))) {
                    ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                    errorMessageVO.setProjectSort("20");
                    errorMessageVO.setErrorMsg(ValidateConstant.EJ.getJyxm() + ValidateConstant.EJ.getJyyj() + "不应填报。");
                    errorMsg.add(errorMessageVO);
                }
            }

            // 校验项目序号为21的项目
            if (ped.equals("1") && jyfa.getSeq() == ValidateConstant.EP.getSeq() && !jyfa.getJylb().equals("■")) {
                e21Count += 1;
            }

            // 校验项目序号为22的项目
            if (cr.equals("1") && jyfa.getSeq() == ValidateConstant.EO.getSeq() && !jyfa.getJylb().equals("■")) {
                e21Count += 1;
            }

            // 校验项目序号为23的项目
            if (validateVO.getNylx() == 3 && jyfa.getSeq() == ValidateConstant.ER.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("23");
                errorMessageVO.setErrorMsg(ValidateConstant.ER.getJyxm() + ValidateConstant.ER.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验项目序号为24的项目
            if (validateVO.getNylx() == 3 && jyfa.getSeq() == ValidateConstant.ES.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("24");
                errorMessageVO.setErrorMsg(ValidateConstant.ES.getJyxm() + ValidateConstant.ES.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }

            // 校验项目序号为26的项目
            if (validateVO.getChooseType() == 1 && validateVO.getNylx() == 3 && jyfa.getSeq() == ValidateConstant.EU.getSeq() && jyfa.getJylb().equals("■")) {
                ErrorMessageVO errorMessageVO = new ErrorMessageVO();
                errorMessageVO.setProjectSort("26");
                errorMessageVO.setErrorMsg(ValidateConstant.EU.getJyxm() + ValidateConstant.EU.getJyyj() + "需填报。");
                errorMsg.add(errorMessageVO);
            }
        }
        // 校验项目4的2选1关系
        if (e4Count == 2) {
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("4");
            errorMessageVO.setErrorMsg(ValidateConstant.E4SORT1.getJyxm() + ValidateConstant.E4SORT1.getJyyj() + "或者" + ValidateConstant.E4SORT2.getJyxm() + ValidateConstant.E4SORT2.getJyyj() + "需填报。");
            errorMsg.add(errorMessageVO);
        } else if (e4Count == 0) {
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("4");
            errorMessageVO.setErrorMsg(ValidateConstant.E4SORT1.getJyxm() + ValidateConstant.E4SORT1.getJyyj() + "和" + ValidateConstant.E4SORT2.getJyxm() + ValidateConstant.E4SORT2.getJyyj() + "需满足2选1条件。");
            errorMsg.add(errorMessageVO);
        }
        // 校验项目5的2选1关系
        if (e5Count == 2) {
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("5");
            errorMessageVO.setErrorMsg(ValidateConstant.E5SORT1.getJyxm() + ValidateConstant.E5SORT1.getJyyj() + "或者" + ValidateConstant.E5SORT2.getJyxm() + ValidateConstant.E5SORT2.getJyyj() + "需填报。");
            errorMsg.add(errorMessageVO);
        } else if (e5Count == 0) {
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("5");
            errorMessageVO.setErrorMsg(ValidateConstant.E5SORT1.getJyxm() + ValidateConstant.E5SORT1.getJyyj() + "和" + ValidateConstant.E5SORT2.getJyxm() + ValidateConstant.E5SORT2.getJyyj() + "需满足2选1条件。");
            errorMsg.add(errorMessageVO);
        }
        // 校验项目7的2选1关系
        if (validateVO.getChooseType() == 2 && validateVO.getNylx() == 1 && e7Count == 2) {
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("7");
            errorMessageVO.setErrorMsg(ValidateConstant.E7SORT1.getJyxm() + ValidateConstant.E7SORT1.getJyyj() + "或者" + ValidateConstant.E7SORT2.getJyxm() + ValidateConstant.E7SORT2.getJyyj() + "需填报。");
            errorMsg.add(errorMessageVO);
        } else if (validateVO.getChooseType() == 2 && validateVO.getNylx() == 1 && e7Count == 0) {
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("7");
            errorMessageVO.setErrorMsg(ValidateConstant.E7SORT1.getJyxm() + ValidateConstant.E7SORT1.getJyyj() + "和" + ValidateConstant.E7SORT2.getJyxm() + ValidateConstant.E7SORT2.getJyyj() + "需满足2选1条件。");
            errorMsg.add(errorMessageVO);
        }
        // 校验项目13和14之间2选1的关系
        if (e13Count == 1 && e14Count == 2) {
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("13");
            errorMessageVO.setErrorMsg(ValidateConstant.EF.getJyxm() + ValidateConstant.EF.getJyyj() + "或者" + ValidateConstant.EG.getJyxm() + ValidateConstant.EG.getJyyj() + "或者" + ValidateConstant.EH.getJyxm() + ValidateConstant.EH.getJyyj() + "需填报。");
            errorMsg.add(errorMessageVO);
        }else if (e13Count == 0 && (e14Count == 1 || e14Count == 0)){
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("13");
            errorMessageVO.setErrorMsg(ValidateConstant.EF.getJyxm() + ValidateConstant.EF.getJyyj() + "和" + ValidateConstant.EG.getJyxm() + ValidateConstant.EG.getJyyj() + "或" + ValidateConstant.EH.getJyxm() + ValidateConstant.EH.getJyyj() + "需满足2选1条件。");
            errorMsg.add(errorMessageVO);
        }else if (e13Count == 1 && e14Count == 1){
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("13");
            errorMessageVO.setErrorMsg(ValidateConstant.EG.getJyxm() + ValidateConstant.EG.getJyyj() + "或者" + ValidateConstant.EH.getJyxm() + ValidateConstant.EH.getJyyj() + "需填报。");
            errorMsg.add(errorMessageVO);
        }
        // 校验项目21和22之间2选1的关系
        if (e21Count == 0) {
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("21");
            errorMessageVO.setErrorMsg(ValidateConstant.EP.getJyxm() + ValidateConstant.EP.getJyyj() + "和项目22" + ValidateConstant.EO.getJyxm() + ValidateConstant.EO.getJyyj() + "需满足2选1条件。");
            errorMsg.add(errorMessageVO);
        }else if (e21Count == 2){
            ErrorMessageVO errorMessageVO = new ErrorMessageVO();
            errorMessageVO.setProjectSort("21");
            errorMessageVO.setErrorMsg(ValidateConstant.EP.getJyxm() + ValidateConstant.EP.getJyyj() + "或者" + ValidateConstant.EO.getJyxm() + ValidateConstant.EO.getJyyj() + "需填报。");
            errorMsg.add(errorMessageVO);
        }
        return errorMsg;
    }

}
