package com.adc.da.bs.manage.rest;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
 


import com.adc.da.bs.manage.entity.RecordManageEntity;
import com.adc.da.bs.manage.service.RecordManageService;
import com.adc.da.util.http.PageParam;
/**
 * 4.5.	备案经验管理
 * @author LuZhiPeng
 *
 */
@Controller
@RequestMapping(value = "/${restPath}/recordmanage")
@Api(description = "备案经验管理")
public class RecordManageController {
	@Autowired
	private RecordManageService recordManageService;
	
	@ApiOperation(value = "备案经验管理列表")
    @PostMapping("/indexList")
    @ResponseBody
    public Map<String, Object> indexlist(HttpServletRequest request,PageParam page) {
		page.setLimit(15);
		page.setOffset(0);
		Map<String,Object> pageMap =recordManageService.findWorkIndex(page);//首页取15条数据
        return pageMap;
    	
    }
	
	@ApiOperation(value = "查询备案经验管理")
    @PostMapping("/recordmanageList")
    @ResponseBody
    public Map<String, Object> findWorkList(HttpServletRequest request,PageParam page, String type, String expName) {
		
    	Map<String,Object> pageMap =recordManageService.findWorkList(page, type, expName);
        return pageMap; 
    }
	
	@ApiOperation(value = "备案经验管理文件增加浏览量")
    @PostMapping("/viewCount")
    @ResponseBody
    public void viewCount(HttpServletRequest request ,Integer id) {
		
    	boolean i = recordManageService.changeViewCount(id);
      
    }	
	
	@ApiOperation(value = "备案经验管理文件增加下载量")
    @PostMapping("/downloadCount")
    @ResponseBody
    public void downloadCount(HttpServletRequest request ,Integer id) {
		
    	boolean i = recordManageService.changeDownloadCount(id);
      
    }	
	
	@ApiOperation(value = "备案经验管理文件删除")
    @PostMapping("/delete")
    @ResponseBody
    public void deleteWork(HttpServletRequest request ,Integer id) {
		
    	boolean i = recordManageService.deleteWork(id);
      
    }	
	
	 @PostMapping("/addRecordmanage")
	 @ResponseBody
	 @ApiOperation(value = "添加备案经验管理文件")
	    public Map<String, Object> addWork(HttpServletRequest request, @RequestBody RecordManageEntity recordManageEntity){	      
	        Map<String, Object> res = recordManageService.addWork(recordManageEntity);
	        return res;
	    }

}
