package com.adc.da.bs.manage.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.adc.da.bs.manage.dao.PolicyManageDao;
import com.adc.da.bs.manage.entity.PolicyManageEntity;
import com.adc.da.util.http.PageParam;
/**
 * 4.4.2.	政策解读管理
 * @author LuZhiPeng
 *
 */

@Service
public class PolicyManageService {
	@Autowired
	private PolicyManageDao policyManageDao;
	
/**
 * 条目索引分页	
 * @param page
 * @return
 */
	public Map<String, Object> findWorkIndex(PageParam page){
		Map<String, Object> result = new HashMap<>();
		Long count = policyManageDao.findTotalCount(page, null, null);
		List<Map<String, Object>> list = policyManageDao.findAllByPage(page);
		result.put("total", count);
		result.put("rows", list);

		return result;
	}
	/**
	 * 条件查询并分页
	 * @param page
	 * @param source
	 * @param name
	 * @return
	 */
	public Map<String, Object> findWorkList(PageParam page,String source, String title) {
		Map<String, Object> result = new HashMap<>();
		Long count = policyManageDao.findTotalCount(page, source, title);
		List<Map<String, Object>> list = policyManageDao.findListByPage(page, source, title);
		result.put("total", count);
		result.put("rows", list);

		return result;
	}
	/**
	 * 添加
	 * @param policyManageEntity
	 * @return
	 */
	@Transactional
	public Map<String,Object> addWork(PolicyManageEntity policyManageEntity){
		Map<String, Object> result = policyManageDao.insertWork(policyManageEntity);
		return result;
	}
	@Transactional
	public boolean changeViewCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=policyManageDao.changeViewCountById(id);
		return i;
	}
	@Transactional
	public boolean changeDownloadCount(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=policyManageDao.changeDownloadCountById(id);
		return i;
	}
	@Transactional
	public boolean deleteWork(Integer id) {
		Map<String, Object> result = new HashMap<>();
		boolean i=policyManageDao.deleteWork(id);
		return i;
	}
}
