package com.adc.da.bs.nerds.rest;

import com.adc.da.bs.nerds.service.NerdsService;
import com.adc.da.util.http.PageParam;
import com.adc.da.util.utils.RedisUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * 推荐目录Controller
 * zhong
 * 2018-3-22
 */

@RestController
@RequestMapping(value = "/${restPath}/nerds")
@Api(description = "推荐目录/车船税/购置税")
public class NerdsController {

    @Autowired
    private NerdsService nerdsService;

    @Autowired
    private RedisUtils redisUtils;

    /**
     * 推荐目录列表
     * zhong
     * 2018-3-22
     */
    @ApiOperation(value = "推荐目录列表")
    @PostMapping("/list")
    @ResponseBody
    public Map<String, Object> findList(HttpServletRequest request, PageParam page, String xh
            , String mc, String sb, String lx, String type) {
//		public ResponseMessage<String> findList(PageParam page,String pc) {
        if ((xh == "" || "undefined".equals(xh))
                && (mc == "" || "undefined".equals(mc))
                && (sb == "" || "undefined".equals(sb))
                && (lx == "" || "undefined".equals(lx))) return null;
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("xh", xh);
        map.put("mc", mc);
        map.put("sb", sb);
        map.put("lx", lx);
        map.put("type", type);
        Map<String, Object> pageMap = nerdsService.findMap(page, map);
        return pageMap;
        //return Result.success(GsonUtil.toJson(pageMap));
    }

    /**
     * 推荐目录列表
     * zhong
     * 2018-3-22
     */
    @ApiOperation(value = "推荐目录列表")
    @PostMapping("/nerdsdetail")
    @ResponseBody
    public Map<String, Object> nerdsdetail(HttpServletRequest request, String p_model, String p_id, String type) {
        Map<String, Object> pageMap = new HashMap<String, Object>();
        List<Map<String, Object>> jbxxItems = nerdsService.getNerdsParamItems("P_JBXX");
        List<Map<String, Object>> nerdsParamData = this.nerdsService.getNerdsParamData(p_id, p_model, type);
        Map<String, Object> paramDataMap = new HashMap<String, Object>();
        if ("N".equals(type)) {
            // 获取单个车辆的技术参数值, 配置ID_序号   值
//	            Map<String, Object> jbxxItemsMap = new HashMap<String, Object>();
//	            List<Map<String, Object>> jbxxItemsList = new ArrayList<Map<String, Object>>();
            for (Map<String, Object> m : nerdsParamData) {
                paramDataMap.put(m.get("PZ_ID") + "_" + m.get("JSCS_SEQ"), m.get("JSCS_VAL") == null ? "-" : m.get("JSCS_VAL").toString());
            }
            pageMap.put("paramDataMap", paramDataMap);

        } else if ("G".equals(type)) {
            // 获取单个车辆的技术参数值, 配置ID_序号   值
            Map<String, Object> paramYDataMap = new HashMap<String, Object>();
            Map<String, Object> paramHDataMap = new HashMap<String, Object>();
            for (Map<String, Object> m : nerdsParamData) {
                paramYDataMap.put(m.get("PZ_ID") + "_" + m.get("JSCS_SEQ"), m.get("FIELDYVALUE") == null ? "-" : m.get("FIELDYVALUE").toString());

                paramHDataMap.put(m.get("PZ_ID") + "_" + m.get("JSCS_SEQ"), m.get("FIELDHVALUE") == null ? "-" : m.get("FIELDYVALUE").toString());
            }
            pageMap.put("paramYDataMap", paramYDataMap);
            pageMap.put("paramHDataMap", paramHDataMap);
        }
        List<Map<String, Object>> pzList = this.nerdsService.getCollocations(p_id, p_model, type);
        pageMap.put("jbxxItems", jbxxItems);
        pageMap.put("pzList", pzList);
        return pageMap;
        //return Result.success(GsonUtil.toJson(pageMap));
    }

    /***
     *
     * @Title: gzsList
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @param @param request
     * @param @param page
     * @param @param xh
     * @param @param mc
     * @param @param sb
     * @param @param qymc
     * @param @param type
     * @param @return    设定文件
     * @return   返回类型
     * @Title: TjmlPc
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午1:34:00
     */
    @ApiOperation(value = "推荐目录pc列表2021")
    @PostMapping("/TjmlPc")
    @ResponseBody
    public List<Map<String, Object>> TjmlPc() {
        long time = 60 * 24 * 30;
        List<Map<String, Object>> TjmlPc = new ArrayList<>();
        try {
            if (!redisUtils.exists("TjmlPc")) {
                TjmlPc = nerdsService.TjmlPc();
                redisUtils.set("TjmlPc", TjmlPc, time, TimeUnit.MINUTES);
            } else {
                TjmlPc = (List<Map<String, Object>>) redisUtils.get("TjmlPc");
            }
        } catch (Exception e) {
            e.printStackTrace();
            TjmlPc = nerdsService.TjmlPc();
        }
        return TjmlPc;
    }

}
