package com.adc.da.bs.nerds.service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.adc.da.bs.nerds.dao.NerdsDao;
import com.adc.da.util.http.PageParam;

/**
 * 推荐目录Service
 * zhong
 * 2018-3-22
 */
@Service
public class NerdsService {
	
	@Autowired
	private NerdsDao nerdsDao;

	public Map<String, Object> findMap(PageParam page, Map<String, Object> map) {
		Map<String, Object> remap = new HashMap<>();
        List<Map<String, Object>> list=nerdsDao.findPage(page,map);
        Long count=nerdsDao.findPageCount(map);
        remap.put("total", count);
        remap.put("rows", list);
		return remap;
	}
	/**
     * 从字典表查询NERDS的参数项目
     *
     * @param partId
     * @return
     */
	public List<Map<String, Object>> getNerdsParamItems(String partId) {
		 return this.nerdsDao.getNerdsParamItems(partId);
	}
	public List<Map<String, Object>> getNerdsParamData(String p_id,
			String p_model, String type) {
		return this.nerdsDao.getNerdsParamData(p_id,p_model,type);
	}
	public List<Map<String, Object>> getCollocations(String p_id,
			String p_model, String type) {
		return this.nerdsDao.getCollocations(p_id, p_model, type);
	}
	/**   
	 * @Title: gzsList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param map
	 * @param @return    设定文件   
	 * 
	 * @author ADC_ZH 
	 * @date 上午11:43:51 
	*/   
	public Map<String, Object> gzsList(PageParam page, Map<String, Object> map) {
		
		Map<String, Object> remap = new HashMap<>();
        List<Map<String, Object>> list=nerdsDao.gzsList(page,map);
        Long count=nerdsDao.gzsListCount(map);
        remap.put("total", count);
        remap.put("rows", list);
		return remap; 
 
	}
	/**   
	 * @Title: ccsList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param page
	 * @param @param map
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午4:18:27 
	*/   
	public Map<String, Object> ccsList(PageParam page, Map<String, Object> map) {
		
		Map<String, Object> remap = new HashMap<>();
        List<Map<String, Object>> list=nerdsDao.ccsList(page,map);
        Long count=nerdsDao.ccsListCount(map);
        remap.put("total", count);
        remap.put("rows", list);
		return remap; 
	}
	/**   
	 * @Title: findTjmlColumn   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午1:05:09 
	*/   
	public  List<Map<String, Object>>  findTjmlColumn() {
        List<Map<String, Object>> list=nerdsDao.findTjmlColumn();

		return list;
	}
	/**   
	 * @Title: TjmlPc   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:20:25 
	*/   
	public List<Map<String, Object>> TjmlPc() {
		List<Map<String, Object>> list=nerdsDao.TjmlPc();
		return list;
	}
	/**   
	 * @Title: tjmlList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param map
	 * @param @param tjmlColumn
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午1:36:44 
	*/   
	public Map<String, Object> tjmlList(PageParam page,Map<String, Object> map,
			List<Map<String, Object>> tjmlColumn) {
		Map<String, Object> remap = new HashMap<>();
        List<Map<String, Object>> list=nerdsDao.tjmlList(page,map);
        Long count=nerdsDao.tjmlListCount(map);
        remap.put("total", count);
        remap.put("rows", list);
		return remap; 
	}
	/**   
	 * @Title: tjmlDetail   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param cp_id
	 * @param @param tjmlColumn
	 * @param @return    设定文件    
	 * @author ADC_ZH 
	 * @date 下午2:40:28 
	*/   
	public List<Map<String, Object>> tjmlDetail(String cp_id,
			List<Map<String, Object>> tjmlColumn) {
        List<Map<String, Object>> list=nerdsDao.tjmlDetail(cp_id,tjmlColumn);

		return list;
	}
	
	
	
}
