package com.adc.da.bs.other.rest;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.adc.da.bs.nerds.service.NerdsService;
import com.adc.da.bs.other.service.NewsService;
import com.adc.da.bs.param.service.ParamService;
import com.adc.da.util.http.PageParam;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import com.adc.da.util.utils.GsonUtil;
import com.google.gson.Gson;

/**
 * 新闻Controller
 * zhong
 * 2018-4-4
 */

@RestController
@RequestMapping(value = "/${restPath}/news")
@Api(description = "新闻")
public class NewsController {
 
	@Autowired
	private NewsService newsService;
	
	/**
	 * 新闻列表
	 * zhong
	 * 2018-3-22
	 */
	@ApiOperation(value = "新闻列表")
    @PostMapping("/indexlist")
    @ResponseBody
    public Map<String, Object> indexlist(HttpServletRequest request) {
		PageParam page=new PageParam();
		page.setLimit(5);
		page.setOffset(1);
//		public ResponseMessage<String> findList(PageParam page,String pc) {
		int[] typeids = new int[]{1,2,3};
		//Map<String, Object> map=new HashMap<String, Object>();
    	Map<String,Object> pageMap =newsService.indexlist(page,typeids);//首页每种取5条
        return pageMap;
    	//return Result.success(GsonUtil.toJson(pageMap));
    }
	/**
		 * 新闻
		 * zhong
		 * 2018-3-14
		 */
		@ApiOperation(value = "新闻列表")
	    @PostMapping("/newslist")
	    @ResponseBody
	    public Map<String, Object> newslist(HttpServletRequest request,PageParam page,String type,String name) {
			int typeid=0;
			try {
				name=URLDecoder.decode(name, "UTF-8");
				name="undefined".equals(name)?"":name;
				if(type!=null&&!"".equals(type)){
					typeid=Integer.parseInt(type);
				}
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}
	    	Map<String,Object> pageMap =newsService.newslist(page,typeid , name);//type=0时查询所有
	        return pageMap; 
	    }
		/**
		 * 新闻
		 * zhong
		 * 2018-3-14
		 */
		@ApiOperation(value = "首页资讯列表2021-更多（政府通知、行业信息、公告、新能源）")
	    @PostMapping("/newslistIndex")
	    @ResponseBody
	    public Map<String, Object> newslistIndex(HttpServletRequest request,PageParam page,int type) {
			
	    	Map<String,Object> pageMap =newsService.newslist(page,type , "");//type=0时查询所有
	        return pageMap; 
	    }
		/**
		 * 新闻
		 * zhong
		 * 2018-3-14
		 */
		@ApiOperation(value = "首页资讯列表2021")
	    @PostMapping("/newsIndexGroupByType")
	    @ResponseBody
	    public Map<String, Object> newsIndexGroupByType(HttpServletRequest request,PageParam page,String type) {
 	    	Map<String,Object> pageMap =newsService.newsIndexGroupByType(page,type , "");//type=0时查询所有
	        return pageMap; 
	    }
		/**
		 * 记录点击次数
		 * zhong
		 * 2018-5-29
		 */
		@ApiOperation(value = "新增点击次数-资讯-行业信息+政府通知+公告+新能源2021")
	    @PostMapping("/clickcount")
	    @ResponseBody
	    public void clickcount(HttpServletRequest request ,String ID) {
			
	    	int i = newsService.clickcount(ID);//首页每种取5条
	      
	    }	
		
		/**
		 * 记录点击次数
		 * zhong
		 * 2021-01-07
		 */
		@ApiOperation(value = "新增点击次数-资讯-整车+零部件2021")
	    @PostMapping("/addclick")
	    @ResponseBody
	    public void addclick(HttpServletRequest request ,String ID) {
			
	    	int i = newsService.addclick(ID);
	      
	    }	
		
	/**
	 * 推荐目录列表
	 * zhong
	 * 2018-3-22
	 */
	/*@ApiOperation(value = "推荐目录列表")
    @PostMapping("/nerdsdetail")
    @ResponseBody
    public Map<String, Object> nerdsdetail(HttpServletRequest request,String p_model,String p_id,String type) {
		Map<String, Object> pageMap=new HashMap<String, Object>();
		List<Map<String, Object>> jbxxItems=nerdsService.getNerdsParamItems("P_JBXX"); 
		List<Map<String,Object>> nerdsParamData = this.nerdsService.getNerdsParamData(p_id,p_model,type);
		Map<String, Object> paramDataMap = new HashMap<String, Object>();
		if ("N".equals(type)){
	            // 获取单个车辆的技术参数值, 配置ID_序号   值
//	            Map<String, Object> jbxxItemsMap = new HashMap<String, Object>();
//	            List<Map<String, Object>> jbxxItemsList = new ArrayList<Map<String, Object>>();
	            for(Map<String, Object> m : nerdsParamData){
	                paramDataMap.put(m.get("PZ_ID") + "_" + m.get("JSCS_SEQ"), m.get("JSCS_VAL"));
	            }
	            pageMap.put("paramDataMap", paramDataMap);
	            
	        } else if ("G".equals(type)){
	            // 获取单个车辆的技术参数值, 配置ID_序号   值
	            Map<String, Object> paramYDataMap = new HashMap<String, Object>();
	            Map<String, Object> paramHDataMap = new HashMap<String, Object>();
	            for(Map<String, Object> m : nerdsParamData){
	                paramYDataMap.put(m.get("PZ_ID") + "_" + m.get("JSCS_SEQ"), m.get("FIELDYVALUE")==null?"-":m.get("FIELDYVALUE").toString());
	                
	                paramHDataMap.put(m.get("PZ_ID") + "_" + m.get("JSCS_SEQ"), m.get("FIELDHVALUE"));
	            }
	            pageMap.put("paramYDataMap", paramYDataMap);
	            pageMap.put("paramHDataMap", paramHDataMap);
	        }
		 List<Map<String, Object>> pzList = this.nerdsService.getCollocations(p_id,p_model,type);
		 pageMap.put("jbxxItems", jbxxItems);
		 pageMap.put("pzList", pzList);
        return pageMap;
    	//return Result.success(GsonUtil.toJson(pageMap));
    }
	
	*//**
	 * 车型参数列表
	 * zhong
	 * 2018-3-14
	 *//*
	@ApiOperation(value = "详细")
    @PostMapping("/paramdetail")
    @ResponseBody

    public Map<String, Object> paramdetail(String xh, String type) {
//		public ResponseMessage<String> findList(PageParam page,String pc) {
    	Map<String,Object> pageMap =paramService.paramdetail(xh, type);
        return pageMap; 
    }
	
	*//**
	 * 车型参数列表
	 * zhong
	 * 2018-3-14
	 *//*
	@ApiOperation(value = "按xh列表")
    @PostMapping("/findxhList")
    @ResponseBody
    public Map<String, Object> findxhList(HttpServletRequest request,PageParam page,String xh) {
		request.getSession().setAttribute("req", xh); 
    	Map<String,Object> pageMap =paramService.findxhPage(page, xh);
        return pageMap; 
    }
	*//**
	 * 车型参数列表
	 * zhong
	 * 2018-3-14
	 *//*
	@ApiOperation(value = "按name列表")
    @PostMapping("/findnameList")
    @ResponseBody
    public Map<String, Object> findnameList(HttpServletRequest request,PageParam page,String name) {
		try {
			name=URLDecoder.decode(name, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	Map<String,Object> pageMap =paramService.findnamePage(page, name);
        return pageMap;
    	 
    }
	*//**
	 * 企业数量统计
	 * zhong
	 * 2018-3-14
	 *//*
	@ApiOperation(value = "详细")
    @PostMapping("/paramcount")
    @ResponseBody

    public Map<String, Object> paramcount(HttpServletRequest request) {
//		public ResponseMessage<String> findList(PageParam page,String pc) {
    	Map<String,Object> pageMap =paramService.paramcount();
        return pageMap; 
    }*/
}
