package com.adc.da.bs.param.dao;

import com.adc.da.bs.param.entity.SearchProductParams;
import com.adc.da.util.http.PageParam;

import org.apache.commons.lang3.StringUtils;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import java.io.File;
import java.util.*;

/**
 * 车型参数Dao
 * zhong
 * 2021-1-14
 */


@Component
public class ParamChartsDao{
	protected final EntityManager entityManager;
	@Autowired
	public ParamChartsDao(EntityManager entityManager) {
		super();
        this.entityManager = entityManager;
	}

	/**   
	 * @Title: lineCharts   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @param i
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午4:34:15 
	*/   
	public List<Map<String, Object>> lineCharts(String qyid, int i) {
		StringBuffer sql = new StringBuffer();
		sql.append(" WITH YM AS ( ");
		sql.append(" SELECT (TO_CHAR(SYSDATE ,'yyyy')-"+i+")||lpad(level,2,0) YYYYMM FROM DUAL connect by level<13 ");
		sql.append(" ), ");
		sql.append(" ZK AS ( ");
		sql.append(" SELECT YYYYMM ,SUM(COU) COU FROM( ");
		sql.append(" SELECT SUBSTR(生效日期, 0, 6) YYYYMM ,COUNT(*)  COU ");
		sql.append(" FROM retrieval.clcp_zk ");
		sql.append(" WHERE 企业ID ='"+qyid+"' AND SUBSTR(生效日期, 0, 4)>=(TO_CHAR(SYSDATE ,'yyyy')-"+i+") ");
		sql.append(" GROUP BY SUBSTR(生效日期, 0, 6) ");
		sql.append(" UNION ");
		sql.append(" SELECT SUBSTR(生效日期, 0, 6) YYYYMM ,COUNT(*)  COU ");
		sql.append(" FROM retrieval.chpdpk_zk ");
		sql.append(" WHERE 企业ID='"+qyid+"' AND SUBSTR(生效日期, 0, 4)>=(TO_CHAR(SYSDATE ,'yyyy')-"+i+")  ");
		sql.append(" GROUP BY SUBSTR(生效日期, 0, 6) ");
		sql.append(" )GROUP BY YYYYMM  ");
		sql.append(" ) ");
		sql.append(" SELECT YM.YYYYMM, NVL(ZK.COU,0) COU FROM YM LEFT JOIN ZK ON YM.YYYYMM=ZK.YYYYMM ");
		sql.append(" WHERE YM.YYYYMM <= TO_CHAR(SYSDATE ,'YYYYMM')  ORDER BY YM.YYYYMM DESC ");
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	/**   
	 * @Title: barCharts   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param string
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 上午9:49:31 
	*/   
	public List<Map<String, Object>> barCharts(String column) {
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT * FROM ( ");
		sql.append(" SELECT "+column+" ,SUM(COU) COU FROM ( ");
		sql.append(" SELECT "+column+" ,COUNT(*) cou FROM retrieval.clcp_zk  WHERE 批次=(SELECT MAX(TO_NUMBER( NVL(批次,0))) FROM retrieval.clcp_zk) GROUP BY "+column+" ");
		sql.append(" UNION ");
		sql.append(" SELECT "+column+" ,COUNT(*) cou FROM retrieval.clcp_zk  WHERE 批次=(SELECT MAX(TO_NUMBER( NVL(批次,0))) FROM retrieval.clcp_zk) GROUP BY "+column+" ");
		sql.append(" )GROUP BY "+column+" ORDER BY COU DESC ");
		sql.append(" )WHERE ROWNUM<11 "); 
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	/**   
	 * @Title: compare   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @param i
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:48:17 
	*/   
	public List<Map<String, Object>> compare(String qyid, int i) {
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT YYYYMM ,SUM(COU) COU FROM( ");
		sql.append(" SELECT  YYYYMM ,NVL(COUNT(*),0)   COU ");
		sql.append(" FROM retrieval.clcp_zk,  (SELECT (TO_CHAR(ADD_MONTHS(SYSDATE, -"+i+") ,'YYYYMM')) YYYYMM FROM DUAL ) dd ");
		sql.append(" WHERE 企业ID ='"+qyid+"' ");
		sql.append(" AND SUBSTR(生效日期, 0, 6) =dd.YYYYMM ");
		sql.append(" UNION ");
		sql.append(" SELECT  YYYYMM ,NVL(COUNT(*),0)   COU ");
		sql.append(" FROM retrieval.chpdpk_zk,(SELECT (TO_CHAR(ADD_MONTHS(SYSDATE, -"+i+") ,'YYYYMM')) YYYYMM FROM DUAL ) dd ");
		sql.append(" WHERE 企业ID ='"+qyid+"' ");
		sql.append(" AND SUBSTR(生效日期, 0, 6) =dd.YYYYMM ");
		sql.append(" )GROUP BY YYYYMM ORDER BY YYYYMM DESC ");
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}

	/**   
	 * @Title: compareByYear   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qyid
	 * @param @param i
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午4:02:33 
	*/   
	public List<Map<String, Object>> compareByYear(String qyid, int i) {
		StringBuffer sql = new StringBuffer();
		sql.append(" SELECT YYYY ,SUM(COU) COU,(TO_CHAR(ADD_MONTHS(SYSDATE, -"+i+") ,'YYYYMM')) YYYYMM FROM( ");
		sql.append(" SELECT  YYYY  ,NVL(COUNT(*),0)   COU ");
		sql.append(" FROM retrieval.clcp_zk,  (SELECT (TO_CHAR(ADD_MONTHS(SYSDATE, -"+i+") ,'YYYY')) YYYY FROM DUAL ) dd ");
		sql.append(" WHERE 企业ID='"+qyid+"' ");
		sql.append(" AND SUBSTR(生效日期, 0, 4) =dd.YYYY ");
		sql.append(" AND SUBSTR(生效日期, 0, 6)>=((TO_CHAR(ADD_MONTHS(SYSDATE, -"+i+") ,'YYYY'))||'00') ");
		sql.append(" AND SUBSTR(生效日期, 0, 6)<=(TO_CHAR(ADD_MONTHS(SYSDATE, -"+i+") ,'YYYYMM')) ");
		sql.append(" UNION ");
		sql.append(" SELECT  YYYY ,NVL(COUNT(*),0)   COU ");
		sql.append(" FROM retrieval.chpdpk_zk,  (SELECT (TO_CHAR(ADD_MONTHS(SYSDATE, -"+i+") ,'YYYY')) YYYY FROM DUAL ) dd ");
		sql.append(" WHERE 企业ID='"+qyid+"' ");
		sql.append(" AND SUBSTR(生效日期, 0, 4) =dd.YYYY ");
		sql.append(" AND SUBSTR(生效日期, 0, 6)>=((TO_CHAR(ADD_MONTHS(SYSDATE, -"+i+") ,'YYYY'))||'00') ");
		sql.append(" AND SUBSTR(生效日期, 0, 6)<=(TO_CHAR(ADD_MONTHS(SYSDATE, -"+i+") ,'YYYYMM')) ");
		sql.append(" )GROUP BY YYYY ORDER BY YYYY DESC ");
		Query query = entityManager.createNativeQuery(sql.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}

}
