package com.adc.da.bs.param.service;

import com.adc.da.bs.param.dao.MbDao;
import com.adc.da.bs.param.entity.MbxmEO;
import com.adc.da.bs.param.entity.MbxmVO;
import com.adc.da.bs.param.entity.NerdsInfoEO;
import com.adc.da.bs.reportManage.utils.PoiUtil;
import com.adc.da.bs.reportManage.utils.ZipUtil;
import com.adc.da.util.exception.AdcDaBaseException;
import com.adc.da.util.utils.ExcelUtils;
import org.apache.commons.lang.StringUtils;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

@Service
public class MbService {

    private static org.slf4j.Logger logger = LoggerFactory.getLogger (MbService.class);

    private static final LinkedHashMap<String, String> expertDefault = new LinkedHashMap<String, String> () {
        {
            put ("QYMC", "QYMC");
            put ("CPXH", "CPXH");
            put ("CPMC", "CPMC");
            put ("CPSB", "CPSB");
            put ("PC", "PC");
        }
    };

    @Autowired
    private MbDao mbDao;

    public List<MbxmEO> queryMbxmList(String type) {
        return mbDao.queryMbxmList (type);
    }

    public void createMbxm(MbxmVO mbxmVO) {
        if (mbDao.checkMbxm (mbxmVO.getMbName ()) > 0) {
            logger.error ("模板项目名称:" + mbxmVO.getMbName () + "已存在，无法保存！");
            throw new AdcDaBaseException ("模板项目名称:" + mbxmVO.getMbName () + "已存在，无法保存！");
        }

        mbDao.createMbxm (mbxmVO);
    }

    public Map<String, Object> findMbListByQyid(String qyid, String mbmc) {
        long start = System.currentTimeMillis();
        Map<String, Object> resultMap = new HashMap<> ();
        List<Map<String, Object>> list = mbDao.findMbListByQyid (qyid, mbmc);

        List<Map<String, Object>> resultList = new ArrayList<Map<String, Object>> ();

        List<String> keys = new ArrayList<String>();

        // 获取模板名称集合
        for (Map<String, Object> data : list) {
            if(!keys.contains (data.get ("NAME").toString ())) {
                keys.add (data.get ("NAME").toString ());
            }
        }

        // 遍历模板名称集合
        for (String key : keys) {
            Map<String, Object> map = new HashMap<> ();
            // 遍历模板名称
            for (Map<String, Object> data : list) {
                if(key.equals (data.get ("NAME").toString ())){
                    if("ZC".equals (data.get ("TYPE").toString ())){
                        map.put ("value_zc", data.get ("PARAMVALUE"));
                    } else if("DP".equals (data.get ("TYPE").toString ())){
                        map.put ("value_dp", data.get ("PARAMVALUE"));
                    } else if("BA".equals (data.get ("TYPE").toString ())) {
                        map.put ("value_ba", data.get ("PARAMVALUE"));
                    }
                    map.put ("name", data.get ("NAME").toString ());
                    map.put ("ID", data.get ("ID").toString ());
                }
            }
            resultList.add (map);
        }

        resultMap.put ("mblist", resultList);
        logger.info("findMbListByQyid所花时间：" + (System.currentTimeMillis() - start));
        return resultMap;
    }

    public void exportExcel(Map<String, Object> selectlist, String mbid, HttpServletResponse response, boolean checkData) throws AdcDaBaseException {

        List<Map<String, Object>> dataList = (List<Map<String, Object>>) selectlist.get ("selectedrows");
        List<List<String>> resultList = new ArrayList<> ();

        List<List<String>> resultList338 = new ArrayList<> ();
        List<List<String>> resultList339 = new ArrayList<> ();

        List<String> titleList = new ArrayList<> ();
        List<String> titleExpertList = new ArrayList<> ();

        List<Map<String, Object>> dataList338 = new ArrayList<Map<String, Object>> ();
        List<Map<String, Object>> dataList339 = new ArrayList<Map<String, Object>> ();

        String titleName = "";
        String titleExpertName = "";
        String titleName338 = "";
        String titleExpertName338 = "企业名称,车辆型号,车辆名称,品牌,批次,参数编号,参数名称,参数值";
        String titleName339 = "QY_ID,CPXH,CPMC,CPSB,PC,SEQ,CNAME,ITEM_VLAUE";
        String titleExpertName339 = "企业名称,车辆型号,车辆名称,品牌,批次,参数编号,参数名称,参数值";

        // 获取模板中表头字段
        List<Map<String, Object>> mbTitleList = mbDao.findMbInfoById (mbid);

        if (mbTitleList == null || mbTitleList.size () == 0) {
            throw new AdcDaBaseException ("该模板信息不存在,请联系管理员！");
        }

        // 字段名
        String defaultTitleName338 = "QYMC,CPXH,CPMC,CPSB,PC,";
        String defaultTitleName339 = "QY_ID,CPXH,CPMC,CPSB,PC,CNAME,ITEM_VLAUE,SEQ ";

        StringBuffer nameBuffer338 = new StringBuffer ().append (" SELECT  ").append (defaultTitleName338);
        StringBuffer nameBuffer339 = new StringBuffer ().append (" SELECT  ").append (defaultTitleName339);
        StringBuffer nameBuffer = new StringBuffer ().append (" SELECT ");

        // 整车和底盘情况
        if (!"BA".equals ((String) mbTitleList.get (0).get ("TYPE"))) {
            Map map = (Map) mbTitleList.get (0);
            String type = (String) map.get ("TYPE");
            String value = (String) map.get ("ZKPARAMVALUE");
            nameBuffer.append (value);
            titleName = value;
            titleExpertName = (String) map.get ("PARAMVALUE");

            logger.info ("******nameBuffer********" + nameBuffer);
            logger.info ("******titleName********" + titleName);
            logger.info ("******titleExpertName********" + titleExpertName);

            if ("ZC".equals (type)) {
                nameBuffer.append (" FROM retrieval.clcp_zk WHERE 1=1 and (产品号,车辆型号,批次) in (");
            } else if ("DP".equals (type)) {
                nameBuffer.append (" FROM retrieval.chpdpk_zk WHERE 1=1 and (产品号,底盘型号,批次) in (");
            }

            // 追加检索条件
            StringBuffer sqlBuffer = new StringBuffer ();
            for (Map<String, Object> resultMap : dataList) {
                String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
                String cph = StringUtils.defaultString ((String) resultMap.get ("CPH"));
                String clxh = StringUtils.defaultString ((String) resultMap.get ("CLXH"));
                sqlBuffer.append (" SELECT '" + cph + "' ,'" + clxh + "' , '" + pc + "'  FROM DUAL ");
                sqlBuffer.append (" UNION ");
            }
            int lastCommaIndexInName = sqlBuffer.lastIndexOf ("UNION");
            sqlBuffer.replace (lastCommaIndexInName, lastCommaIndexInName + 5, "");
            sqlBuffer.append (") ");
            nameBuffer.append (sqlBuffer);

            // 获取按模板导出的数据源
            logger.info ("******nameBuffer********" + nameBuffer.toString ());
            List<Map<String, Object>> mbList = mbDao.findZkBySql (nameBuffer.toString ());

            titleList = Arrays.asList (titleName.split (","));
            titleExpertList = Arrays.asList (titleExpertName.split (","));

            if (mbList == null || mbList.size () == 0) {
                throw new AdcDaBaseException ("您选择的参数未在模板中，请确认是否已上传公告有效参数表！！");
            }

            for (Map<String, Object> resultMap : mbList) {

                List<String> putList = mapTransitionList (resultMap, titleList);
                resultList.add (putList);
            }

            if (!checkData) {
                String fileName = "申报产品导出文件" + new SimpleDateFormat ("yyyyMMdd").format (new Date ()) + ".xlsx";
                ExcelUtils.uploadExcelAboutUser (response, fileName, titleExpertList, resultList);
            }

            // 备案参数情况
        } else {

            // 区分批次是338以前还是338以后，还采用不同的表查询
            for (Map<String, Object> resultMap : dataList) {
                String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
                if (pc.compareTo ("338") <= 0) {
                    dataList338.add (resultMap);
                } else {
                    dataList339.add (resultMap);
                }
            }

            Map map = (Map) mbTitleList.get (0);
            String type = (String) map.get ("TYPE");
            String zkValue = (String) map.get ("ZKPARAMVALUE");
            String paramValue = (String) map.get ("PARAMVALUE");

            titleName338 = zkValue;

            // 先获取338及以前数据
            if (dataList338.size () >= 1) {
                nameBuffer338.append (zkValue);
                nameBuffer338.append (" FROM GGBAK.QC_ALL_BACS_NEW WHERE 1=1 and (CP_ID, PC) in (");
                // 追加检索条件
                StringBuffer sqlBuffer338 = new StringBuffer ();
                for (Map<String, Object> resultMap : dataList338) {
                    String cpno = StringUtils.defaultString ((String) resultMap.get ("CPNO"));
                    String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
                    sqlBuffer338.append (" SELECT '" + cpno + "' , '" + pc + "'  FROM DUAL ");
                    sqlBuffer338.append (" UNION ");
                }
                int lastCommaIndexInName = sqlBuffer338.lastIndexOf ("UNION");
                sqlBuffer338.replace (lastCommaIndexInName, lastCommaIndexInName + 5, "");
                sqlBuffer338.append (") ");
                nameBuffer338.append (sqlBuffer338);

                // 获取按模板导出的数据源
                logger.info ("******nameBuffer338********" + nameBuffer338.toString ());

                List<Map<String, Object>> mbList338 = mbDao.findZkBySql (nameBuffer338.toString ());

                titleList = Arrays.asList (titleName338.split (","));
                titleExpertList = Arrays.asList (titleExpertName338.split (","));

                // 获取备案参数的KEY,VALUE
                Map<String, String> baParamsMap = getParamsMap ("BA");

                Map<String, String> baSeqParamsMap = getSeqParamsMap(true);

                for (Map<String, Object> resultMap : mbList338) {
                    List<List<String>> putList = mapTransitionList338 (resultMap, titleList, baParamsMap, baSeqParamsMap);
                    resultList338.addAll (putList);
                }
            }

            // 再获取339及以后数据
            if (dataList339.size () >= 1) {
                nameBuffer339.append ("   FROM NERDS.GG_DATA_ZRIN a, NERDS.GG_DATA_DETAIL b, NERDS.BACS_MBXM m ");
                nameBuffer339.append ("  WHERE a.id = b.gg_id and b.cname = m.NAME ");
                nameBuffer339.append ("    and confirm = '1' and b.item_vlaue is not null ");
                nameBuffer339.append ("    and (a.qy_id, a.cpxh, a.cpmc, a.pc) in ( ");

                // 追加检索条件
                StringBuffer sqlBuffer339 = new StringBuffer ();
                String qymc = "";
                for (Map<String, Object> resultMap : dataList339) {
                    qymc = StringUtils.defaultString ((String) resultMap.get ("QYMC"));
                    String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
                    String cpmc = StringUtils.defaultString ((String) resultMap.get ("CLMC"));
                    String qy_id = StringUtils.defaultString ((String) resultMap.get ("QY_ID"));
                    String cpxh = StringUtils.defaultString ((String) resultMap.get ("CLXH"));
                    sqlBuffer339.append (" SELECT '" + qy_id + "' ,'" + cpxh + "' ,'" + cpmc + "' , '" + pc + "'  FROM DUAL ");
                    sqlBuffer339.append (" UNION ");
                }
                int lastCommaIndexInName = sqlBuffer339.lastIndexOf ("UNION");
                sqlBuffer339.replace (lastCommaIndexInName, lastCommaIndexInName + 5, "");
                sqlBuffer339.append (") ");
                sqlBuffer339.append ("ORDER BY TO_NUMBER(m.ID) ");
                nameBuffer339.append (sqlBuffer339);

                // 获取按模板导出的数据源
                logger.info ("******nameBuffer339********" + nameBuffer339.toString ());
                List<Map<String, Object>> mbList339 = mbDao.findZkBySql (nameBuffer339.toString ());

                titleList = Arrays.asList (titleName339.split (","));
                titleExpertList = Arrays.asList (titleExpertName339.split (","));

                Map<String, String> baSeqParamsMap = getSeqParamsMap(false);

                for (Map<String, Object> resultMap : mbList339) {

                    List<String> putList = mapTransitionList339 (resultMap, titleList, baSeqParamsMap);
                    if (putList.size () >= 1) {
                        resultList339.add (putList);
                    }
                }

            }

            resultList.addAll (resultList338);
            resultList.addAll (resultList339);

            if (resultList == null || resultList.size () == 0) {
                throw new AdcDaBaseException ("您选择的参数未在模板中，请确认是否已上传公告有效参数表！！");
            }

            if (!checkData) {
                String fileName = "申报产品导出文件" + new SimpleDateFormat ("yyyyMMdd").format (new Date ()) + ".xlsx";
                ExcelUtils.uploadExcelAboutUser (response, fileName, titleExpertList, resultList);
            }
        }
    }

    private Map<String, String> getSeqParamsMap(boolean flg) {
        Map<String, String> paramsMap = new HashMap<> ();
        List<MbxmEO> paramsList = mbDao.queryBaxmList ();
        if (flg) {
            // 338批以前根据备案参数英文名称获取SEQ
            for (MbxmEO xm : paramsList) {
                paramsMap.put (xm.getZkName (), xm.getSeq ());
            }
        } else {
            // 338批以后根据备案参数中文名称获取SEQ
            for (MbxmEO xm : paramsList) {
                paramsMap.put (xm.getName (), xm.getSeq ());
            }
        }
        return paramsMap;
    }

    private List<String> mapTransitionList339(Map<String, Object> resultMap, List<String> titleList, Map<String, String> baSeqParamsMap) {
        // 每行数据
        List<String> list = new ArrayList ();

        for (String title : titleList) {
            if ("TYPE".equals (title)) {
                list.add ("备案参数");
            } else {
                list.add (resultMap.get (title) == null ? "" : resultMap.get (title).toString ());
            }
        }
        return list;
    }

    private Map<String, String> getParamsMap(String type) {
        Map<String, String> paramsMap = new HashMap<> ();
        List<MbxmEO> paramsList = mbDao.queryMbxmList (type);
        for (MbxmEO xm : paramsList) {
            paramsMap.put (xm.getZkName (), xm.getName ());
        }
        return paramsMap;
    }

    private List<List<String>> mapTransitionList338(Map<String, Object> resultMap, List<String> titleList, Map<String, String> baParamsMap,
            Map<String, String> baSeqParamsMap) {

        // 每行数据
        List<List<String>> putList = new ArrayList ();
        for (String title : titleList) {
            List<String> list = new ArrayList ();
            for (String key : expertDefault.keySet ()) {
                list.add (resultMap.get (key) == null ? "" : resultMap.get (key).toString ());
            }
            // 参数编号
            list.add (baSeqParamsMap.get (title));
            list.add (baParamsMap.get (title));
            list.add (resultMap.get (title) == null ? "" : resultMap.get (title).toString ());
            putList.add (list);
        }

        return putList;
    }

    private List<List<String>> mapTransitionListNew(Map<String, Object> resultMap, List<String> zkColumnNameList, Map<String, String> paramsMap,
            String type) {

        // 每行数据
        List<List<String>> putList = new ArrayList ();
        for (String title : zkColumnNameList) {
            List<String> list = new ArrayList ();
            for (String key : expertDefault.keySet ()) {
                list.add (resultMap.get (key) == null ? "" : resultMap.get (key).toString ());
            }
            if ("ZC".equals (type)) {
                list.add ("公告参数(整车)");
            } else if ("DP".equals (type)) {
                list.add ("公告参数(底盘)");
            } else if ("BA".equals (type)) {
                list.add ("备案参数");
            }
            list.add (paramsMap.get (title));
            list.add (resultMap.get (title) == null ? "" : resultMap.get (title).toString ());
            putList.add (list);
        }

        return putList;
    }

    private List<String> mapTransitionList(Map<String, Object> map, List<String> titleList) {
        List<String> list = new ArrayList ();
        // 编辑titleList 按顺序获取相应信息
        for (String title : titleList) {
            list.add (map.get (title) == null ? "" : map.get (title).toString ());
        }

        return list;
    }

    public Map<String, Object> findListbyParams(Map<String, Object> map) {

        Map<String, Object> paramsMap = new HashMap<String, Object> ();
        String type = "ZC";

        List<Map<String, Object>> dataList = (List<Map<String, Object>>) map.get ("selectedrows");

        if ("1".equals (dataList.get (0).get ("TYPE").toString ())) {
            type = "ZC";
        } else if ("2".equals (dataList.get (0).get ("TYPE").toString ())) {
            type = "DP";
        }

        StringBuffer nameBufferZc = new StringBuffer ().append (" SELECT ");
        StringBuffer nameBufferDp = new StringBuffer ().append (" SELECT ");
        // 追加检索条件
        StringBuffer sqlBuffer = new StringBuffer ();

        if ("ZC".equals (type)) {
            setZcTitle (nameBufferZc, "ZC");
            int lastCommaIndexInName = nameBufferZc.lastIndexOf (",");
            nameBufferZc.replace (lastCommaIndexInName, lastCommaIndexInName + 1, "");
            nameBufferZc.append (" FROM retrieval.clcp_zk WHERE 1=1 and (产品号,车辆型号,批次) in (");
        } else {
            setZcTitle (nameBufferDp, "DP");
            int lastCommaIndexInName = nameBufferDp.lastIndexOf (",");
            nameBufferDp.replace (lastCommaIndexInName, lastCommaIndexInName + 1, "");
            nameBufferDp.append (" FROM retrieval.chpdpk_zk WHERE 1=1 and (产品号,底盘型号,批次) in (");
        }

        for (Map<String, Object> resultMap : dataList) {
            String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
            String cph = StringUtils.defaultString ((String) resultMap.get ("CPH"));
            String clxh = StringUtils.defaultString ((String) resultMap.get ("CLXH"));
            sqlBuffer.append (" SELECT '" + cph + "' ,'" + clxh + "' , '" + pc + "'  FROM DUAL ");
            sqlBuffer.append (" UNION ");
        }
        int lastCommaIndexInName = sqlBuffer.lastIndexOf ("UNION");
        sqlBuffer.replace (lastCommaIndexInName, lastCommaIndexInName + 5, "");
        sqlBuffer.append (") ");

        if ("ZC".equals (type)) {
            // 获取按整车导出的数据源
            nameBufferZc.append (sqlBuffer);
            logger.info ("******nameBufferZc********" + nameBufferZc.toString ());
            List<Map<String, Object>> mbZcList = mbDao.findZkBySql (nameBufferZc.toString ());
            paramsMap.put ("params", mbZcList);
            paramsMap.put ("type", "ZC");

            // 增加标记位
            Map<String, Object> addMap = new HashMap<> ();

            for (Map.Entry<String, Object> entry : mbZcList.get (0).entrySet ()) {
                String mapKey = entry.getKey ();
                addMap.put (mapKey, '1');
                System.out.println ("mapKey:" + mapKey);
                String value = "";

                for (int j = 0; j < mbZcList.size (); j++) {
                    String itemValue = mbZcList.get (j).get (mapKey) == null ? "" : mbZcList.get (j).get (mapKey).toString ();

                    if (j == 0) {
                        value = itemValue;
                    } else {
                        if (!value.contains (itemValue)) {
                            addMap.put (mapKey, '0');
                            break;
                        }
                    }
                }
            }

            mbZcList.add (addMap);

        } else {
            // 获取按底盘导出的数据源
            nameBufferDp.append (sqlBuffer);
            logger.info ("******nameBufferDp********" + nameBufferDp.toString ());
            List<Map<String, Object>> mbDpList = mbDao.findZkBySql (nameBufferDp.toString ());
            paramsMap.put ("params", mbDpList);
            paramsMap.put ("type", "DP");

            // 增加标记位
            Map<String, Object> addMap = new HashMap<> ();

            for (Map.Entry<String, Object> entry : mbDpList.get (0).entrySet ()) {
                String mapKey = entry.getKey ();
                addMap.put (mapKey, '1');
                System.out.println ("mapKey:" + mapKey);
                String value = "";

                for (int j = 0; j < mbDpList.size (); j++) {
                    String itemValue = mbDpList.get (j).get (mapKey) == null ? "" : mbDpList.get (j).get (mapKey).toString ();

                    if (j == 0) {
                        value = itemValue;
                    } else {
                        if (!value.contains (itemValue)) {
                            addMap.put (mapKey, '0');
                            break;
                        }
                    }
                }
            }

            mbDpList.add (addMap);
        }

        return paramsMap;
    }

    private void setZcTitle(StringBuffer sql, String type) {
        List<MbxmEO> paramsList = mbDao.queryMbxmList (type);
        for (MbxmEO xm : paramsList) {
            sql.append ("        " + xm.getZkName () + ", ");
        }
    }

    public void exportParamsExcel(Map<String, Object> selectlist, HttpServletResponse response) {

        String typeParam = "ZC";
        List<Map<String, Object>> dataList = (List<Map<String, Object>>) selectlist.get ("selectedrows");
        if ("1".equals (dataList.get (0).get ("TYPE").toString ())) {
            typeParam = "ZC";
        } else if ("2".equals (dataList.get (0).get ("TYPE").toString ())) {
            typeParam = "DP";
        }

        List<List<String>> resultList = new ArrayList<> ();
        List<String> titleList = new ArrayList<> ();
        List<String> titleExpertList = new ArrayList<> ();
        String titleName = "";
        String titleExpertName = "";

        List<Map<String, Object>> mbTitleList;

        // 获取模板中表头字段
        if ("ZC".equals (typeParam)) {
            mbTitleList = mbDao.findMbInfoById ("1234567890ZC");
        } else {
            mbTitleList = mbDao.findMbInfoById ("1234567890DP");
        }

        // 字段名
        StringBuffer nameBuffer = new StringBuffer ().append (" SELECT ");

        if (mbTitleList != null) {
            Map map = (Map) mbTitleList.get (0);
            String type = (String) map.get ("TYPE");
            String value = (String) map.get ("ZKPARAMVALUE");
            nameBuffer.append (value);
            titleName = value;
            titleExpertName = (String) map.get ("PARAMVALUE");

            logger.info ("******nameBuffer********" + nameBuffer);
            logger.info ("******titleName********" + titleName);
            logger.info ("******titleExpertName********" + titleExpertName);

            if ("ZC".equals (type)) {
                nameBuffer.append (" FROM retrieval.clcp_zk WHERE 1=1 and (产品号,车辆型号,批次) in (");
            } else if ("DP".equals (type)) {
                nameBuffer.append (" FROM retrieval.chpdpk_zk WHERE 1=1 and (产品号,底盘型号,批次) in (");
            }

            // 追加检索条件
            StringBuffer sqlBuffer = new StringBuffer ();
            for (Map<String, Object> resultMap : dataList) {
                String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
                String cph = StringUtils.defaultString ((String) resultMap.get ("CPH"));
                String clxh = StringUtils.defaultString ((String) resultMap.get ("CLXH"));
                sqlBuffer.append (" SELECT '" + cph + "' ,'" + clxh + "' , '" + pc + "'  FROM DUAL ");
                sqlBuffer.append (" UNION ");
            }
            int lastCommaIndexInName = sqlBuffer.lastIndexOf ("UNION");
            sqlBuffer.replace (lastCommaIndexInName, lastCommaIndexInName + 5, "");
            sqlBuffer.append (") ");
            nameBuffer.append (sqlBuffer);

            // 获取按模板导出的数据源
            logger.info ("******nameBuffer********" + nameBuffer.toString ());
            List<Map<String, Object>> mbList = mbDao.findZkBySql (nameBuffer.toString ());

            titleList = Arrays.asList (titleName.split (","));
            titleExpertList = Arrays.asList (titleExpertName.split (","));

            for (Map<String, Object> resultMap : mbList) {
                List<String> putList = mapTransitionList (resultMap, titleList);
                resultList.add (putList);
            }
        } else {
            throw new AdcDaBaseException ("请先选择模板信息！");
        }

        if (mbTitleList != null) {
            String fileName = "导出参数比对详细信息" + new SimpleDateFormat ("yyyyMMdd").format (new Date ()) + ".xlsx";
            ExcelUtils.uploadExcelAboutUser (response, fileName, titleExpertList, resultList);
        }
    }

    public Map<String, Object> getReportCnt(String qymc, String origin) {
        return mbDao.getReportCnt (qymc, origin);
    }

    public void exportExcelNew(Map<String, Object> map, String qyid, String mbname, HttpServletResponse response, boolean checkData) {
        List<List<String>> resultList = new ArrayList<> ();

        List<Map<String, Object>> dataList = (List<Map<String, Object>>) map.get ("selectedrows");

        // 获取模板中表头字段
        List<Map<String, Object>> mbTitleList = mbDao.findMbListByQyid (qyid, mbname);

        // 获取备案参数的KEY,VALUE
        Map<String, String> zcParamsMap = getParamsMap ("ZC");
        Map<String, String> dpParamsMap = getParamsMap ("DP");
        Map<String, String> baParamsMap = getParamsMap ("BA");

        for (int i = 0; i < dataList.size (); i++) {
            Map<String, Object> selectedMap = dataList.get (i);
            // 获取每一行数据的excel组合后数据信息
            List<List<String>> itemList = getExportExcel (selectedMap, mbTitleList, zcParamsMap, dpParamsMap, baParamsMap);
            resultList.addAll (itemList);
        }

        if (resultList == null || resultList.size () == 0) {
            throw new AdcDaBaseException ("您选择的参数未在模板中，请确认是否已上传公告有效参数表！");
        }

        if (!checkData) {
            String fileName = "申报产品导出文件" + new SimpleDateFormat ("yyyyMMdd").format (new Date ()) + ".xlsx";
            String titleExpertName = "企业名称,车辆型号,车辆名称,品牌,批次,参数类别,参数名称,参数值";
            List<String> titleExpertList = new ArrayList<> ();
            titleExpertList = Arrays.asList (titleExpertName.split (","));
            ExcelUtils.uploadExcelAboutUser (response, fileName, titleExpertList, resultList);
        }

    }

    private List<List<String>> getExportExcel(Map<String, Object> selectedMap, List<Map<String, Object>> typeList,
            Map<String, String> zcParamsMap, Map<String, String> dpParamsMap, Map<String, String> baParamsMap) {
        List<List<String>> resultList = new ArrayList<> ();

        List<List<String>> resultListZc = new ArrayList<> ();
        List<List<String>> resultListDp = new ArrayList<> ();
        List<List<String>> resultListBa = new ArrayList<> ();

        for (int i = 0; i < typeList.size (); i++) {
            Map<String, Object> typeMap = typeList.get (i);

            if ("ZC".equals ((String) typeMap.get ("TYPE"))) {
                resultListZc = getExportZcValues (selectedMap, typeMap, zcParamsMap);
            } else if ("DP".equals ((String) typeMap.get ("TYPE"))) {
                resultListDp = getExportDpValues (selectedMap, typeMap, dpParamsMap);
            } else if ("BA".equals ((String) typeMap.get ("TYPE"))) {
                resultListBa = getExportBaValues (selectedMap, typeMap, baParamsMap);
            }
        }

        if (resultListZc.size () >= 1) {
            resultList.addAll (resultListZc);
        }

        if (resultListDp.size () >= 1) {
            resultList.addAll (resultListDp);
        }

        if (resultListBa.size () >= 1) {
            resultList.addAll (resultListBa);
        }

        return resultList;
    }

    private List<List<String>> getExportZcValues(Map<String, Object> map, Map<String, Object> typeMap, Map<String, String> zcParamsMap) {
        List<List<String>> resultList = new ArrayList<> ();

        // 字段名
        String defaultTitleName = "企业名称 as qymc,车辆型号 as cpxh,车辆名称 as cpmc,产品商标 as cpsb,批次 as pc,";

        String zkColumnName = (String) typeMap.get ("ZKPARAMVALUE");
        String expertCName = (String) typeMap.get ("PARAMVALUE");
        String pc = StringUtils.defaultString ((String) map.get ("PC"));
        String cph = StringUtils.defaultString ((String) map.get ("CPH"));
        String clxh = StringUtils.defaultString ((String) map.get ("CLXH"));

        StringBuffer nameBuffer = new StringBuffer ().append (" SELECT ").append (defaultTitleName).append (zkColumnName);
        nameBuffer.append (" FROM retrieval.clcp_zk WHERE 1=1 and (产品号,车辆型号,批次) in (");
        nameBuffer.append (" SELECT '" + cph + "' ,'" + clxh + "' , '" + pc + "'  FROM DUAL )");

        logger.info ("******nameBuffer********" + nameBuffer);
        logger.info ("******expertCName********" + expertCName);

        List<Map<String, Object>> mbList = mbDao.findZkBySql (nameBuffer.toString ());

        if (mbList == null || mbList.size () == 0) {
            throw new AdcDaBaseException ("未查询到公告整车参数信息:车辆型号： " + clxh + " 批次：" + pc);
        }

        List<String> zkColumnNameList = Arrays.asList (zkColumnName.split (","));

        for (Map<String, Object> resultMap : mbList) {
            List<List<String>> putList = mapTransitionListNew (resultMap, zkColumnNameList, zcParamsMap, "ZC");
            resultList.addAll (putList);
        }
        return resultList;
    }

    private List<List<String>> getExportDpValues(Map<String, Object> map, Map<String, Object> typeMap, Map<String, String> dpParamsMap) {
        List<List<String>> resultList = new ArrayList<> ();

        // 字段名
        String defaultTitleName = "企业名称 as qymc,底盘型号 as cpxh,产品名称 as cpmc,产品商标 as cpsb,批次 as pc,";

        String zkColumnName = (String) typeMap.get ("ZKPARAMVALUE");
        String expertCName = (String) typeMap.get ("PARAMVALUE");
        String pc = StringUtils.defaultString ((String) map.get ("PC"));
        String cph = StringUtils.defaultString ((String) map.get ("CPH"));
        String clxh = StringUtils.defaultString ((String) map.get ("CLXH"));

        StringBuffer nameBuffer = new StringBuffer ().append (" SELECT ").append (defaultTitleName).append (zkColumnName);
        nameBuffer.append (" FROM retrieval.chpdpk_zk WHERE 1=1 and (产品号,底盘型号,批次) in (");
        nameBuffer.append (" SELECT '" + cph + "' ,'" + clxh + "' , '" + pc + "'  FROM DUAL )");

        logger.info ("******nameBuffer********" + nameBuffer);
        logger.info ("******expertCName********" + expertCName);

        List<Map<String, Object>> mbList = mbDao.findZkBySql (nameBuffer.toString ());

        if (mbList == null || mbList.size () == 0) {
            throw new AdcDaBaseException ("未查询到公告底盘参数信息:底盘型号： " + clxh + " 批次：" + pc);
        }

        List<String> zkColumnNameList = Arrays.asList (zkColumnName.split (","));

        for (Map<String, Object> resultMap : mbList) {
            List<List<String>> putList = mapTransitionListNew (resultMap, zkColumnNameList, dpParamsMap, "DP");
            resultList.addAll (putList);
        }
        return resultList;
    }

    private List<List<String>> getExportBaValues(Map<String, Object> selectedMap, Map<String, Object> typeMap, Map<String, String> baParamsMap) {
        // 字段名
        String defaultTitleName338 = "QYMC,CPXH,CPMC,CPSB,PC,";
        String defaultTitleName339 = "(SELECT name FROM retrieval.ret_users where username=a.qy_id and rownum=1) as QYMC,CPXH,CPMC,CPSB,PC,CNAME,ITEM_VLAUE ";

        List<String> titleList = new ArrayList<> ();
        List<String> titleExpertList = new ArrayList<> ();

        List<List<String>> resultList = new ArrayList<> ();

        String titleExpertName = "企业名称,车辆型号,车辆名称,品牌,批次,参数类别,参数名称,参数值";

        String titleName339 = "QYMC,CPXH,CPMC,CPSB,PC,TYPE,CNAME,ITEM_VLAUE";

        StringBuffer nameBuffer338 = new StringBuffer ().append (" SELECT  ").append (defaultTitleName338);
        StringBuffer nameBuffer339 = new StringBuffer ().append (" SELECT  ").append (defaultTitleName339);

        String zkValue = (String) typeMap.get ("ZKPARAMVALUE");
        String paramValue = (String) typeMap.get ("PARAMVALUE");
        String cpno = StringUtils.defaultString ((String) selectedMap.get ("CPNO"));
        String pc = StringUtils.defaultString ((String) selectedMap.get ("PC"));

        String qymc = StringUtils.defaultString ((String) selectedMap.get ("QYMC"));
        String cpmc = StringUtils.defaultString ((String) selectedMap.get ("CLMC"));
        String qy_id = StringUtils.defaultString ((String) selectedMap.get ("QY_ID"));
        String cpxh = StringUtils.defaultString ((String) selectedMap.get ("CLXH"));

        // 区分批次是338以前还是338以后，还采用不同的表查询
        if (StringUtils.defaultString ((String) selectedMap.get ("PC")).compareTo ("338") <= 0) {
            nameBuffer338.append (zkValue);
            nameBuffer338.append (" FROM GGBAK.QC_ALL_BACS_NEW WHERE 1=1 and (CP_ID, PC) in (");
            nameBuffer338.append (" SELECT '" + cpno + "' , '" + pc + "'  FROM DUAL) ");

            // 获取按模板导出的数据源
            logger.info ("******nameBuffer338********" + nameBuffer338.toString ());

            List<Map<String, Object>> mbList338 = mbDao.findZkBySql (nameBuffer338.toString ());

            titleList = Arrays.asList (zkValue.split (","));
            titleExpertList = Arrays.asList (titleExpertName.split (","));

            for (Map<String, Object> resultMap : mbList338) {
                List<List<String>> putList = mapTransitionListNew (resultMap, titleList, baParamsMap, "BA");
                resultList.addAll (putList);
            }
        } else {
            nameBuffer339.append ("   FROM NERDS.GG_DATA_ZRIN a, NERDS.GG_DATA_DETAIL b ");
            nameBuffer339.append ("  WHERE a.id = b.gg_id ");
            nameBuffer339.append ("    and confirm = '1' and b.item_vlaue is not null ");
            nameBuffer339.append ("    and (a.qy_id, a.cpxh, a.cpmc, a.pc) in ( ");

            nameBuffer339.append (" SELECT '" + qy_id + "' ,'" + cpxh + "' ,'" + cpmc + "' , '" + pc + "'  FROM DUAL) ");

            // 追加检测范围

            String[] paramVal = paramValue.split (",");
            StringBuffer comma = new StringBuffer ();

            for (int i = 0; i < paramVal.length; i++) {
                if (i == 0) {
                    comma.append ("'").append (paramVal[i]).append ("'");
                } else {
                    comma.append (",").append ("'").append (paramVal[i]).append ("'");
                }
            }
            nameBuffer339.append (" and cname in (").append (comma.toString ()).append (") ");

            // 获取按模板导出的数据源
            logger.info ("******nameBuffer339********" + nameBuffer339.toString ());

            List<Map<String, Object>> mbList339 = mbDao.findZkBySql (nameBuffer339.toString ());

            if (mbList339 == null || mbList339.size () == 0) {
                throw new AdcDaBaseException ("您选择的产品参数未在模板中，请查询后重新选择:车辆型号： " + cpxh + " 批次：" + pc);
            }

            titleList = Arrays.asList (titleName339.split (","));
            titleExpertList = Arrays.asList (titleExpertName.split (","));

            Map<String, String> baSeqParamsMap = getSeqParamsMap(false);

            for (Map<String, Object> resultMap : mbList339) {
                List<String> putList = mapTransitionList339 (resultMap, titleList, baSeqParamsMap);
                if (putList.size () >= 1) {
                    resultList.add (putList);
                }
            }
        }
        return resultList;
    }

    @Transactional
    public int delete(String mbid) {
        return mbDao.delete(mbid);
    }

    public void exportParamsExcelNew(Map<String, Object> pageMap, String type, HttpServletResponse response) {
        // 每行数据
        List<List<String>> resultList = new ArrayList<> ();
        // 标题列
        List<String> titleList = new ArrayList<> ();
        titleList.add ("参数名称");

        List<Map<String, Object>> expertList = (List<Map<String, Object>>) pageMap.get ("params");

        // 去掉标志位
        int expertCnt = expertList.size () - 1;
        for (Map.Entry<String, Object> entry : expertList.get (0).entrySet ()) {
            String mapKey = entry.getKey ();
            System.out.println ("mapKey:" + mapKey);
            String value = "";

            // type 1 ：对比不同项 0：全量参数 、 lastItemValue 1：相同 0：不同
            String lastItemValue = expertList.get (expertCnt).get (mapKey) == null ? "" : expertList.get (expertCnt).get (mapKey).toString ();
            if ("1".equals (type) && "1".equals (lastItemValue)) {
                continue;
            }

            if ("产品号".equals (mapKey)) {
                for (int j = 0; j < expertCnt; j++) {
                    String itemValue = expertList.get (j).get (mapKey) == null ? "" : expertList.get (j).get (mapKey).toString ();
                    titleList.add (itemValue);
                }
            }

            List<String> list = new ArrayList ();
            list.add (mapKey);
            for (int j = 0; j < expertCnt; j++) {
                String itemValue = expertList.get (j).get (mapKey) == null ? "" : expertList.get (j).get (mapKey).toString ();
                list.add (itemValue);
            }
            resultList.add (list);
        }

        String fileName = "导出参数比对详细信息" + new SimpleDateFormat ("yyyyMMdd").format (new Date ()) + ".xlsx";
        ExcelUtils.uploadExcelAboutUser (response, fileName, titleList, resultList);
    }

    public void importExcel(List<NerdsInfoEO> result) {
        mbDao.importExcel(result);
    }

    public List<MbxmEO> showBacsXmList(Map<String, Object> selectlist, String mbid) {

        List<Map<String, Object>> dataList = (List<Map<String, Object>>) selectlist.get ("selectedrows");
        List<MbxmEO> resultList = new ArrayList<> ();

        List<MbxmEO> resultList338 = new ArrayList<> ();
        List<MbxmEO> resultList339 = new ArrayList<> ();

        List<String> titleList = new ArrayList<> ();

        List<Map<String, Object>> dataList338 = new ArrayList<Map<String, Object>> ();
        List<Map<String, Object>> dataList339 = new ArrayList<Map<String, Object>> ();

        String titleName = "";
        String titleExpertName = "";
        String titleName338 = "";
        String titleName339 = "QY_ID,CPXH,CPMC,CPSB,PC,SEQ,CNAME,ITEM_VLAUE";

        // 获取模板中表头字段
        List<Map<String, Object>> mbTitleList = mbDao.findMbInfoById (mbid);

        if (mbTitleList == null || mbTitleList.size () == 0) {
            throw new AdcDaBaseException ("该模板信息不存在,请联系管理员！");
        }

        // 字段名
        String defaultTitleName338 = "QYMC,CPXH,CPMC,CPSB,PC,";
        String defaultTitleName339 = "QY_ID,CPXH,CPMC,CPSB,PC,CNAME,ITEM_VLAUE,SEQ ";

        StringBuffer nameBuffer338 = new StringBuffer ().append (" SELECT  ").append (defaultTitleName338);
        StringBuffer nameBuffer339 = new StringBuffer ().append (" SELECT  ").append (defaultTitleName339);
        StringBuffer nameBuffer = new StringBuffer ().append (" SELECT ");

        // 区分批次是338以前还是338以后，还采用不同的表查询
        for (Map<String, Object> resultMap : dataList) {
            String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
            if (pc.compareTo ("338") <= 0) {
                dataList338.add (resultMap);
            } else {
                dataList339.add (resultMap);
            }
        }

        Map map = (Map) mbTitleList.get (0);
        String type = (String) map.get ("TYPE");
        String zkValue = (String) map.get ("ZKPARAMVALUE");
        String paramValue = (String) map.get ("PARAMVALUE");

        titleName338 = zkValue;

        // 先获取338及以前数据
        if (dataList338.size () >= 1) {
            nameBuffer338.append (zkValue);
            nameBuffer338.append (" FROM GGBAK.QC_ALL_BACS_NEW WHERE 1=1 and (CP_ID, PC) in (");
            // 追加检索条件
            StringBuffer sqlBuffer338 = new StringBuffer ();
            for (Map<String, Object> resultMap : dataList338) {
                String cpno = StringUtils.defaultString ((String) resultMap.get ("CPNO"));
                String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
                sqlBuffer338.append (" SELECT '" + cpno + "' , '" + pc + "'  FROM DUAL ");
                sqlBuffer338.append (" UNION ");
            }
            int lastCommaIndexInName = sqlBuffer338.lastIndexOf ("UNION");
            sqlBuffer338.replace (lastCommaIndexInName, lastCommaIndexInName + 5, "");
            sqlBuffer338.append (") ");
            nameBuffer338.append (sqlBuffer338);

            // 获取按模板导出的数据源
            logger.info ("******nameBuffer338********" + nameBuffer338.toString ());

            List<Map<String, Object>> mbList338 = mbDao.findZkBySql (nameBuffer338.toString ());

            titleList = Arrays.asList (titleName338.split (","));

            // 获取备案参数的KEY,VALUE
            Map<String, String> baParamsMap = getParamsMap ("BA");

            Map<String, String> baSeqParamsMap = getSeqParamsMap (true);

            // 转成对象LIst
            for (Map<String, Object> resultMap : mbList338) {
                List<MbxmEO> putList = mapTransitionListShow338 (resultMap, titleList, baParamsMap, baSeqParamsMap);
                resultList338.addAll (putList);
            }
        }

        // 再获取339及以后数据
        if (dataList339.size () >= 1) {
            nameBuffer339.append ("   FROM NERDS.GG_DATA_ZRIN a, NERDS.GG_DATA_DETAIL b, NERDS.BACS_MBXM m ");
            nameBuffer339.append ("  WHERE a.id = b.gg_id and b.cname = m.NAME ");
            nameBuffer339.append ("    and confirm = '1' and b.item_vlaue is not null ");
            nameBuffer339.append ("    and (a.qy_id, a.cpxh, a.cpmc, a.pc) in ( ");

            // 追加检索条件
            StringBuffer sqlBuffer339 = new StringBuffer ();
            String qymc = "";
            for (Map<String, Object> resultMap : dataList339) {
                qymc = StringUtils.defaultString ((String) resultMap.get ("QYMC"));
                String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
                String cpmc = StringUtils.defaultString ((String) resultMap.get ("CLMC"));
                String qy_id = StringUtils.defaultString ((String) resultMap.get ("QY_ID"));
                String cpxh = StringUtils.defaultString ((String) resultMap.get ("CLXH"));
                sqlBuffer339.append (" SELECT '" + qy_id + "' ,'" + cpxh + "' ,'" + cpmc + "' , '" + pc + "'  FROM DUAL ");
                sqlBuffer339.append (" UNION ");
            }
            int lastCommaIndexInName = sqlBuffer339.lastIndexOf ("UNION");
            sqlBuffer339.replace (lastCommaIndexInName, lastCommaIndexInName + 5, "");
            sqlBuffer339.append (") ");
            sqlBuffer339.append ("ORDER BY TO_NUMBER(m.ID) ");
            nameBuffer339.append (sqlBuffer339);

            // 获取按模板导出的数据源
            logger.info ("******nameBuffer339********" + nameBuffer339.toString ());
            List<Map<String, Object>> mbList339 = mbDao.findZkBySql (nameBuffer339.toString ());

            for (Map<String, Object> resultMap : mbList339) {
                MbxmEO putList = mapTransitionListShow339 (resultMap);
                resultList339.add (putList);
            }

        }

        resultList.addAll (resultList338);
        resultList.addAll (resultList339);

        if (resultList == null || resultList.size () == 0) {
            throw new AdcDaBaseException ("您选择的参数未在模板中，请确认是否已上传公告有效参数表！！");
        }

        return resultList;

    }

    private MbxmEO mapTransitionListShow339(Map<String, Object> resultMap) {
        // 每行数据
        MbxmEO xm = new MbxmEO ();
        xm.setSeq (resultMap.get ("SEQ") == null ? "" : resultMap.get ("SEQ").toString ());
        xm.setName (resultMap.get ("CNAME") == null ? "" : resultMap.get ("CNAME").toString ());
        xm.setValue (resultMap.get ("ITEM_VLAUE") == null ? "" : resultMap.get ("ITEM_VLAUE").toString ());
        return xm;
    }

    private List<MbxmEO> mapTransitionListShow338(Map<String, Object> resultMap, List<String> titleList, Map<String, String> baParamsMap, Map<String, String> baSeqParamsMap) {
        // 每行数据
        List<MbxmEO> putList = new ArrayList ();
        for (String title : titleList) {
            MbxmEO xm = new MbxmEO();
            // 参数编号
            xm.setSeq (baSeqParamsMap.get (title));
            xm.setName (baParamsMap.get (title));
            xm.setValue (resultMap.get (title) == null ? "" : resultMap.get (title).toString ());
            putList.add (xm);
        }

        return putList;
    }

    public void checkExportGgParamsExcel(Map<String, Object> selectlist, HttpServletResponse response, boolean checkData) {

        List<Map<String, Object>> dataList = (List<Map<String, Object>>) selectlist.get ("selectedrows");
        List<List<String>> resultList = new ArrayList<> ();

        List<List<String>> resultList339 = new ArrayList<> ();

        List<String> titleList = new ArrayList<> ();
        List<String> titleExpertList = new ArrayList<> ();

        List<Map<String, Object>> dataList339 = new ArrayList<Map<String, Object>> ();

        String titleName = "";
        String titleExpertName = "";
        String titleName339 = "QY_ID,CPXH,CPMC,CPSB,PC,SEQ,CNAME,ITEM_VLAUE";
        String titleExpertName339 = "企业名称,车辆型号,车辆名称,品牌,批次,参数编号,参数名称,参数值";

        // 字段名
        String defaultTitleName339 = "QY_ID,CPXH,CPMC,CPSB,PC,CNAME,ITEM_VLAUE,SEQ ";

        StringBuffer nameBuffer339 = new StringBuffer ().append (" SELECT  ").append (defaultTitleName339);
        StringBuffer nameBuffer = new StringBuffer ().append (" SELECT ");

        // 区分批次是338以前还是338以后，还采用不同的表查询
        for (Map<String, Object> resultMap : dataList) {
            String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
            // 338批及以前的过滤掉
            if (pc.compareTo ("338") <= 0) {
            } else {
                dataList339.add (resultMap);
            }
        }


        List<String> resultCpxhs = new ArrayList<>();

        List<String> noResultCpxhs = new ArrayList<>();

        // 再获取339及以后数据
        if (dataList339.size () >= 1) {
            nameBuffer339.append ("   FROM NERDS.GG_DATA_ZRIN a, NERDS.GG_DATA_DETAIL b, NERDS.GGCSXM_ALL m ");
            nameBuffer339.append ("  WHERE a.id = b.gg_id and b.cname = m.NAME ");
            nameBuffer339.append ("    and confirm = '1' and b.item_vlaue is not null ");
            nameBuffer339.append ("    and (a.qy_id, a.cpxh, a.cpmc, a.pc) in ( ");

            // 追加检索条件
            StringBuffer sqlBuffer339 = new StringBuffer ();
            String qymc = "";
            for (Map<String, Object> resultMap : dataList339) {
                qymc = StringUtils.defaultString ((String) resultMap.get ("QYMC"));
                String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
                String cpmc = StringUtils.defaultString ((String) resultMap.get ("CLMC"));
                String qy_id = StringUtils.defaultString ((String) resultMap.get ("QY_ID"));
                String cpxh = StringUtils.defaultString ((String) resultMap.get ("CLXH"));
                sqlBuffer339.append (" SELECT '" + qy_id + "' ,'" + cpxh + "' ,'" + cpmc + "' , '" + pc + "'  FROM DUAL ");
                sqlBuffer339.append (" UNION ");
            }
            int lastCommaIndexInName = sqlBuffer339.lastIndexOf ("UNION");
            sqlBuffer339.replace (lastCommaIndexInName, lastCommaIndexInName + 5, "");
            sqlBuffer339.append (") ");
            sqlBuffer339.append ("ORDER BY QY_ID, CPXH, TYPE, TO_NUMBER(m.ID) ");
            nameBuffer339.append (sqlBuffer339);

            // 获取按模板导出的数据源
            logger.info ("******nameBuffer339********" + nameBuffer339.toString ());
            List<Map<String, Object>> mbList339 = mbDao.findZkBySql (nameBuffer339.toString ());

            titleList = Arrays.asList (titleName339.split (","));
            titleExpertList = Arrays.asList (titleExpertName339.split (","));

            Map<String, String> seqAllParamsMap = getSeqAllParamsMap(false);

            for (Map<String, Object> resultMap : mbList339) {

                // 获取已查询到车型信息
                resultCpxhs.add (StringUtils.defaultString ((String) resultMap.get ("CPXH")));

                List<String> putList = mapTransitionList339 (resultMap, titleList, seqAllParamsMap);
                if (putList.size () >= 1) {
                    resultList339.add (putList);
                }
            }

        }

        resultList.addAll (resultList339);

        for (Map<String, Object> dataMap : dataList339) {
            String clxh = StringUtils.defaultString ((String) dataMap.get ("CLXH"));
            if(!resultCpxhs.contains (clxh)){
                noResultCpxhs.add (clxh);
            }

        }

        if (noResultCpxhs.size () >= 1) {
            throw new AdcDaBaseException ("请先在企业云盘上传公告有效参数表!<br> 车辆型号:"+noResultCpxhs.toString ());
        }

        if (resultList == null || resultList.size () == 0) {
            throw new AdcDaBaseException ("请先在企业云盘上传公告有效参数表!");
        }

        if (!checkData) {
            String fileName = "下载公告参数" + new SimpleDateFormat ("yyyyMMdd").format (new Date ()) + ".xlsx";
            ExcelUtils.uploadExcelAboutUser (response, fileName, titleExpertList, resultList);
        }

    }

    private Map<String, String> getSeqAllParamsMap(boolean flg) {

        Map<String, String> paramsMap = new HashMap<> ();
        List<MbxmEO> paramsList = mbDao.queryGgxmList ();
        if (flg) {
            // 338批以前根据备案参数英文名称获取SEQ
            for (MbxmEO xm : paramsList) {
                paramsMap.put (xm.getZkName (), xm.getSeq ());
            }
        } else {
            // 338批以后根据备案参数中文名称获取SEQ
            for (MbxmEO xm : paramsList) {
                paramsMap.put (xm.getName (), xm.getSeq ());
            }
        }
        return paramsMap;
    }

    public void exportGgParamsExcel(Map<String, Object> selectlist, HttpServletResponse response) {

        // 导出每个产品的excel到服务器指定路径下的文件夹中

        List<Map<String, Object>> dataList = (List<Map<String, Object>>) selectlist.get ("selectedrows");
        List<List<String>> resultList = new ArrayList<> ();

        List<String> titleList = new ArrayList<> ();
        List<String> titleExpertList = new ArrayList<> ();

        List<Map<String, Object>> dataList339 = new ArrayList<Map<String, Object>> ();

        // 区分批次是338以前还是338以后，还采用不同的表查询
        for (Map<String, Object> resultMap : dataList) {
            String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
            // 338批及以前的过滤掉
            if (pc.compareTo ("338") <= 0) {
            } else {
                dataList339.add (resultMap);
            }
        }

        String s = UUID.randomUUID().toString().replace("-", "").toLowerCase();

        String filepath = PoiUtil.DIRECTORY + File.separator +  s + File.separator;
        File file =new File(filepath);

        List<String> filenames = new ArrayList<>();

        //如果文件夹不存在则创建
        if (!file .exists() && !file .isDirectory()) {
            file.mkdir();
        }

        // 再获取339及以后数据
        for (Map<String, Object> resultMap : dataList339) {

            List<List<String>> resultList339 = new ArrayList<> ();

            String titleName = "";
            String titleExpertName = "";
            String titleName339 = "QY_ID,CPXH,CPMC,CPSB,PC,SEQ,CNAME,ITEM_VLAUE";
            String titleExpertName339 = "企业名称,车辆型号,车辆名称,品牌,批次,参数编号,参数名称,参数值";

            // 字段名
            String defaultTitleName339 = "QY_ID,CPXH,CPMC,CPSB,PC,CNAME,ITEM_VLAUE,SEQ ";

            StringBuffer nameBuffer339 = new StringBuffer ().append (" SELECT  ").append (defaultTitleName339);
            StringBuffer nameBuffer = new StringBuffer ().append (" SELECT ");

            nameBuffer339.append ("   FROM NERDS.GG_DATA_ZRIN a, NERDS.GG_DATA_DETAIL b, NERDS.GGCSXM_ALL m ");
            nameBuffer339.append ("  WHERE a.id = b.gg_id and b.cname = m.NAME ");
            nameBuffer339.append ("    and confirm = '1' and b.item_vlaue is not null ");
            nameBuffer339.append ("    and (a.qy_id, a.cpxh, a.cpmc, a.pc) in ( ");

            // 追加检索条件
            StringBuffer sqlBuffer339 = new StringBuffer ();
            String qymc = "";
            qymc = StringUtils.defaultString ((String) resultMap.get ("QYMC"));
            String pc = StringUtils.defaultString ((String) resultMap.get ("PC"));
            String cpmc = StringUtils.defaultString ((String) resultMap.get ("CLMC"));
            String qy_id = StringUtils.defaultString ((String) resultMap.get ("QY_ID"));
            String cpxh = StringUtils.defaultString ((String) resultMap.get ("CLXH"));
            sqlBuffer339.append (" SELECT '" + qy_id + "' ,'" + cpxh + "' ,'" + cpmc + "' , '" + pc + "'  FROM DUAL ");
            sqlBuffer339.append (") ");
            sqlBuffer339.append ("ORDER BY QY_ID, CPXH, TYPE, TO_NUMBER(m.ID) ");
            nameBuffer339.append (sqlBuffer339);

            // 获取按模板导出的数据源
            logger.info ("******nameBuffer339********" + nameBuffer339.toString ());
            List<Map<String, Object>> mbList339 = mbDao.findZkBySql (nameBuffer339.toString ());

            titleList = Arrays.asList (titleName339.split (","));
            titleExpertList = Arrays.asList (titleExpertName339.split (","));

            Map<String, String> seqAllParamsMap = getSeqAllParamsMap(false);

            for (Map<String, Object> itemMap : mbList339) {

                // 过滤itemmap数据
                itemMapFilter(itemMap);

                // 获取已查询到车型信息
                List<String> putList = mapTransitionList339 (itemMap, titleList, seqAllParamsMap);
                if (putList.size () >= 1) {
                    resultList339.add (putList);
                }
            }

            String fileName = cpxh + "_" + cpmc + "_" + pc + ".xlsx";

            filenames.add (fileName);

            ExcelUtils.uploadExcelAboutUser (filepath + fileName, titleExpertList, resultList339);

        }

        // 压缩该文件夹下所有excel文件，输出给前端
        downloadExcels(response, filenames, filepath);
    }

    private void downloadExcels(HttpServletResponse response, List<String> filenames, String filepath) {

        //设置最终输出zip文件的目录+文件名
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy年MM月dd日HH时mm分ss秒");
        String zipFileName = formatter.format(new Date()) + ".zip";
        String strZipPath = PoiUtil.DIRECTORY + File.separator + zipFileName;

        ZipOutputStream zipStream = null;
        FileInputStream zipSource = null;
        BufferedInputStream bufferStream = null;
        URL url = null;
        HttpURLConnection httpUrl = null;

        File zipFile = new File(strZipPath);
        try {
            //构造最终压缩包的输出流
            zipStream = new ZipOutputStream(new FileOutputStream (zipFile));
            for (int i = 0; i < filenames.size (); i++) {
                //解码获取真实路径与文件名
                String realFileName = java.net.URLDecoder.decode(filenames.get (i), "UTF-8");
                String realFilePath = java.net.URLDecoder.decode(filepath, "UTF-8");

                logger.info("************realFileName****************"+realFileName);
                logger.info("************realFilePath****************"+realFilePath);

                File file = new File(realFilePath + realFileName);

                if (file.exists()) {
                    zipSource = new FileInputStream(file);//将需要压缩的文件格式化为输入流
                    /**
                     * 压缩条目不是具体独立的文件，而是压缩包文件列表中的列表项，称为条目，就像索引一样这里的name就是文件名,
                     * 文件名和之前的重复就会导致文件被覆盖
                     */
                    ZipEntry zipEntry = new ZipEntry(realFileName);//在压缩目录中文件的名字
                    zipStream.putNextEntry(zipEntry);//定位该压缩条目位置，开始写入文件到压缩包中
                    bufferStream = new BufferedInputStream (zipSource, 1024 * 10);
                    int read = 0;
                    byte[] buf = new byte[1024 * 10];
                    while ((read = bufferStream.read(buf, 0, 1024 * 10)) != -1) {
                        zipStream.write(buf, 0, read);
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            //关闭流
            try {
                if (null != bufferStream){
                    bufferStream.close();
                }
                if (null != zipStream) {
                    zipStream.flush();
                    zipStream.close();
                }
                if (null != zipSource) {
                    zipSource.close();
                }
                if (null != httpUrl){
                    httpUrl.disconnect();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        //判断系统压缩文件是否存在：true-把该压缩文件通过流输出给客户端后删除该压缩文件  false-未处理
        if (zipFile.exists()) {
            ZipUtil.downReport(response, zipFileName, strZipPath);
            zipFile.delete();
        }
    }

    @Transactional
    public int deleteByMbmc(String mbmc, String qyid) {
        return mbDao.deleteByMbmc(mbmc, qyid);

    }

    private void itemMapFilter(Map<String, Object> itemMap) {

        //燃料种类 {"name":"柴油","fuelType":"01","fuelCategory":["02"]} {"name":"","fuelType":"","fuelCategory":[]}
        if("燃料种类".equals (itemMap.get ("CNAME").toString ())){
            String item_value = StringUtils.defaultString ((String) itemMap.get ("ITEM_VLAUE"));
            setFilterValue (itemMap, item_value, "name", "fuelType");
        }

        //储能装置负极材料 {"selectValue":"CNZZDJZCF-六氟磷酸锂材料","inputValue":"","fileList":[]}
        if("储能装置电解质成分".equals (itemMap.get ("CNAME").toString ()) || "储能装置正极材料".equals (itemMap.get ("CNAME").toString ()) ||
                "储能装置负极材料".equals (itemMap.get ("CNAME").toString ())){
            String item_value = StringUtils.defaultString ((String) itemMap.get ("ITEM_VLAUE"));
            setFilterValue (itemMap, item_value, "selectValue", "inputValue");
        }
    }

    private void setFilterValue(Map<String, Object> itemMap, String item_value, String name, String fuelType) {
        if (item_value.contains (name) && item_value.contains (fuelType)) {
            String value = item_value.replaceAll ("\\{", "").replaceAll ("\\}", "").replaceAll ("\"","");
            String[] items = value.split (",");
            for (int i = 0; i < items.length; i++) {
                System.out.println ("items[i]:" + items[i]);
                if (items[i].contains (name)) {
                    String[] itemName = items[i].split (":");
                    if (itemName.length >= 2) {
                        itemMap.put ("ITEM_VLAUE", itemName[1]);
                        break;
                    }
                }
            }
        }
    }
}

