package com.adc.da.bs.param.service;

import com.adc.da.bs.param.dao.ParamDao;
import com.adc.da.bs.param.entity.SearchProductParams;
import com.adc.da.util.http.PageParam;
import com.adc.da.util.utils.RedisUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * 车型参数Service
 * zhong
 * 2018-3-14
 */
@Service
public class ParamService {

    @Autowired
    private ParamDao paramDao;

    @Autowired
    private RedisUtils redisUtils;

    /**
     * 获取审核列表
     *
     * @param qyid
     * @param rlzl
     * @param cpsb
     * @param qymc
     * @param
     * @return
     */
    public Map<String, Object> findMap(PageParam page, String pc, String qyid, String cpsb, String rlzl, String qymc) {
        Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> list = paramDao.findPage(page, pc, qyid, cpsb, rlzl, qymc);
        Long count = paramDao.findPageCount(page, pc, qyid, cpsb, rlzl, qymc);
        map.put("total", count);
        map.put("rows", list);
        return map;
    }

    public Map<String, Object> paramdetail(String cph, String type) {
        Map<String, Object> map = new HashMap<>();
        if ("1".equals(type)) {//查询车型
            map = paramDao.paramdetail(cph);
            List<String> keyList = new ArrayList<>();
            keyList.add("底盘ID");
            keyList.add("产品ID");
            keyList.add("产品号");
            keyList.add("产品类别");
            //keyList.add("企业ID");
            keyList.add("产品型号");
            keyList.add("企业名称");
            keyList.add("生产地址");
            keyList.add("车辆型号");
            keyList.add("车辆名称");
//			keyList.add("产品名称");
            keyList.add("中文品牌");
            keyList.add("英文品牌");
            keyList.add("前轮距");
            keyList.add("后轮距");
            keyList.add("发动机型号");
            keyList.add("发动机企业");
            keyList.add("发动机排量");
            keyList.add("发动机功率");
            keyList.add("发动机商标");
            keyList.add("识别代号序列");
            keyList.add("转向形式");
            keyList.add("燃料种类");
            keyList.add("排放标准");
            keyList.add("长");
            keyList.add("宽");
            keyList.add("高");
            keyList.add("货箱内部长度");
            keyList.add("货厢内部宽");
            keyList.add("货厢内部高");
            keyList.add("轴数");
            keyList.add("轴距");
            keyList.add("钢板弹簧片数");
            keyList.add("轮胎数");
            keyList.add("轮胎规格");
            keyList.add("总质量");
            keyList.add("核定载质量");
            keyList.add("整备质量");
            keyList.add("载质量");
            keyList.add("半挂鞍座");
            keyList.add("核定载客");
            keyList.add("接近离去角");
            keyList.add("驾驶室前排载客");
            keyList.add("前悬后悬");
            keyList.add("最高设计车速");
            keyList.add("底盘企业及底盘型号");
            keyList.add("轴荷");
            keyList.add("油耗");
            keyList.add("免检");
            keyList.add("防抱死系统");
            keyList.add("标识型号");
            keyList.add("标识商标");
            keyList.add("标识企业");
            keyList.add("批次");
            keyList.add("公告发布日期");
            keyList.add("公告生效日期");
            keyList.add("撤销公告批次");
            keyList.add("撤销公告发布日期");
            keyList.add("停止销售日期"); //新增【停止销售日期】
            keyList.add("备注");
            map.put("keyList", keyList);
        } else if ("2".equals(type)) {//查询地盘
            map = paramDao.paramdetailDp(cph);
            List<String> list = new ArrayList<>();
            //list.add("企业ID");
            list.add("产品号");
            list.add("底盘ID");
            list.add("企业名称");
            list.add("生产地址");
            list.add("底盘型号");
//			list.add("底盘型号");
            list.add("产品型号");
            list.add("产品名称");
            list.add("产品商标");
            list.add("长");
            list.add("宽");
            list.add("高");
            list.add("燃料种类");
            list.add("依据标准");
            list.add("前悬后悬");
            list.add("转向形式");
            list.add("轴数");
            list.add("轴距");
            list.add("弹簧片数");
            list.add("轮胎数");
            list.add("轮胎规格");
            list.add("前轮距");
            list.add("后轮距");
            list.add("总质量");
            list.add("整备质量");
            list.add("接近离去角");
            list.add("[挂车质量/准牵引总质量]");
            list.add("发动机型号");
            list.add("发动机企业");
            list.add("排量");
            list.add("功率");
            list.add("识别代号");
            list.add("备注");
            list.add("最高设计车速");
            list.add("轴荷");
            list.add("防抱死制动系统");
            list.add("半挂车鞍座最大允许总质量");
            list.add("批次");
            list.add("前悬后悬");
            list.add("前排乘客");
            list.add("后排乘客");
            list.add("油耗");
            list.add("产品更新标记");
//            list.add("停止生产日期");
//            list.add("停止销售日期");
            list.add("公告发布日期");
            list.add("公告生效日期");
            list.add("停止销售日期");    //新增【停止销售日期】
            list.add("更新日期");
            list.add("数据状态");
            map.put("keyList", list);
        }
        Map<String, Object> picMap = paramDao.getParamPic(cph, type);
        map.put("picMap", picMap);
        return map;
    }

    public Map<String, Object> findxhPage(PageParam page, String xh, String qyid, String pc, String cpsb, String rlzl, String qymc) {
        Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> list = paramDao.findxhPage(page, xh, qyid, pc, cpsb, rlzl, qymc);
        Long count = paramDao.findxhPageCount(page, xh, qyid, pc, cpsb, rlzl, qymc);
        map.put("total", count);
        map.put("rows", list);
        return map;
    }

    public Map<String, Object> findxhPage339(PageParam page, String xh, String qyid, String qyid2, String pc) {
        Map<String, Object> map = new HashMap<>();
        //List<Map<String, Object>> list=paramDao.findxhPage(page,xh,qyid);
        //Long count=paramDao.findxhPageCount(xh,qyid);

        List<Map<String, Object>> list = paramDao.findxhPage339(page, xh, qyid, qyid2, pc);
        Long count = paramDao.findxhPageCount339(xh, qyid, qyid2, pc);
        map.put("total", count);
        map.put("rows", list);
        return map;
    }

    public Map<String, Object> findnamePage(PageParam page, String qymc, String qyid, String pc, String cpsb, String rlzl, String cpmc) {
        Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> list = paramDao.findnamePage(page, qymc, qyid, pc, cpsb, rlzl, cpmc);
        Long count = paramDao.findnamePageCount(page, qymc, qyid, pc, cpsb, rlzl, cpmc);
        map.put("total", count);
        map.put("rows", list);
        return map;
    }

    public Map<String, Object> findnamePage339(PageParam page, String name, String qyid, String qyid2, String pc, String cpsb, String rlzl, String cpmc) {
        Map<String, Object> map = new HashMap<>();
//		List<Map<String, Object>> list=paramDao.findnamePage(page,name,qyid);
//		Long count=paramDao.findnamePageCount(name,qyid);
        List<Map<String, Object>> list = paramDao.findnamePage339(page, name, qyid, qyid2, pc, cpsb, rlzl, cpmc);
        Long count = paramDao.findnamePageCount339(name, qyid, qyid2, pc, cpsb, rlzl, cpmc);
        map.put("total", count);
        map.put("rows", list);
        return map;
    }

    public Map<String, Object> paramcount() {
        Map<String, Object> map = new HashMap<>();
        map = paramDao.paramcount();
        return map;
    }

    public String getdpxh(String dpid) {
        String dpxh = paramDao.getdpxh(dpid);
        return dpxh;
    }

    public Map<String, Object> findMoreList(PageParam page, SearchProductParams spp) {
        Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> list = paramDao.findMoreList(page, spp);
        Long count = paramDao.findMorePageCount(spp);
        map.put("total", count);
        map.put("rows", list);
        return map;
    }

    public Map<String, Object> findMoreList339(PageParam page, SearchProductParams spp, String qyid, String pc) {
        Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> list = paramDao.findMoreList339(page, spp, qyid, pc);
        Long count = paramDao.findMorePageCount339(spp, qyid, pc);
        map.put("total", count);
        map.put("rows", list);
        return map;
    }

    /**
     * @Title: findMapbyUser
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @param @param page
     * @param @param string
     * @param @param xh
     * @param @param qyid
     * @param @return    设定文件
     * @author ADC_ZH
     * @param qyid
     * @param cpsb
     * @param rlzl
     * @date 下午6:19:51
     */
    public Map<String, Object> findMapbyUser(PageParam page, String name,
                                             String xh, String pc, String qyid, String rlzl, String cpsb) {
        Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> list=paramDao.findMapbyUser(page, name, xh, pc, qyid, rlzl, cpsb);
        Long count=paramDao.findMapbyUserCount(page, name, xh, pc, qyid, rlzl, cpsb);
        map.put("total", count);
        map.put("rows", list);
        return map;
    }

    /**
     * @Title: findBrand
     * @Description: TODO(本企业数据-查询条件下拉框)
     * @param @param qyid
     * @param @return    设定文件
     * @author ADC_ZH
     * @date 下午7:02:55
     */
    public Map<String, Object>  findBrandFuel(String qyid) {
        long time=60*24*2;
        Map<String, Object> map = new HashMap<>();
        if(!redisUtils.exists("fuel_"+qyid)){
            List<Map<String, Object>> fuel=paramDao.findFuel(qyid);
            redisUtils.set("fuel_"+qyid, fuel, time, TimeUnit.MINUTES);
            map.put("fuel", fuel);
        }else{
            map.put("fuel", redisUtils.get("fuel_"+qyid));
        }
        if(!redisUtils.exists("brand_"+qyid)){
            List<Map<String, Object>> brand=paramDao.findBrand(qyid);
            redisUtils.set("brand_"+qyid, brand, time, TimeUnit.MINUTES);
            map.put("brand", brand);
        }else{
            map.put("brand", redisUtils.get("brand_"+qyid));
        }
        return map;
    }

    /**
     * @Title: findGroup
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @param @param qyid
     * @param @return    设定文件
     * @return String    返回类型
     * @author ADC_ZH
     * @date 下午3:48:20
     */
    public String findGroup(String qyid) {
        String group=paramDao.findGroup(qyid);

        return group;
    }

    /**
     * @Title: findBrandFuelPc
     * @Description: TODO(行业数据-查询条件下拉框)
     * @param @param qyid
     * @author ADC_ZH
     * @date 下午6:36:02
     */
    public Map<String, Object> findBrandFuelPc(String qyid) {
        long time=60*24*2;
        Map<String, Object> map = new HashMap<>();
        if(!redisUtils.exists("fuel")){
            List<Map<String, Object>> fuel=paramDao.findFuel("");
            redisUtils.set("fuel", fuel, time, TimeUnit.MINUTES);
            map.put("fuel", fuel);
        }else{
            map.put("fuel", redisUtils.get("fuel"));
        }
        if(!redisUtils.exists("brand")){
            List<Map<String, Object>> brand=paramDao.findBrand("");
            redisUtils.set("brand", brand, time, TimeUnit.MINUTES);
            map.put("brand", brand);
        }else{
            map.put("brand", redisUtils.get("brand"));
        }
        if(!redisUtils.exists("pc")){
            List<Map<String, Object>> pc=paramDao.findPc("");
            map.put("pc", pc);
            redisUtils.set("pc", pc, time, TimeUnit.MINUTES);
        }else{
            map.put("pc", redisUtils.get("pc"));
        }
        return map;
    }

    /**
     * @param @param  page
     * @param @param  string
     * @param @param  xh
     * @param @param  qyid
     * @param @return 设定文件
     * @param qyid
     * @param cpsb
     * @param rlzl
     * @return Map<String Object>    返回类型
     * @Title: findCpmcByCpxh
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午1:15:26
     */
    public List<Map<String, Object>> findCpmcByCpxh(String cpxh, String pc,
                                                    String qyid) {
        List<Map<String, Object>> list = paramDao.findCpmcByCpxh(cpxh, pc, qyid);
        return list;
    }


}
