package com.adc.da.bs.report.dao;

import java.util.List;
import java.util.Map;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import com.adc.da.util.http.PageParam;

/**
 * @description 检测报告查询
 * @author ZhengZhiwei
 * @date create at 16:26 2018/3/20
 * @modified by
 */
@Component
public class ReportDao {
    protected final EntityManager entityManager;
    @Autowired
    public ReportDao(EntityManager entityManager) {
        super();
        this.entityManager = entityManager;
    }


/**
 * @describtion 检测报告分页查询 通过产品型号和报告号模糊查询
 * @author ZhengZhiwei
 * @date create at 21:12 2018/3/21
 * @modified by
 */
    public List<Map<String, Object>> findPage(PageParam page, String param) {
        StringBuilder sql = new StringBuilder();
        sql.append("   SELECT A.*,ROWNUM RN FROM(  ");
        sql.append("   SELECT A .*,ROWNUM  ");
        sql.append("   FROM(  ");
        sql.append("   SELECT qymc,bgbh,xmdm,xmmc,yjbz,cpxh,cpmc,cpsb,rk  ");
        sql.append("   FROM ggcain06.bgk  ");
        sql.append("   WHERE 1 = 1  ");
        sql.append("   AND cpxh like concat(concat('%',:cpxh),'%') ");
        sql.append("   UNION ALL  ");
        sql.append("   SELECT qymc,bgbh,xmdm,xmmc,yjbz,cpxh,cpmc,cpsb,rk  ");
        sql.append("   FROM ggcain06.bgk  ");
        sql.append("   WHERE 1 = 1  ");
        sql.append("   AND BGBH like concat(concat('%',:bgbh),'%')  ");
        sql.append("   ) A  ");
        sql.append("   ORDER BY A.qymc,A.bgbh,A.cpxh,A.cpmc,A.cpsb  ");
        sql.append("   ) A  ");


        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        //param = "'%" + param + "%'";
        query.setParameter("cpxh", param);
        query.setParameter("bgbh", param);
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }
    /**
     * @describtion  检测报告分页查询 查询数据总数
     * @author ZhengZhiwei
     * @date create at 21:26 2018/3/21
     * @modified by
     */
    public Long findPageCount(String param) {
        StringBuilder sql = new StringBuilder();
        sql.append("   SELECT count(1) FROM(  ");
        sql.append("   SELECT A .*  ");
        sql.append("   FROM(  ");
        sql.append("   SELECT qymc,bgbh,xmdm,xmmc,yjbz,cpxh,cpmc,cpsb,rk  ");
        sql.append("   FROM ggcain06.bgk  ");
        sql.append("   WHERE 1 = 1  ");
        sql.append("   AND cpxh like concat(concat('%',:cpxh),'%')   ");
        sql.append("   UNION ALL  ");
        sql.append("   SELECT qymc,bgbh,xmdm,xmmc,yjbz,cpxh,cpmc,cpsb,rk  ");
        sql.append("   FROM ggcain06.bgk  ");
        sql.append("   WHERE 1 = 1  ");
        sql.append("   AND BGBH like concat(concat('%',:bgbh),'%')  ");
        sql.append("   ) A  ");
        sql.append("   ) A  ");
        Query query = entityManager.createNativeQuery(sql.toString());
//        param = "'%" + param + "%'";
        query.setParameter("cpxh", param);
        query.setParameter("bgbh", param);
        Long count=Long.parseLong(query.getSingleResult().toString());
        return count;
    }


	public int upPdf(Map<String, Object> map) {
		String insSql = " INSERT INTO NERDS.PDF_INFO (ID,UP_DATE, TITLE, AUTHOR ,PAGE, CHARTS, UP_USER, PATH, TYPE, COVER, CONTENT,TOP,URL,CONTENTDETAIL "
				+ ") VALUES (NERDS.retrieval_seq.nextval, SYSDATE, ?, ?, ?, ?, ?, ?, ? , ?, ?, ?, ? ,?) ";
		Query insQuery = entityManager.createNativeQuery(insSql);
		insQuery.setParameter(1, map.get("title"));
	    insQuery.setParameter(2, map.get("author"));
	    insQuery.setParameter(3, map.get("page"));
	    insQuery.setParameter(4, map.get("charts"));
	    insQuery.setParameter(5, map.get("up_user"));
	    insQuery.setParameter(6, map.get("path"));
	    insQuery.setParameter(7, map.get("type"));
	    insQuery.setParameter(8, map.get("cover"));
	    insQuery.setParameter(9, map.get("content"));
	    insQuery.setParameter(10, map.get("top"));
	    insQuery.setParameter(11, map.get("url"));
	    insQuery.setParameter(12, map.get("contentdetail"));
		int i=0;
		try {
			i = insQuery.executeUpdate();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return i;
	}


	public List<Map<String, Object>> PdfList(PageParam page, String type) {
		StringBuilder sql = new StringBuilder();
        sql.append("   SELECT A.*,ROWNUM RN FROM(  ");
        sql.append("   SELECT A .*,ROWNUM  ");
        sql.append("   FROM(  ");
        sql.append("   SELECT *  ");
        sql.append("   FROM NERDS.PDF_INFO   ");
        sql.append("   WHERE TYPE = ?   ");
        sql.append("   ) A  ");
        sql.append("   ORDER BY A.UP_DATE DESC  ");
        sql.append("   ) A  ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter(1,"1");
        query.setFirstResult(0);
        query.setMaxResults(8);
        List<Map<String, Object>> list = query.getResultList();
        return list;
	}


	public Long PdfListCount(String type) {
		// TODO Auto-generated method stub
		return null;
	}


	@SuppressWarnings("unchecked")
	public List<Map<String, Object>> PdfIndex(String type, int i) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select * from (SELECT TO_CHAR(SYSDATE,'YYYY-MM-DD') AS TODAY, ID,TITLE ,AUTHOR,PAGE,CHARTS,");
		sql.append(" UP_DATE ,UP_USER,PATH,TYPE,COVER,CONTENT,TOP,URL,CLICKCOUNT ");
        sql.append(" FROM NERDS.PDF_INFO ");
        sql.append(" WHERE TYPE = '"+type+"'");
        sql.append(" AND TOP = '1' ");
        sql.append(" ORDER BY ID DESC ");
        sql.append("  ) WHERE ROWNUM<="+i);
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list;
	}


	public Map<String, Object> NewsContents(String type, String num) {
		StringBuilder sql = new StringBuilder();
		sql.append(" SELECT ID,TITLE ,AUTHOR,PAGE,CHARTS,");
		sql.append(" UP_DATE ,UP_USER,PATH,TYPE,COVER,CONTENT,TOP,URL,CONTENTDETAIL ");
        sql.append(" FROM NERDS.PDF_INFO ");
        sql.append(" WHERE TYPE = '"+type+"'");
        sql.append(" AND ID=?");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter(1,num);
        List<Map<String, Object>> list = query.getResultList();
        return list.get(0);
	}


	public List<Map<String, Object>> dailylist(PageParam page, int type,
			String name) {
		StringBuilder sql = new StringBuilder();
        sql.append(" SELECT A.*,ROWNUM RN FROM(  ");
        sql.append(" SELECT A .*,ROWNUM  ");
        sql.append(" FROM(  ");
        sql.append(" SELECT ID,TITLE ,UP_DATE,TO_CHAR (UP_DATE, 'YYYY-MM-DD') REL_TIME,CONTENT,COVER,AUTHOR,URL,CLICKCOUNT ");
        sql.append(" FROM NERDS.PDF_INFO   ");
        sql.append(" WHERE TYPE = ?   ");
        sql.append(" ) A  ");
        sql.append(" ORDER BY A.UP_DATE DESC  ");
        sql.append(" ) A  ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter(1,type);
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        return list;
	}


	public Long dailylistPageCount(int type, String name) {
		StringBuilder sql = new StringBuilder();
        sql.append("   SELECT count(1)  ");
        sql.append("   FROM NERDS.PDF_INFO   ");
        sql.append("   WHERE TYPE = ?   ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.setParameter(1,type);
        Long count=Long.parseLong(query.getSingleResult().toString());
        return count;
	}


	/**   
	 * @Title: delete   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @return    设定文件   
	 * @return boolean    返回类型   
	 * @author ADC_ZH 
	 * @date 下午6:21:47 
	*/   
	public boolean delete(String id) {
		boolean re=false;
		if(id!=null && !"".equals(id)){			
			StringBuffer deleteSql = new StringBuffer();
			deleteSql.append(" UPDATE NERDS.PDF_INFO SET TYPE = '0' "); 
			deleteSql.append(" WHERE ID = '"+id+"'");
			Query query = entityManager.createNativeQuery(deleteSql.toString());
			if(query.executeUpdate() == 1 ){
				re=true;
			} 
		} 
		return re;
	}


	/**   
	 * @Title: PdfIndexCountList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param types
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 上午8:26:30 
	*/   
	public List<Map<String, Object>> PdfIndexCountList(String types) {
		StringBuffer bf = new StringBuffer();
		bf.append("	SELECT TYPE,COUNT(*),SUM (CLICKCOUNT) FROM 	NERDS.PDF_INFO  ");
		bf.append("	WHERE TYPE in ("+types+")");
		bf.append("	GROUP BY TYPE  ");
		Query query = entityManager.createNativeQuery(bf.toString());
		query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP); 
//		query.setParameter(1,types); 
		List<Map<String, Object>> list = query.getResultList();
		return list;
	}


	/**   
	 * @Title: PdfIndexList   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param types
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 上午8:58:10 
	*/   
	public List<Map<String, Object>> PdfIndexList(String types, int i) {
		StringBuilder sql = new StringBuilder();
		sql.append(" select * from (SELECT TO_CHAR(SYSDATE,'YYYY-MM-DD') AS TODAY, ID,TITLE ,AUTHOR,PAGE,CHARTS,");
		sql.append(" UP_DATE ,UP_USER,PATH,TYPE,COVER,CONTENT,TOP,URL,CLICKCOUNT ");
        sql.append(" FROM NERDS.PDF_INFO ");
        sql.append(" WHERE TYPE  in ("+types+")");
        sql.append(" AND TOP = '1' ");
        sql.append(" ORDER BY ID DESC ");
        sql.append("  ) WHERE ROWNUM<="+i);
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list;
	}


	/**   
	 * @Title: addclick   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param iD
	 * @param @return    设定文件   
	 * @return int    返回类型   
	 * @author ADC_ZH 
	 * @date 下午4:53:44 
	*/ 
	@Transactional
	public int addclick(String iD) { 
		String updatePointSql = " UPDATE NERDS.PDF_INFO  SET CLICKCOUNT = (NVL(CLICKCOUNT, 0)+1) WHERE ID = ? ";
		Query updateQuery = entityManager.createNativeQuery(updatePointSql);
		updateQuery.setParameter(1, iD);
		int i= updateQuery.executeUpdate() ;
		return i;
	}
}
