package com.adc.da.bs.report.enums;

/**
 *  保存的文件 类型枚举
 *  目的在于后续维护扩展 不会出现类型编号不知道到几的情况
 *
 * @author 韩磊
 * @date 2019/3/20 16:48
 */
public enum FileTypeEnum {
    /**
     *  分析报告页面中的 "公告"栏
     */
    BULLETIN(1,"公告"),
    /**
     *  分析报告页面中的 "新能源"栏
     */
    EV(2,"新能源"),
    /**
     *  政策研究页面
     */
    POLICY(3,"政策研究"),
    /**
     *  资源共享页面(1级菜单)中的
     *  会议资料(2级菜单)
     */
    METTING(4,"会议资料");

    private int value;

    private String name;

    FileTypeEnum(int value, String name) {
        this.value = value;
        this.name = name;
    }

    public int getValue() {
        return value;
    }

    public String getName() {
        return name;
    }

    public static FileTypeEnum getFileEnumByValue(int value){
        for(FileTypeEnum fileType : FileTypeEnum.values()){
            if(value == fileType.getValue()){
                return fileType;
            }
        }
        return null;
    }

    public static String getFileEnumNameByValue(int value){
        for(FileTypeEnum fileType : FileTypeEnum.values()){
            if(value == fileType.getValue()){
                return fileType.getName();
            }
        }
        return null;
    }
}
