package com.adc.da.bs.report.rest;

import com.adc.da.bs.report.service.ReportService;
import com.adc.da.util.exception.AdcDaBaseException;
import com.adc.da.util.http.PageParam;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.Reader;
import java.sql.Clob;
import java.sql.SQLException;
import java.util.Map;

/**
 * @author ZhengZhiwei
 * @description 检测报告查询
 * @date create at 16:29 2018/3/20
 * @modified by
 */
@Controller
@RequestMapping(value = "/${restPath}/report")
@Api(description = "检测报告查询")
public class ReportController {
    @Autowired
    private ReportService reportService;


    /**
     * @describtion 检测报告查询列表
     * @author ZhengZhiwei
     * @date create at 16:31 2018/3/20
     * @modified by
     */
    @ApiOperation(value = "检测报告查询列表")
    @PostMapping("/list")
    @ResponseBody
    public Map<String, Object> findList(HttpServletRequest request, PageParam page, String param) {
    	if(param=="") throw new AdcDaBaseException("请求参数为空！");;
        Map<String,Object> pageMap =reportService.findMapByPage(page, param);
        return pageMap;
    }
    /**
     * @describtion pdf列表
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "检测报告查询列表")
    @PostMapping("/PdfList")
    @ResponseBody
    public Map<String, Object> PdfList(HttpServletRequest request, PageParam page, String type) {
        Map<String,Object> pageMap =reportService.PdfList(page, type);
        return pageMap;
    }
    /**
     * @describtion pdf列表
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "检测报告查询列表")
    @PostMapping("/PdfIndex")
    @ResponseBody
    public Map<String, Object> PdfIndex(HttpServletRequest request) {
        Map<String,Object> pageMap =reportService.PdfIndex();
        return pageMap;
    }
    
    /**
     * @describtion 列表
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "首页新闻列表")
    @PostMapping("/MainPageNews")
    @ResponseBody
    public Map<String, Object> MainPageNews(HttpServletRequest request) {
        Map<String,Object> pageMap =reportService.MainPageNews();
        return pageMap;
    }
    /**
     * @describtion 列表
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "首页资讯——更多2021（整车、零部件）")
    @PostMapping("/dailylist")
    @ResponseBody
    public Map<String, Object> dailylist(HttpServletRequest request, PageParam page, int type) {
        Map<String,Object> pageMap =reportService.dailylist(page,type , "");
        return pageMap;
    }
    
    /**
     * @describtion 列表
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "首页资讯——更多2021（整车、零部件）")
    @PostMapping("/dailylistManager")
    @ResponseBody
    public Map<String, Object> dailylistManager(HttpServletRequest request, PageParam page, String type) {
    	
        Map<String,Object> pageMap =reportService.dailylist(page,Integer.parseInt(type) , "");
        return pageMap;
    }
    /**
     * @describtion 列表
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "首页新闻内容")
    @PostMapping("/NewsContents")
    @ResponseBody
    public Map<String, Object> NewsContents(HttpServletRequest request, String num) {
        Map<String,Object> map =reportService.NewsContents("5",num);
        if(map==null){
        	map.put("CONTENTDETAIL", "未找到相关信息！");
        }else{

        	Clob clob=(Clob) map.get("CONTENTDETAIL"); 

        	String reString = "";
        	try {
        		Reader is = clob.getCharacterStream();// 得到流
        		BufferedReader br = new BufferedReader(is);
        		String s = br.readLine();
        		StringBuffer sb = new StringBuffer();
        		while (s != null) {// 执行循环将字符串全部取出付值给StringBuffer由StringBuffer转成STRING
        			sb.append(s);
        			s = br.readLine();
        		}
        		reString = sb.toString();
        		map.put("CONTENTDETAIL", reString);
        	} catch (SQLException e) {
        		// TODO Auto-generated catch block
        		e.printStackTrace();
        	} catch (IOException e) {
        		// TODO Auto-generated catch block
        		e.printStackTrace();
        	}
        }
        return map;
    }
    /**
     * @describtion 删除
     * @author zhong
     * @modified by
     */
    @ApiOperation(value = "删除")
    @PostMapping("/delete")
    @ResponseBody
    public boolean delete(HttpServletRequest request, String id) {
    	Map<String,Object> usermap=(Map<String, Object>) request.getSession().getAttribute("usermap");
		if (!"61077".equals(usermap.get("ID").toString()) || !"adc".equals(usermap.get("USERNAME").toString())) {
			return false;
        }else{         	
        	return reportService.delete(id);
        }
    }
}
