package com.adc.da.bs.reportManage.utils;

import org.apache.commons.lang.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.poifs.filesystem.POIFSFileSystem;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DateUtil;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;


public class PoiUtil {
	// 以下测试路径
//	public static final String ADDRESS = "D:/3310a/jcjg/zjsc/DX010006/";
//	public static final String TEMPURL = "D:/3310a/jcjg/zjsc/DX010006/temp/";
//	public static final String DIRECTORY = "D:/3310a/jcjg/zjsc/DX010006/repository/";
//	public static final String BGBHPATH = "http://192.2.12.172:9098/reportPath/";
//	public static final String BGBHPATHOLD = "http://123.127.164.35:18082/datafilesAdd_8/";

	// 以下正式路径
    public static final String ADDRESS = "/root/ADCBS/1.0/adcbs-ui/ADC/upload/report/";
    public static final String TEMPURL = "/root/ADCBS/1.0/adcbs-ui/ADC/upload/report/temp/";
    public static final String DIRECTORY = "/root/ADCBS/1.0/adcbs-ui/ADC/upload/report/repository/";
	public static final String BGBHPATH = "http://www.catarc.info:13030/reportPath/";
	public static final String BGBHPATHOLD = "http://123.127.164.35:18082/datafilesAdd_8/";
    public static final String TJB = "/root/ADCBS/1.0/adcbs-ui/ADC/upload/tjb/";
//	public static final String TJB = "D:/root/ADCBS/1.0/adcbs-ui/ADC/upload/tjb/";

	/**
	 * 导入检测报告清单
	 * @param srcFile
	 * @return
	 * @throws Exception
	 */
	public static Map<String, List<String>> importFromExcel(File srcFile) throws Exception {
		Map<String, List<String>> resFormExcel = new HashMap<String, List<String>>();
		FileInputStream fis = new FileInputStream(srcFile);
		try {
			if (srcFile.getName().endsWith(".xls")) {
				POIFSFileSystem fSystem = new POIFSFileSystem(fis);
				HSSFWorkbook wb = new HSSFWorkbook(fSystem);
				HSSFSheet st = wb.getSheetAt(0);

				int excelRealRow = getExcelRealRow(st);
				for (int i = 2; i < 1 + excelRealRow; i++) {
					String key = getValueAt(st, i, 1);
					List<String> lineData = new ArrayList<String>();
					for (int j = 1; j < 8; j++) {
						lineData.add(getValueAt(st, i, j));
					}
					resFormExcel.put(key, lineData);
				}
				return resFormExcel;
			}
			else if (srcFile.getName().endsWith(".xlsx")) {
				XSSFWorkbook xwb = new XSSFWorkbook(fis);
				XSSFSheet xst = xwb.getSheetAt(0);

				int excelRealRow = getExcelRealRow(xst);
				for (int i = 2; i < 1 + excelRealRow; i++) {
					String key = getValueAt(xst, i, 1);
					List<String> lineData = new ArrayList<String>();
					for (int j = 1; j < 8; j++) {
						lineData.add(getValueAt(xst, i, j));
					}
					resFormExcel.put(key, lineData);
				}
				return resFormExcel;
			}
			else {
				throw new Exception("文件类型不对!");
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new FileNotFoundException(e.getMessage());
		} catch (IOException e) {
			e.printStackTrace();
			throw new Exception(e.getMessage());
		}
		finally{
			fis.close();
		}
	}

	/**
	 * 导入检测人员清单
	 * @param srcFile
	 * @return
	 * @throws Exception
	 */
	public static Map<String, List<String>> importJcryExcel(File srcFile) throws Exception {
		Map<String, List<String>> resFormExcel = new HashMap<String, List<String>>();
		FileInputStream fis = new FileInputStream(srcFile);
		try {
			if (srcFile.getName().endsWith(".xls")) {
				POIFSFileSystem fSystem = new POIFSFileSystem(fis);
				HSSFWorkbook wb = new HSSFWorkbook(fSystem);
				HSSFSheet st = wb.getSheetAt(0);

				if (!(st.getRow(0).getLastCellNum()  == 6)) {
					throw new Exception("非法文件！请使用提供的模板填写，且不要更改模板样式! ");
				}
				int excelRealRow = getExcelRealRow(st);
				//System.out.println(excelRealRow);

				for (int i = 2; i < 1+excelRealRow; i++) {
					String key = getValueAt(st, i, 0);
					List<String> lineData = new ArrayList<String>();
					for (int j = 1; j < 2 + 4; j++) {
						lineData.add(getValueAt(st, i, j));
					}
					resFormExcel.put(key, lineData);
				}
				return resFormExcel;
			}
			else if (srcFile.getName().endsWith(".xlsx")) {
				throw new Exception("文件类型不对!");
			}
			else {
				throw new Exception("文件类型不对!");
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new FileNotFoundException(e.getMessage());
		} catch (IOException e) {
			e.printStackTrace();
			throw new Exception(e.getMessage());
		}
		finally{
			fis.close();
		}
	}

	static // 获取Excel表的真实行数
	int getExcelRealRow(Sheet sheet) {
		boolean flag = false;
		for (int i = 1; i <= sheet.getLastRowNum(); ) {
			Row r = sheet.getRow(i);
			if (r == null) {
				// 如果是空行（即没有任何数据、格式），直接把它以下的数据往上移动
				sheet.shiftRows(i + 1, sheet.getLastRowNum(), -1);
				continue;
			}
			flag = false;
			for (Cell c : r) {
				if (c.getCellType() != Cell.CELL_TYPE_BLANK) {
					flag = true;
					break;
				}
			}
			if (flag) {
				i++;
				continue;
			} else {
				// 如果是空白行（即可能没有数据，但是有一定格式）
				if (i == sheet.getLastRowNum())// 如果到了最后一行，直接将那一行remove掉
					sheet.removeRow(r);
				else//如果还没到最后一行，则数据往上移一行
					sheet.shiftRows(i + 1, sheet.getLastRowNum(), -1);
			}
		}
		return sheet.getLastRowNum();
	}

	public static String importByExcelForDate(Cell currentCell) {
		String currentCellValue = "";
		// 判断单元格数据是否是日期
		if ("yyyy/mm;@".equals(currentCell.getCellStyle().getDataFormatString())
				|| "m/d/yy".equals(currentCell.getCellStyle().getDataFormatString())
				|| "yy/m/d".equals(currentCell.getCellStyle().getDataFormatString())
				|| "mm/dd/yy".equals(currentCell.getCellStyle().getDataFormatString())
				|| "dd-mmm-yy".equals(currentCell.getCellStyle().getDataFormatString())
				|| "yyyy/m/d".equals(currentCell.getCellStyle().getDataFormatString())) {
			if (DateUtil.isCellDateFormatted(currentCell)) {
				// 用于转化为日期格式
				Date d = currentCell.getDateCellValue();
				DateFormat formater = new SimpleDateFormat("yyyy-MM-dd");
				currentCellValue = formater.format(d);
			}
		} else {
			// 不是日期原值返回
			currentCellValue = currentCell.toString();
		}
		return currentCellValue;
	}

	public static String getValueAt(Object sheet , int row, int col){
		String res_rString = "";
		if (sheet instanceof HSSFSheet) {
			HSSFCell sCell = ((HSSFSheet) sheet).getRow(row).getCell((short)col);
			if(sCell!=null ){
				
				// 判断单元格数据是否是日期
				if (sCell!=null && ("yyyy/mm;@".equals(sCell.getCellStyle().getDataFormatString())
						|| "m/d/yy".equals(sCell.getCellStyle().getDataFormatString())
						|| "yy/m/d".equals(sCell.getCellStyle().getDataFormatString())
						|| "mm/dd/yy".equals(sCell.getCellStyle().getDataFormatString())
						|| "dd-mmm-yy".equals(sCell.getCellStyle().getDataFormatString())
						|| "yyyy/m/d".equals(sCell.getCellStyle().getDataFormatString()))) {
					
					res_rString = importByExcelForDate(sCell);
					return res_rString;
				}
				
				int cellT = sCell.getCellType();
				switch (cellT) {
				case HSSFCell.CELL_TYPE_NUMERIC:
					res_rString = StringUtils.defaultString(String.valueOf(sCell.getNumericCellValue()));
					Double parseDouble = Double.parseDouble(res_rString);
					int intValue = parseDouble.intValue();
					res_rString =intValue+"";
					break;
				case HSSFCell.CELL_TYPE_STRING:
					res_rString = StringUtils.defaultString(String.valueOf(sCell.getStringCellValue()));
					break;
				default:
					return "";
				}
				return res_rString;
			}else{
				return "";
			}
		}
		else if (sheet instanceof XSSFSheet) {
			XSSFCell xCell = ((XSSFSheet) sheet).getRow(row).getCell((short)col);
			if(xCell!=null ){
				// 判断单元格数据是否是日期
				if ("yyyy/mm;@".equals(xCell.getCellStyle().getDataFormatString())
						|| "m/d/yy".equals(xCell.getCellStyle().getDataFormatString())
						|| "yy/m/d".equals(xCell.getCellStyle().getDataFormatString())
						|| "mm/dd/yy".equals(xCell.getCellStyle().getDataFormatString())
						|| "dd-mmm-yy".equals(xCell.getCellStyle().getDataFormatString())
						|| "yyyy/m/d".equals(xCell.getCellStyle().getDataFormatString())) {
					
					res_rString = importByExcelForDate(xCell);
					return res_rString;
				}
				
				
				int cellT = xCell.getCellType();
				switch (cellT) {
				case XSSFCell.CELL_TYPE_NUMERIC:
					res_rString = StringUtils.defaultString(String.valueOf(xCell.getNumericCellValue()));
					break;
				case XSSFCell.CELL_TYPE_STRING:
					res_rString = StringUtils.defaultString(String.valueOf(xCell.getStringCellValue()));
					break;
				default:
					return "";
				}
				return res_rString;
			}else{
				return "";
			}
		}
		else {
			return "";
		}
	}

	public static boolean FileIsExist(String url) {

		BufferedInputStream bis = null;
		HttpURLConnection httpUrl = null;
		try {
			URL urlfile = null; // 文件URL地址
			urlfile = new URL(url);
			httpUrl = (HttpURLConnection) urlfile.openConnection();
			httpUrl.setRequestMethod("GET");
			httpUrl.connect();
			bis = new BufferedInputStream(httpUrl.getInputStream());
			if (bis != null) {
				return true;
			} else {
				return false;
			}
		} catch (Exception e) {
			return false;
		} finally {
			try {
				bis.close();
				httpUrl.disconnect();
			} catch (IOException e) {
			}
		}
	}
	
	
	/**
	 * 导入检测报告清单
	 * @param srcFile
	 * @return
	 * @throws Exception
	 */
	public static Map<String, List<String>> importExcelTjb(File srcFile,int row,int colum) throws Exception {
		Map<String, List<String>> resFormExcel = new HashMap<String, List<String>>();
		FileInputStream fis = new FileInputStream(srcFile);
		try {
			if (srcFile.getName().endsWith(".xls")) {
				POIFSFileSystem fSystem = new POIFSFileSystem(fis);
				HSSFWorkbook wb = new HSSFWorkbook(fSystem);
				HSSFSheet st = wb.getSheetAt(0);

				int excelRealRow = getExcelRealRow(st);
				for (int i = row; i <= excelRealRow; i++) {
					String key = getValueAt(st, i, 1);
					List<String> lineData = new ArrayList<String>();
					for (int j = 1; j < colum; j++) {
						lineData.add(getValueAt(st, i, j));
					}
					resFormExcel.put(key, lineData);
				}
				return resFormExcel;
			}
			else if (srcFile.getName().endsWith(".xlsx")) {
				XSSFWorkbook xwb = new XSSFWorkbook(fis);
				XSSFSheet xst = xwb.getSheetAt(0);

				int excelRealRow = getExcelRealRow(xst);
				for (int i = row; i <= excelRealRow; i++) {
					String key = getValueAt(xst, i, 1);
					List<String> lineData = new ArrayList<String>();
					for (int j = 1; j < colum; j++) {
						lineData.add(getValueAt(xst, i, j));
					}
					resFormExcel.put(key, lineData);
				}
				return resFormExcel;
			}
			else {
				throw new Exception("文件类型不对!");
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw new FileNotFoundException(e.getMessage());
		} catch (IOException e) {
			e.printStackTrace();
			throw new Exception(e.getMessage());
		}
		finally{
			fis.close();
		}
	}

}
