package com.adc.da.bs.resourceSharing.dao;

import com.adc.da.bs.resourceSharing.entity.QaAnswerEntity;
import com.adc.da.bs.resourceSharing.entity.QaExpertsLibFileEntity;
import com.adc.da.bs.resourceSharing.entity.QaIssueEntity;
import com.adc.da.util.http.PageParam;
import org.apache.commons.lang3.StringUtils;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import javax.persistence.Query;
import java.sql.Clob;
import java.sql.SQLException;
import java.util.*;


/**
 * 资源共享  问答模块 包含 提问  问题集 经典问题
 *
 * @author ZhengZhiwei
 * @description
 * @date create at 15:30 2018/3/29
 * @modified by
 */
@Component
public class QandADao {
    protected final EntityManager entityManager;

    @Autowired
    public QandADao(EntityManager entityManager) {
        super();
        this.entityManager = entityManager;
    }

    /**
     * @param
     * @describtion TODO 查询问题集总数量
     * @author ZhengZhiwei
     * @date create at 16:01 2018/3/29
     * @modified by
     */
    public Long findTotalCount(Integer entId, String isA, String param, String qtype) {
        StringBuffer sql = new StringBuffer();
        sql.append("  SELECT count(*) as count ");
        sql.append("  FROM RETRIEVAL.QA_ISSUES QAI  ");
        sql.append("  LEFT JOIN RETRIEVAL.RET_USERS RU ");
        sql.append("  ON QAI.ENTID = RU.ID  ");
        sql.append("  LEFT JOIN  (SELECT COUNT(*) AS ACOUNT,QID FROM RETRIEVAL.QA_ANSWERS QAA where QAA.DEL_FLAG=0 GROUP BY QID ) N   ");
        sql.append("  ON N.QID = QAI.ID  ");
        sql.append("  WHERE QAI.DEL_FLAG='0'  ");
        if (StringUtils.equals(isA, "myQ")) {//我的提问
            sql.append("  and QAI.ENTID = ? ");//我的id
        } else if (StringUtils.equals(isA, "myA")) {//我的回答
            sql.append(" AND QAI.id IN (SELECT DISTINCT QID FROM NERDS.QA_MESSAGE WHERE  type = '回复'  and M_USERID = ?)");
        } else if (StringUtils.equals(isA, "UN")) {//暂无回答
            sql.append(" AND nvl(N.ACOUNT,0)=0  ");
        }
        if (StringUtils.isNotEmpty(param)) {//关键字查询
            sql.append("   AND (QAI.TITLE LIKE  ?  OR QAI.CONTENT LIKE ?)");
        }
        if (StringUtils.isNotEmpty(qtype)) {//类别
            sql.append("   AND  QAI.QTYPE =:qtype ");
        }
        Query query = entityManager.createNativeQuery(sql.toString());
        if (StringUtils.equals(isA, "myQ") || StringUtils.equals(isA, "myA")) {
            query.setParameter(1, entId);//我的id
        } else if (StringUtils.isNotEmpty(param)) {
            query.setParameter(1, "%" + param + "%");
            query.setParameter(2, "%" + param + "%");
        }
        if (StringUtils.isNotEmpty(qtype)) {//类别
            query.setParameter("qtype", qtype);
        }
        Long count = Long.parseLong(query.getSingleResult().toString());
        return count;
    }

    /**
     * @param
     * @describtion TODO  分页查询问题集 条件查询
     * @author ZhengZhiwei
     * @date create at 16:02 2018/3/29
     * @modified by
     */
    public List<Map<String, Object>> findListByPage(PageParam page, Integer entId, String isA, String param, String qtype) {
        StringBuffer sql = new StringBuffer();
        sql.append("  SELECT QAI.ID, QAI.USERID, QAI.ENTID, QAI.TITLE, QAI.CONTENT, QAI.VIEWCOUNT, ");
        sql.append("  QAI.REWARDS, to_char(QAI.CREATDATE,'yyyy-MM-dd HH24:mi:ss') as CREATDATE, QAI.ANONYMITY, QAI.ACCEPTED, RU.NAME, nvl(N.ACOUNT,0) ACOUNT, ");
        sql.append("  to_char(sysdate,'yyyy-MM-DD') as today, to_char(QAI.CREATDATE,'yyyy-MM-dd') as rel_time ");
        sql.append("  FROM RETRIEVAL.QA_ISSUES QAI  ");
        sql.append("  LEFT JOIN RETRIEVAL.RET_USERS RU ");
        sql.append("  ON QAI.ENTID = RU.ID  ");
        sql.append("  LEFT JOIN  (SELECT COUNT(*) AS ACOUNT,QID FROM RETRIEVAL.QA_ANSWERS QAA where QAA.DEL_FLAG=0  GROUP BY QID) N   ");
        sql.append("  ON N.QID = QAI.ID  ");
        sql.append("  WHERE QAI.DEL_FLAG='0'  ");
        if (StringUtils.equals(isA, "myQ")) {//我的提问
            sql.append(" and QAI.ENTID = ? ");//我的id
        } else if (StringUtils.equals(isA, "myA")) {//我的回答
            sql.append(" AND QAI.id IN (SELECT DISTINCT QID FROM NERDS.QA_MESSAGE WHERE  type = '回复'  and M_USERID = ?)");
        } else if (StringUtils.equals(isA, "UN")) {//暂无回答
            sql.append(" AND nvl(N.ACOUNT,0)=0  ");
        }

        if (StringUtils.isNotEmpty(param)) {//关键字查询
            sql.append(" AND (QAI.TITLE LIKE  ?  OR QAI.CONTENT LIKE ?)");
        }

        if (StringUtils.isNotEmpty(qtype)) {//类别
            sql.append("   AND  QAI.QTYPE =:qtype ");
        }
        sql.append("  ORDER BY CREATDATE DESC,ID ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        if (StringUtils.equals(isA, "myQ") || StringUtils.equals(isA, "myA")) {
            query.setParameter(1, entId);//我的id
        } else if (StringUtils.isNotEmpty(param)) {
            query.setParameter(1, "%" + param + "%");
            query.setParameter(2, "%" + param + "%");
        }

        if (StringUtils.isNotEmpty(qtype)) {//类别
            query.setParameter("qtype", qtype);
        }
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        for (Map<String, Object> data : list) {
            Clob clob = (Clob) data.get("CONTENT");
            try {
                data.put("CONTENT", clob.getSubString((long) 1, (int) clob.length()));
            } catch (SQLException e1) {
                e1.printStackTrace();
            }
        }
        return list;
    }


    /**
     * @param
     * @describtion TODO 查询当前用户未读消息数量
     * @author ZhengZhiwei
     * @date create at 15:01 2018/3/30
     * @modified by
     */
    public Integer findUnreadMsg(String param) {
        String sql = "SELECT count(*) FROM NERDS.QA_MESSAGE WHERE M_USERID = ? AND FLAG = 'N' ";
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, param);
        Integer count = Integer.parseInt(query.getSingleResult().toString());
        return count;
    }

    /**
     * @param
     * @return
     * @author Zhong
     * @describtion TODO 未读消息列表
     * @date create at 8:50 2018/6/8
     * @modified by
     */
    public List<Map<String, Object>> qamessageList(PageParam page, String uid) {
        String sql = "SELECT i.TITLE,q.* FROM NERDS.QA_MESSAGE q ,QA_ISSUES i WHERE q.QID=i.ID(+) AND  q.M_USERID =?  AND q.FLAG = 'N' AND I.DEL_FLAG='0' ";
        // String sql = "SELECT * FROM NERDS.QA_MESSAGE WHERE M_USERID = ? AND FLAG = 'N' ";
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, uid);
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list;

    }

    /**
     * @param uid
     * @param
     * @return
     * @author Zhong
     * @describtion TODO 标记为已读消息
     * @date create at 8:50 2018/6/8
     * @modified by
     */
    public boolean qamessageUp(String id, String uid) {
        String sql = "update NERDS.QA_MESSAGE set FLAG = 'Y' ";
        if (id != null && !"".equals(id)) {
            sql += " WHERE ID = '" + id + "'";
        } else {
            sql += " WHERE M_USERID = '" + uid + "'";
        }
        Query query = entityManager.createNativeQuery(sql);
        if (query.executeUpdate() >= 1) {
            return true;
        }
        return false;

    }

    /**
     * @param
     * @describtion TODO 新建问题
     * @author ZhengZhiwei
     * @date create at 15:57 2018/3/29
     * @modified by
     */
    public Map<String, Object> addQaIssue(QaIssueEntity qaIssueEntity) {
        Map<String, Object> res = new HashMap<>();
        String idSql = "SELECT NERDS.retrieval_seq.nextval from dual";
        Query idQuery = entityManager.createNativeQuery(idSql);
        Integer id = Integer.parseInt(idQuery.getSingleResult().toString());
        String sql = "INSERT INTO retrieval.qa_issues (ID, TITLE, CONTENT, USERID, ENTID, VIEWCOUNT, REWARDS, ACCEPTED, CREATDATE, ANONYMITY, ATTACHMENTCNAME, ATTACHMENTURL,QTYPE,DEL_FLAG ) values ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ? ,'0') ";

        Query query = entityManager.createNativeQuery(sql);

        query.setParameter(1, id);
        query.setParameter(2, qaIssueEntity.getTitle());
        query.setParameter(3, qaIssueEntity.getContent());
        query.setParameter(4, qaIssueEntity.getUserid());
        query.setParameter(5, qaIssueEntity.getRetrievalId());
        query.setParameter(6, qaIssueEntity.getViewCount());
        query.setParameter(7, qaIssueEntity.getRewards());
        query.setParameter(8, qaIssueEntity.getAnonymity());
        query.setParameter(9, new Date());
        query.setParameter(10, qaIssueEntity.getAnonymity());
        query.setParameter(11, qaIssueEntity.getIssAttachmentFileName());
        query.setParameter(12, qaIssueEntity.getIssAttachmentUrl());
        query.setParameter(13, qaIssueEntity.getQtype());
        if (query.executeUpdate() == 1) {
            res.put("success", "1");
            res.put("msg", "保存成功");
        } else {
            res.put("success", "0");
            res.put("msg", "保存失败");
        }
        return res;
    }

    /**
     * @param point 增加是正数 扣除是负数
     * @param uid   用户id
     * @author ZhengZhiwei
     * @describtion TODO 根据用户id修改积分
     * @date create at 16:04 2018/4/2
     * @modified by
     */
    public void changePointByUid(Integer point, Integer VIRTUAL_POINT, Integer uid) {
        String sql = " UPDATE RETRIEVAL.RET_USERS SET QA_POINT = (QA_POINT+?),VIRTUAL_POINT=(VIRTUAL_POINT+?) WHERE ID = ?  ";
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, point);
        query.setParameter(2, VIRTUAL_POINT);
        query.setParameter(3, uid);
        query.executeUpdate();

    }

    /**
     * @param
     * @describtion TODO 获取积分最高的前N个用户
     * @author Zhong
     * @date create at 15:57 2018/3/29
     * @modified by
     */
    public List<Map<String, Object>> getTopNSore(int i) {
        String queryStr = "SELECT * FROM ( SELECT A.*, ROWNUM RN FROM (select name,qa_point from RETRIEVAL.RET_USERS where username !='adc' and qa_point is not null order by qa_point desc) A WHERE ROWNUM <= ?) WHERE RN >= 0 ";
        Query query = entityManager.createNativeQuery(queryStr);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter(1, i);
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }


    /**
     * @param count 获取用户数量
     * @author ZhengZhiwei
     * @describtion TODO 获取积分最高的用户信息
     * @date create at 11:40 2018/4/12
     * @modified by
     */
    public List<Map<String, Object>> getTopScoreUser(String count) {
        List<Map<String, Object>> res = new ArrayList<>();
        String sql = "SELECT * FROM ( SELECT A.*, ROWNUM RN FROM (select name,qa_point from RETRIEVAL.RET_USERS where qa_point is not null order by qa_point desc) A WHERE ROWNUM <= ?) WHERE RN >= 0 ";
        Query query = entityManager.createNativeQuery(sql);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter(1, count);
        res = query.getResultList();
        return res;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 通过问题id获取问题详情
     * @date create at 14:39 2018/4/12
     * @modified by
     */
    public List<Map<String, Object>> getIssueById(String qid) {
        List<Map<String, Object>> res = new ArrayList<>();
        String sql = "SELECT QAI.*,RU.NAME FROM RETRIEVAL.QA_ISSUES QAI LEFT JOIN RETRIEVAL.RET_USERS RU ON QAI.ENTID = RU.ID WHERE QAI.ID = ? ";
        Query query = entityManager.createNativeQuery(sql);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter(1, qid);
        res = query.getResultList();
        for (Map<String, Object> data : res) {
            Clob clob = (Clob) data.get("CONTENT");
            try {
                data.put("CONTENT", clob.getSubString((long) 1, (int) clob.length()));
            } catch (SQLException e1) {
                e1.printStackTrace();
            }
        }
        return res;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 根据问题id获取对应的回答
     * @date create at 16:18 2018/4/12
     * @modified by
     */
    public List<Map<String, Object>> getAnswersByQid(String qid) {
        String sql = "SELECT QAA.*,NVL(RU.SHORT_NAME,RU.NAME) NAME,(SELECT count(*) FROM RETRIEVAL.QA_ANSWERS QA WHERE QA.aid=QAA.id and  QA.DEL_FLAG=0) reply_count "
                + " FROM RETRIEVAL.QA_ANSWERS QAA LEFT JOIN RETRIEVAL.RET_USERS RU ON QAA.ENTID = RU.ID WHERE QAA.QID = ? and QAA.DEL_FLAG=0 and QAA.AID is null ORDER BY BEST,CREATDATE DESC ";
        Query query = entityManager.createNativeQuery(sql);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setParameter(1, qid);
        List<Map<String, Object>> list = query.getResultList();
        for (Map<String, Object> data : list) {
            Clob clob = (Clob) data.get("ANSWER");
            try {
                data.put("ANSWER", clob.getSubString((long) 1, (int) clob.length()));
            } catch (SQLException e1) {
                e1.printStackTrace();
            }
        }
        return list;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 问题浏览量+1
     * @date create at 15:18 2018/4/12
     * @modified by
     */
    public boolean changeViewCountByQid(String qid) {
        String updatePointSql = " UPDATE RETRIEVAL.QA_ISSUES SET VIEWCOUNT = (VIEWCOUNT+1) WHERE ID = ? ";
        Query updateQuery = entityManager.createNativeQuery(updatePointSql);
        updateQuery.setParameter(1, qid);
        if (updateQuery.executeUpdate() == 1) {
            return true;
        }
        return false;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 根据qid获取提问人的userId和所属企业的企业id
     * @date create at 13:16 2018/4/13
     * @modified by
     */
    public List<Map<String, Object>> getMuserIdByQid(Integer qid) {
        List<Map<String, Object>> res = new ArrayList<>();

        String querySql = " SELECT USERID,ENTID FROM RETRIEVAL.QA_ISSUES where id = ? ";
        Query query = entityManager.createNativeQuery(querySql);
        query.setParameter(1, qid);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        res = query.getResultList();
        return res;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 添加未读消息
     * @date create at 13:33 2018/4/13
     * @modified by
     */
    public boolean saveAnswerToMessage(String content, String type, Integer userid, Integer qid, String flag, Integer retrievalId, Integer m_userid, Integer m_entid) {
        String idSql = "SELECT NERDS.retrieval_seq.nextval from dual";
        Query idQuery = entityManager.createNativeQuery(idSql);
        Integer id = Integer.parseInt(idQuery.getSingleResult().toString());
        String insSsql = " INSERT INTO NERDS.QA_MESSAGE (ID,CONTENT,TYPE,USERID,QID,FLAG,CREATDATE,ENTID,M_ENTID,M_USERID) VALUES (?, ?, ?, ?, ?, ?, ?, ?,?,?) ";
        Query insertQuery = entityManager.createNativeQuery(insSsql);
        insertQuery.setParameter(1, id);
        insertQuery.setParameter(2, content);
        insertQuery.setParameter(3, type);
        insertQuery.setParameter(4, userid);
        insertQuery.setParameter(5, qid);
        insertQuery.setParameter(6, flag);
        insertQuery.setParameter(7, new Date());
        insertQuery.setParameter(8, retrievalId);
        insertQuery.setParameter(9, m_entid);
        insertQuery.setParameter(10, m_userid);
        if (insertQuery.executeUpdate() == 1) {
            return true;
        }
        return false;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 添加问题回答
     * @date create at 13:05 2018/4/13
     * @modified by
     */
    public boolean addQaAnswer(QaAnswerEntity qaAnswerEntity) {

        Map<String, Object> res = new HashMap<>();
        String idSql = "SELECT NERDS.retrieval_seq.nextval from dual";
        Query idQuery = entityManager.createNativeQuery(idSql);
        Integer id = Integer.parseInt(idQuery.getSingleResult().toString());
        String insertSql = " INSERT INTO RETRIEVAL.QA_ANSWERS (ID, QID, USERID, ENTID, ANSWER, GOOD_COUNT, BAD_COUNT, CREATDATE, ATTACHMENTCNAME, ATTACHMENTURL, AID, TO_USER,DEL_FLAG) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?,0 ) ";
        Query insertQuery = entityManager.createNativeQuery(insertSql);
        insertQuery.setParameter(1, id);
        insertQuery.setParameter(2, qaAnswerEntity.getQid());
        insertQuery.setParameter(3, qaAnswerEntity.getUserid());
        insertQuery.setParameter(4, qaAnswerEntity.getRetrievalId());
        insertQuery.setParameter(5, qaAnswerEntity.getAnswer());
        insertQuery.setParameter(6, qaAnswerEntity.getGoodCount());
        insertQuery.setParameter(7, qaAnswerEntity.getBadCount());
        insertQuery.setParameter(8, new Date());
        insertQuery.setParameter(9, qaAnswerEntity.getAswAttachmentFileName());
        insertQuery.setParameter(10, qaAnswerEntity.getAswAttachmentUrl());
        insertQuery.setParameter(11, qaAnswerEntity.getAid());
        insertQuery.setParameter(12, qaAnswerEntity.getToUser());
        if (insertQuery.executeUpdate() == 1) {
            return true;
        }
        return false;

    }


    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 根据回答id获取企业id
     * @date create at 16:20 2018/4/13
     * @modified by
     */
    public List<Map<String, Object>> getMuserIdByAid(int aid) {
        String querySql = " select userid,ENTID,QID from RETRIEVAL.QA_ANSWERS where id = ? AND DEL_FLAG=0";
        Query query = entityManager.createNativeQuery(querySql);
        query.setParameter(1, aid);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> res = query.getResultList();
        return res;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 清算点赞数量
     * @date create at 16:24 2018/4/13
     * @modified by
     */
    public boolean changePraiseCount(String type, String aid) {
        int id = Integer.parseInt(aid);
        String sql = "";
        if ("Y".equals(type)) {
            sql = "UPDATE RETRIEVAL.QA_ANSWERS SET GOOD_COUNT = (GOOD_COUNT+1)  WHERE ID = ?";
        } else {
            sql = "UPDATE RETRIEVAL.QA_ANSWERS SET BAD_COUNT =  (BAD_COUNT+1) WHERE ID = ?";
        }
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, id);
        if (query.executeUpdate() == 1) {
            return true;
        }
        return false;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 记录用户
     * @date create at 16:37 2018/4/13
     * @modified by
     */
    public boolean addPraiseHistory(String aid, String uid, String type) {
        int aswid = Integer.parseInt(aid);
        int userid = Integer.parseInt(uid);
        String sql = "";
        if ("Y".equals(type)) {
            sql = "UPDATE RETRIEVAL.QA_ANSWERS SET PRAISEUSERS = PRAISEUSERS || ? WHERE ID = ?";
        } else {
            sql = "UPDATE RETRIEVAL.QA_ANSWERS SET TREADUSERS = TREADUSERS || ? WHERE ID = ?";

        }
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, "|" + userid + ",");
        query.setParameter(2, aswid);
        if (query.executeUpdate() == 1) {
            return true;
        }
        return false;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 经典问题列表
     * @date create at 10:20 2018/4/16
     * @modified by
     */
    public List<Map<String, Object>> findClassicQList(PageParam page, Integer entId, String type, String param) {
        StringBuffer sql = new StringBuffer();
        sql.append(" SELECT  * FROM (  SELECT  row_number() over(order by UPLOADDATE DESC) as rn ,");
        sql.append(" ID,USERID,ENTID,FILETITLE,CATAGORY,VIEWCOUNT,to_char(UPLOADDATE,'yyyy-MM-dd HH24:mi:ss') as UPLOADDATE,DOWNLOADCOUNT FROM RETRIEVAL.QA_FILES QF WHERE 1=1 ");
        ////去掉本人限制 sql.append("   AND (ACCEPTED = 'Y' OR (ACCEPTED is null AND ENTID = ?) ) ");
        if (StringUtils.isNotEmpty(type)) {
            sql.append("   and CATAGORY = ? ");
        } else {//2019-5-9 只看系统类和流程类
            sql.append("   and CATAGORY in ('流程类','系统类' ) ");
        }
        if (StringUtils.isNotEmpty(param)) {
            sql.append("   and (FILETITLE like ?  OR FILEDESC like ?) ");
        }
        if (StringUtils.isNotEmpty(page.getStartTime())) {            //判断是否输入起始时间
            sql.append("AND to_char(UPLOADDATE,'yyyy-MM-dd HH24:mi:ss')>='" + page.getStartTime() + "'");
        }
        if (StringUtils.isNotEmpty(page.getEndTime())) {            //判断是否输入结束时间
            sql.append("AND to_char(UPLOADDATE,'yyyy-MM-dd HH24:mi:ss')<='" + page.getEndTime() + "'");
        }
        if (page.getLimit() == 4) {//首页按点击数排序
            sql.append("  ORDER BY  VIEWCOUNT DESC) ");
        } else {
            sql.append("  ORDER BY  UPLOADDATE DESC) ");
        }
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        //// query.setParameter(1, entId); 
        if (StringUtils.isNotEmpty(type)) {
            query.setParameter(1, type);
            if (StringUtils.isNotEmpty(param)) {
                query.setParameter(2, "%" + param + "%");
                query.setParameter(3, "%" + param + "%");
            }
        } else {
            if (StringUtils.isNotEmpty(param)) {
                query.setParameter(1, "%" + param + "%");
                query.setParameter(2, "%" + param + "%");
            }
        }
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 经典问题数量
     * @date create at 10:20 2018/4/16
     * @modified by
     */
    public Long findClassicQCount(PageParam page, Integer entId, String type, String param) {
        StringBuffer sql = new StringBuffer();
        sql.append(" SELECT COUNT(1) FROM ( ");
        sql.append("   SELECT * FROM RETRIEVAL.QA_FILES QF WHERE 1=1 ");

        //// sql.append("   AND (ACCEPTED = 'Y' OR (ACCEPTED is null AND ENTID = ?) )  "); 
        if (StringUtils.isNotEmpty(type)) {
            sql.append("   and CATAGORY = ? ");
        } else {//2019-5-9 只看系统类和流程类
            sql.append("   and CATAGORY in ('流程类','系统类' ) ");
        }
        if (StringUtils.isNotEmpty(param)) {
            sql.append("   and (FILETITLE like ?  OR FILEDESC like ?) ");
        }

        if (StringUtils.isNotEmpty(page.getStartTime())) {            //判断是否输入起始时间
            sql.append("AND to_char(UPLOADDATE,'yyyy-MM-dd HH24:mi:ss')>='" + page.getStartTime() + "'");
        }
        if (StringUtils.isNotEmpty(page.getEndTime())) {            //判断是否输入结束时间
            sql.append("AND to_char(UPLOADDATE,'yyyy-MM-dd HH24:mi:ss')<='" + page.getEndTime() + "'");
        }
        sql.append(" )  ");
        Query query = entityManager.createNativeQuery(sql.toString());
        ////query.setParameter(1, entId);
        if (StringUtils.isNotEmpty(type)) {
            query.setParameter(1, type);
            if (StringUtils.isNotEmpty(param)) {
                query.setParameter(2, "%" + param + "%");
                query.setParameter(3, "%" + param + "%");
            }
        } else {
            if (StringUtils.isNotEmpty(param)) {
                query.setParameter(1, "%" + param + "%");
                query.setParameter(2, "%" + param + "%");
            }
        }
        Long count = Long.parseLong(query.getSingleResult().toString());
        return count;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 上传经典问题
     * @date create at 10:11 2018/4/16
     * @modified by
     */
    public Map<String, Object> saveNewExpertsLibFileData(String enterType, QaExpertsLibFileEntity qaExpertsLibFile) {
        Map<String, Object> res = new HashMap<>();
        String idSql = "SELECT NERDS.retrieval_seq.nextval from dual";
        Query idQuery = entityManager.createNativeQuery(idSql);
        Integer id = Integer.parseInt(idQuery.getSingleResult().toString());
        String insSql = " INSERT INTO RETRIEVAL.QA_FILES (ID, USERID, ENTID ,FILETITLE, FILEDESC, REWARDS, CATAGORY, URL, CNAME, ACCEPTED, UPLOADDATE, VIEWCOUNT, DOWNLOADCOUNT) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, 0, 0 ) ";
        Query insQuery = entityManager.createNativeQuery(insSql);
        insQuery.setParameter(1, id);
        insQuery.setParameter(2, qaExpertsLibFile.getUserid());
        insQuery.setParameter(3, qaExpertsLibFile.getRetrievalId());
        insQuery.setParameter(4, qaExpertsLibFile.getFileTitle());
        insQuery.setParameter(5, qaExpertsLibFile.getFileDesc());
        insQuery.setParameter(6, 0);
        insQuery.setParameter(7, qaExpertsLibFile.getCatagory());
        insQuery.setParameter(8, qaExpertsLibFile.getFileUrl());
        insQuery.setParameter(9, qaExpertsLibFile.getFileName());
        insQuery.setParameter(10, qaExpertsLibFile.getAccepted());
        insQuery.setParameter(11, new Date());
        if (insQuery.executeUpdate() == 1) {
            res.put("success", true);
            res.put("qid", id);
        } else {
            res.put("success", false);
        }
        return res;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 添加到QA_MESSAGE 表中
     * @date create at 14:32 2018/4/16
     * @modified by
     */
    public void saveYwzlToMessage(String content, String type_dianzan, Integer userid, Integer qid, Integer entid, String ywzl_flag) {
        Map<String, Object> res = new HashMap<>();
        String idSql = "SELECT NERDS.retrieval_seq.nextval from dual";
        Query idQuery = entityManager.createNativeQuery(idSql);
        Integer id = Integer.parseInt(idQuery.getSingleResult().toString());
        String insSql = " INSERT INTO NERDS.QA_MESSAGE (ID,CONTENT,TYPE,USERID,QID,CREATDATE,ENTID,YWZL_FLAG) VALUES (?, ?, ?, ?, ?, ?, ?, ?) ";
        Query insQuery = entityManager.createNativeQuery(insSql);
        insQuery.setParameter(1, id);
        insQuery.setParameter(2, content);
        insQuery.setParameter(3, type_dianzan);
        insQuery.setParameter(4, userid);
        insQuery.setParameter(5, qid);
        insQuery.setParameter(6, new Date());
        insQuery.setParameter(7, entid);
        insQuery.setParameter(8, ywzl_flag);
        insQuery.executeUpdate();
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 改变经典问题的浏览量 每次加1
     * @date create at 8:07 2018/4/17
     * @modified by
     */
    public boolean changeViewCountByCQid(String cqid) {
        Integer cqidi = Integer.parseInt(cqid);
        String updatePointSql = " UPDATE RETRIEVAL.QA_FILES SET VIEWCOUNT = (VIEWCOUNT+1) WHERE ID = ? ";
        Query updateQuery = entityManager.createNativeQuery(updatePointSql);
        updateQuery.setParameter(1, cqidi);
        if (updateQuery.executeUpdate() == 1) {
            return true;
        }
        return false;
    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 根据id获取经典问题详细信息
     * @date create at 8:18 2018/4/17
     * @modified by
     */
    public Map<String, Object> findClassicQDetail(String param) {
        Map<String, Object> res = new HashMap<>();
        String sql = " SELECT QF.ID,QF.USERID,QF.FILETITLE,QF.FILEDESC,QF.CATAGORY,QF.CNAME as FILENAME, QF.URL as FILEURL,QF.ENTID,NVL(RU.SHORT_NAME,RU.NAME) NAME FROM RETRIEVAL.QA_FILES QF LEFT JOIN RETRIEVAL.RET_USERS RU ON QF.ENTID = RU.ID WHERE QF.ID = ? ";
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, param);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> resList = query.getResultList();
        if (resList.isEmpty()) {
            res.put("err", "操作异常，请稍后重试");
            return res;
        } else {
            res = resList.get(0);
        }
        return res;

    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 根据id获取经典问题附件信息
     * @date create at 8:18 2018/4/17
     * @modified by
     */
    public Map<String, Object> findClassicQFileInfo(String param) {
        Map<String, Object> res = new HashMap<>();
        String sql = " SELECT QF.ID,QF.CNAME as FILENAME, QF.URL as FILEURL FROM RETRIEVAL.QA_FILES QF LEFT JOIN RETRIEVAL.RET_USERS RU ON QF.ENTID = RU.ID WHERE QF.ID = ? ";
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, param);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> resList = query.getResultList();
        if (resList.isEmpty()) {
            res.put("err", "操作异常，请稍后重试");
            return res;
        } else {
            res = resList.get(0);
        }
        return res;

    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 根据id获取问题附件信息
     * @date create at 8:18 2018/4/17
     * @modified by
     */
    public Map<String, Object> findQFileInfo(String param) {
        Map<String, Object> res = new HashMap<>();
        String sql = "SELECT QAI.ATTACHMENTCNAME as FILENAME, QAI.ATTACHMENTURL as FILEURL FROM RETRIEVAL.QA_ISSUES QAI LEFT JOIN RETRIEVAL.RET_USERS RU ON QAI.ENTID = RU.ID WHERE QAI.ID = ? ";
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, param);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> resList = query.getResultList();
        if (resList.isEmpty()) {
            res.put("err", "操作异常，请稍后重试");
            return res;
        } else {
            res = resList.get(0);
        }
        return res;

    }

    /**
     * @param
     * @return
     * @author ZhengZhiwei
     * @describtion TODO 根据id获取答案附件信息
     * @date create at 8:18 2018/4/17
     * @modified by
     */
    public Map<String, Object> findQAFileInfo(String param) {
        Map<String, Object> res = new HashMap<>();
        String sql = " SELECT QAA.ATTACHMENTCNAME as FILENAME, QAA.ATTACHMENTURL as FILEURL FROM RETRIEVAL.QA_ANSWERS QAA LEFT JOIN RETRIEVAL.RET_USERS RU ON QAA.ENTID = RU.ID WHERE QAA.ID = ?";
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, param);
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> resList = query.getResultList();
        if (resList.isEmpty()) {
            res.put("err", "操作异常，请稍后重试");
            return res;
        } else {
            res = resList.get(0);
        }
        return res;

    }

    /**
     * @param
     * @return
     * @author Zhong
     * @describtion TODO 采纳最佳答案
     * @date create at 8:18 2018/5/15
     * @modified by
     */
    public boolean bestanswer(String qid, String aid) {
        String updateQA_ISSUES = " UPDATE RETRIEVAL.QA_ISSUES SET ACCEPTED = 'Y' WHERE ID = '" + qid + "'";
        String updateQA_ANSWERS = " UPDATE RETRIEVAL.QA_ANSWERS SET BEST = 'Y' WHERE ID = '" + aid + "'";
        Query updateQuery1 = entityManager.createNativeQuery(updateQA_ISSUES);
        Query updateQuery2 = entityManager.createNativeQuery(updateQA_ANSWERS);
        if (updateQuery1.executeUpdate() == 1 && updateQuery2.executeUpdate() == 1) {
            return true;
        }
        return false;
    }

    /**
     * @param @param  type
     * @param @param  aid
     * @param @return 设定文件
     * @param uid
     * @return boolean    返回类型
     * @Title: cancelPraiseCount
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午1:58:18
     */
    public boolean cancelPraiseCount(String type, String aid, String uid) {
        int id = Integer.parseInt(aid);
        String sql = "";
        if ("Y".equals(type)) {
            sql = "UPDATE RETRIEVAL.QA_ANSWERS SET GOOD_COUNT = (GOOD_COUNT-1)  WHERE ID = ? and PRAISEUSERS LIKE '%|" + uid + ",%'";
        } else {
            sql = "UPDATE RETRIEVAL.QA_ANSWERS SET BAD_COUNT =  (BAD_COUNT-1) WHERE ID = ? and TREADUSERS LIKE '%|" + uid + ",%'";
        }
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, id);
        if (query.executeUpdate() == 1) {
            return true;
        }
        return false;
    }

    /**
     * @param @param aid
     * @param @param uid
     * @param @param type    设定文件
     * @return
     * @Title: cancelPraiseHistory
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午1:59:24
     */
    public boolean cancelPraiseHistory(String aid, String uid, String type) {
        int aswid = Integer.parseInt(aid);
        int userid = Integer.parseInt(uid);
        String sql = "";
        if ("Y".equals(type)) {
            sql = "UPDATE RETRIEVAL.QA_ANSWERS SET PRAISEUSERS = REPLACE(PRAISEUSERS, ?, '')  WHERE ID = ?";
        } else {
            sql = "UPDATE RETRIEVAL.QA_ANSWERS SET TREADUSERS = REPLACE(TREADUSERS, ?, '')  WHERE ID = ?";

        }
        Query query = entityManager.createNativeQuery(sql);
        query.setParameter(1, "|" + userid + ",");
        query.setParameter(2, aswid);
        if (query.executeUpdate() == 1) {
            return true;
        }
        return false;

    }

    /**
     * @param @param qid
     * @param @param aid    设定文件
     * @param userId
     * @return
     * @Title: cancelbestanswer
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午4:41:31
     */
    public boolean cancelbestanswer(String userId, String qid, String aid) {

        String updateQA_ISSUES = " UPDATE RETRIEVAL.QA_ISSUES SET ACCEPTED = '' WHERE ID = '" + qid + "'";
        if (!"61077".equals(userId)) {
            updateQA_ISSUES += " and  USERID='" + userId + "' ";
        }
        String updateQA_ANSWERS = " UPDATE RETRIEVAL.QA_ANSWERS SET BEST = '' WHERE QID = '" + qid + "'";
        Query updateQuery1 = entityManager.createNativeQuery(updateQA_ISSUES);
        Query updateQuery2 = entityManager.createNativeQuery(updateQA_ANSWERS);
        if (updateQuery1.executeUpdate() > 0) {
            if (updateQuery2.executeUpdate() > 0)
                return true;
        }
        return false;
    }

    /**
     * @param @param uid
     * @param @param qid
     * @param @param aid    设定文件
     * @return
     * @Title: bestanswer
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午5:29:26
     */
    public boolean bestanswer(String uid, String qid, String aid) {
        String updateQA_ISSUES = " UPDATE RETRIEVAL.QA_ISSUES SET ACCEPTED = 'Y' WHERE ID = '" + qid + "' ";
        if (!"61077".equals(uid)) {
            updateQA_ISSUES += " and  USERID='" + uid + "' ";
        }
        String updateQA_ANSWERS = " UPDATE RETRIEVAL.QA_ANSWERS SET BEST = 'Y' WHERE  ID = '" + aid + "' and QID = '" + qid + "'";
        Query updateQuery1 = entityManager.createNativeQuery(updateQA_ISSUES);
        Query updateQuery2 = entityManager.createNativeQuery(updateQA_ANSWERS);
        if (updateQuery1.executeUpdate() == 1) {
            if (updateQuery2.executeUpdate() > 0)
                return true;
        }
        return false;
    }

    /**
     * @param @param  uid
     * @param @param  aid
     * @param @return 设定文件
     * @Title: getQaReplyList
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午2:15:37
     */
    public List<Map<String, Object>> getQaReplyList(String uid, String aid) {
        StringBuffer sql = new StringBuffer();
        sql.append("  SELECT QAI.*,NVL(RU.SHORT_NAME,RU.NAME)  to_username,NVL( U.SHORT_NAME, U.NAME) username ");
        sql.append("  FROM RETRIEVAL.QA_ANSWERS QAI  ");
        sql.append("  LEFT JOIN RETRIEVAL.RET_USERS RU on RU.ID=QAI.TO_USER ");
        sql.append("  LEFT JOIN RETRIEVAL.RET_USERS U on U.ID=QAI.USERID ");
        sql.append("  WHERE QAI.DEL_FLAG=0  ");
        if (StringUtils.isNotEmpty(aid)) {//我的提问
            sql.append(" and QAI.AID = ? ");//我的id
        }
        sql.append("  ORDER BY CREATDATE DESC  ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        if (StringUtils.isNotEmpty(aid)) {//关键字查询
            query.setParameter(1, aid);
        }
        List<Map<String, Object>> list = query.getResultList();
        for (Map<String, Object> data : list) {
            Clob clob = (Clob) data.get("ANSWER");
            try {
                data.put("ANSWER", clob.getSubString((long) 1, (int) clob.length()));
            } catch (SQLException e1) {
                e1.printStackTrace();
            }
        }
        return list;
    }

    /**
     * @param @param  uid
     * @param @param  aid
     * @param @return 设定文件
     * @return boolean    返回类型
     * @Title: deleteQaAnswer
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午2:25:35
     */
    public boolean deleteQaAnswer(String uid, String aid) {
        String updateQA_ANSWERS = " UPDATE RETRIEVAL.QA_ANSWERS SET DEL_FLAG = '1' WHERE ID = '" + aid + "'";
        if (!"61077".equals(uid)) {
            updateQA_ANSWERS += " and  USERID='" + uid + "' ";
        }
        Query updateQuery1 = entityManager.createNativeQuery(updateQA_ANSWERS);
        if (updateQuery1.executeUpdate() == 1) {
            return true;
        }
        return false;
    }

    public boolean deleteQaIssue(String uid, String aid) {
        String updateQA_ANSWERS = " UPDATE RETRIEVAL.QA_ISSUES SET DEL_FLAG = '1' WHERE ID = '" + aid + "'";
        if (!"61077".equals(uid)) {
            updateQA_ANSWERS += " and  USERID='" + uid + "' ";
        }
        Query updateQuery1 = entityManager.createNativeQuery(updateQA_ANSWERS);
        if (updateQuery1.executeUpdate() == 1) {
            return true;
        }
        return false;
    }

    /**
     * @param @return 设定文件
     * @Title: countByType
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午4:01:54
     */
    public List<Map<String, Object>> countByType() {
        Map<String, Object> map = new HashMap<>();
        StringBuffer sql = new StringBuffer();
        sql.append("  SELECT QTYPE ,count(*) count FROM RETRIEVAL.QA_ISSUES WHERE DEL_FLAG='0'  GROUP BY QTYPE ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);

        List<Map<String, Object>> list = query.getResultList();
        return list;
    }

    /**
     * @param @return 设定文件
     * @Title: orderQyname
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 上午10:56:51
     */
    public List<Map<String, Object>> orderQyname() {
        Map<String, Object> map = new HashMap<>();
        StringBuffer sql = new StringBuffer();
        sql.append(" SELECT  * FROM ");
        sql.append(" (SELECT U . NAME,COUNT(*),l.USERID  FROM ");
        sql.append(" NERDS.RETRIEVAL_SYS_LOG l, RET_USERS U ");
        sql.append(" WHERE ");
        sql.append(" l.USERID = U .ID (+) ");
        sql.append(" AND CLICKMODULE  LIKE '%login%' ");
        sql.append(" and l.NOTE  !=  '221.239.111.146,天津市'  ");
        sql.append(" and l.USERID !=  '61077'  ");
        sql.append(" GROUP BY l.USERID ,U . NAME ");
        sql.append(" ORDER BY COUNT(*) DESC ) ");
        sql.append(" WHERE ROWNUM<11 ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }

    /**
     * @param @return 设定文件
     * @Title: qaListByHot
     * @Description: TODO(这里用一句话描述这个方法的作用)
     * @author ADC_ZH
     * @date 下午2:41:04
     */
    public List<Map<String, Object>> qaListByHot(PageParam page) {
        Map<String, Object> map = new HashMap<>();
        StringBuffer sql = new StringBuffer();
        sql.append(" SELECT  ID,USERID,TITLE,NVL(NAME ,'匿名') NAME,  to_char(CREATDATE,'yyyy-MM-DD') as CREATDATE , GOODCOUNT,ANSWERCOUNT ,  VIEWCOUNT,BESTANSWER ");
        sql.append(" FROM  ");
        sql.append(" (  SELECT q.ID,q.TITLE, CREATDATE,VIEWCOUNT,NVL(RU.SHORT_NAME,RU.NAME) NAME,q.USERID, ");
        sql.append(" (SELECT a.ANSWER  FROM QA_ANSWERS a WHERE a.QID=q.ID AND a.BEST='Y'AND a.AID IS NULL AND a.DEL_FLAG=0 ) BESTANSWER, ");
        sql.append(" (SELECT NVL(A.GOOD_COUNT, 0)  FROM QA_ANSWERS a WHERE a.QID=q.ID AND a.BEST='Y'AND a.AID IS NULL AND a.DEL_FLAG=0 ) GOODCOUNT, ");
        sql.append(" (SELECT NVL(SUM(A.GOOD_COUNT), 0) FROM QA_ANSWERS a WHERE a.QID=q.ID AND a.DEL_FLAG=0 ) GOODCOUNT1, ");
        sql.append(" (SELECT ABS(NVL(SUM(A.GOOD_COUNT), 0)-NVL(SUM(A.BAD_COUNT), 0)) FROM QA_ANSWERS a WHERE a.QID=q.ID AND a.DEL_FLAG=0 ) POINT, ");
        sql.append(" (SELECT COUNT (*) FROM QA_ANSWERS a WHERE a.QID=q.ID AND a.AID=(SELECT ID FROM QA_ANSWERS a WHERE a.QID=q.ID AND a.BEST='Y'AND a.AID IS NULL AND a.DEL_FLAG=0 )  AND a.DEL_FLAG=0  ) ANSWERCOUNT , ");
        sql.append(" (SELECT COUNT (*) FROM QA_ANSWERS a WHERE a.QID=q.ID AND a.DEL_FLAG=0  AND a.AID IS NULL ) ANSWERCOUNT1 , ");
//        sql.append(" (VIEWCOUNT-1)/ power(ceil(decode((SYSDATE-q.CREATDATE),0,1)),1.5)  ORDERSEQ "); 
        sql.append(" (( VIEWCOUNT - 1 ) / power( ceil((SYSDATE - q.CREATDATE)+2)  , 1.5 )) ORDERSEQ ");
        sql.append(" FROM QA_ISSUES q LEFT JOIN RETRIEVAL.RET_USERS RU on RU.ID=q.USERID  WHERE Q.DEL_FLAG='0'  )");
        sql.append(" ORDER BY POINT+ANSWERCOUNT1+ORDERSEQ DESC ");
        Query query = entityManager.createNativeQuery(sql.toString());
        query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        for (Map<String, Object> data : list) {
            Clob clob = (Clob) data.get("BESTANSWER");
            try {
                if (clob != null && !"".equals(clob)) {
                    data.put("BESTANSWER", clob.getSubString((long) 1, (int) clob.length()));
                }
            } catch (SQLException e1) {
                e1.printStackTrace();
            }
        }
        return list;
    }
}
