package com.adc.da.bs.resourceSharing.rest;

import com.adc.da.bs.resourceSharing.service.MeetingService;
import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RestController
@RequestMapping(value = "/${restPath}/Meeting")
@Api(description = "会议资料查询")
public class MeetingController {
    @Autowired
    private MeetingService meetingService;

    /**
     * @describtion 会议资料查询
     * @author An
     * @modified by
     */
    @ApiOperation(value = "会议资料查询列表")
    @GetMapping("/meetingList")
    @ResponseBody
    public ResponseMessage<Map<String, Object>> meetingList() {
        try {
            Map<String, Object> maps = meetingService.meetingList();
            return Result.success(maps);
        }
        catch (Exception e){
            return Result.error(e.getMessage());

        }
    }
}

