package com.adc.da.bs.webservice.schedule;

import com.adc.da.bs.login.dao.LoginDao;
import com.adc.da.bs.webservice.dao.ZbzxGgcsDao;
import com.adc.da.bs.webservice.server.ZbzxGgcsService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.AsyncResult;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.Future;

@Service
public class AsyncService {
    private static Logger logger = LoggerFactory.getLogger(AsyncService.class);

    @Autowired
    private ZbzxGgcsService zbzxGgcsService;
    @Autowired
    private ZbzxGgcsDao zbzxGgcsDao;
    @Autowired
    private LoginDao loginDao;

    // 指定使用beanname为synchroDataExecutor的线程池
    @Async("synchroDataExecutor")
    public Future<String> execStep(Map<String, Object> map) throws InterruptedException {

        try {
            System.out.println("调用异步开始时间："+System.currentTimeMillis());

            // 获取当前ADC总库批次
            int maxpc = zbzxGgcsDao.findMaxPcCount();
            System.out.println("获取当前ADC总库批次时间："+System.currentTimeMillis());
            Map<String, Object> resMap = new HashMap<>(3);
            resMap = zbzxGgcsService.GetGgcsByUser(map.get("username").toString(), String.valueOf(maxpc), (Map<String, String>) map.get("cookies"));
            resMap.put("result", "Y");
            logger.info("****** STEP 1：GetGgcsByUser END", map.get("username"));

            if ("Y".equals(resMap.get("result").toString())) {
                logger.info("****** STEP 2：importDpData START", map.get("username"));
                loginDao.importDpData();     //导入底盘数据
                logger.info("****** STEP 2：importDpData END", map.get("username"));
                loginDao.importZcPicData();  //导入整车照片数据
                logger.info("****** STEP 3：ImportZcPicData END", map.get("username"));
                loginDao.pushZcPicFile();    // Step3.1 同步照片
                logger.info("****** STEP 3.1：pushZcPicFile END", map.get("username"));

                loginDao.importZcData();     //导入整车数据
                logger.info("****** STEP 3：importZcData END", map.get("username"));
                loginDao.dealCpsb();         //处理产品商标
                logger.info("****** STEP 4：dealCpsb END", map.get("username"));

                logger.info("****** STEP 5：updateRetUserStatusY START", map.get("username"));
                loginDao.updateRetUserStatusY(map);
                logger.info("****** STEP 5：updateRetUserStatusY END", map.get("username"));
            }
            System.out.println("调用异步结束时间："+System.currentTimeMillis());
            return new AsyncResult<>("Y");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return new AsyncResult<>("N");
    }
}
