package com.adc.da.bs.webservice.util;

import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

import javax.crypto.Cipher;
import javax.crypto.CipherInputStream;
import javax.crypto.CipherOutputStream;
import javax.crypto.spec.SecretKeySpec;
import java.io.*;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.security.Key;

public class DESUtil {
    Key key;

    public DESUtil() {
    }

    public DESUtil(String str) {
        setKey(str); // 设置秘钥
    }

    public Key getKey() {
        return key;
    }

    public void setKey(Key key) {
        this.key = key;
    }

    /**
     * 根据参数生成秘钥
     */
    public void setKey(String strKey) {
        try {
            // KeyGenerator _generator = KeyGenerator.getInstance ( "DES" );
            // _generator.init( new SecureRandom(strKey.getBytes()));
            // this.key = _generator.generateKey();
            // System.out.println(strKey.getBytes().length);
            this.key = new SecretKeySpec(strKey.getBytes(), "DES");
            // _generator = null ;
        } catch (Exception e) {
            throw new RuntimeException("Error initializing SqlMap class. Cause: " + e);
        }
    }

    /**
     * 加密 String 明文输入 ,String 密文输出
     */
    public String encryptStr(String strMing) {
        byte[] byteMi = null;
        byte[] byteMing = null;
        String strMi = "";
        BASE64Encoder base64en = new BASE64Encoder();
        try {
            byteMing = strMing.getBytes();
            byteMi = this.encryptByte(byteMing);
            strMi = base64en.encode(byteMi);
        } catch (Exception e) {
            throw new RuntimeException("Error initializing SqlMap class. Cause: " + e);
        } finally {
            base64en = null;
            byteMing = null;
            byteMi = null;
        }
        return strMi;
    }

    /**
     *
     * 解密 以 String 密文输入 ,String 明文输出
     *
     * @param strMi
     * @return
     */
    public String decryptStr(String strMi) {
        BASE64Decoder base64De = new BASE64Decoder();
        byte[] byteMing = null;
        byte[] byteMi = null;
        String strMing = "";
        try {
            byteMi = base64De.decodeBuffer(strMi);
            byteMing = this.decryptByte(byteMi);
            strMing = new String(byteMing, "UTF8");
        } catch (Exception e) {
            throw new RuntimeException("Error initializing SqlMap class. Cause: " + e);
        } finally {
            base64De = null;
            byteMing = null;
            byteMi = null;
        }
        return strMing;
    }

    /**
     * 加密以 byte[] 明文输入 ,byte[] 密文输出
     *
     * @param byteS
     * @return
     */
    private byte[] encryptByte(byte[] byteS) {
        byte[] byteFina = null;
        Cipher cipher;
        try {
            cipher = Cipher.getInstance("DES");
            cipher.init(Cipher.ENCRYPT_MODE, key);
            byteFina = cipher.doFinal(byteS);
        } catch (Exception e) {
            throw new RuntimeException("Error initializing SqlMap class. Cause: " + e);
        } finally {
            cipher = null;
        }
        return byteFina;
    }

    /**
     * 解密以 byte[] 密文输入 , 以 byte[] 明文输出
     *
     * @param byteD
     * @return
     */
    private byte[] decryptByte(byte[] byteD) {
        Cipher cipher;
        byte[] byteFina = null;
        try {
            cipher = Cipher.getInstance("DES");
            cipher.init(Cipher.DECRYPT_MODE, key);
            byteFina = cipher.doFinal(byteD);
        } catch (Exception e) {
            throw new RuntimeException("Error initializing SqlMap class. Cause: " + e);
        } finally {
            cipher = null;
        }
        return byteFina;
    }

    /**
     * 文件 file 进行加密并保存目标文件 destFile 中
     *
     * @param file 要加密的文件 如 c:/test/srcFile.txt
     * @param destFile 加密后存放的文件名 如 c:/ 加密后文件 .txt
     */
    public void encryptFile(String file, String destFile) throws Exception {
        Cipher cipher = Cipher.getInstance("DES");
        // cipher.init(Cipher.ENCRYPT_MODE, getKey());
        cipher.init(Cipher.ENCRYPT_MODE, this.key);
        InputStream is = new FileInputStream(file);
        OutputStream out = new FileOutputStream(destFile);
        CipherInputStream cis = new CipherInputStream(is, cipher);
        byte[] buffer = new byte[1024];
        int r;
        while ((r = cis.read(buffer)) > 0) {
            out.write(buffer, 0, r);
        }
        cis.close();
        is.close();
        out.close();
    }

    /**
     * 文件采用 DES 算法解密文件
     *
     * @param file 已加密的文件 如 c:/ 加密后文件 .txt *
     * @param destFile 解密后存放的文件名 如 c:/ test/ 解密后文件 .txt
     */
    public void decryptFile(String file, String dest) throws Exception {
        Cipher cipher = Cipher.getInstance("DES");
        cipher.init(Cipher.DECRYPT_MODE, this.key);
        InputStream is = new FileInputStream(file);
        OutputStream out = new FileOutputStream(dest);
        CipherOutputStream cos = new CipherOutputStream(out, cipher);
        byte[] buffer = new byte[1024];
        int r;
        while ((r = is.read(buffer)) >= 0) {
            cos.write(buffer, 0, r);
        }
        cos.close();
        out.close();
        is.close();
    }

    // 常规加解密工具
    private static DESUtil encry = new DESUtil("ADCCVT16");

    // 加密CPID
    public static String encCpid(String cpid) throws UnsupportedEncodingException {
        String encCpid = encry.encryptStr(cpid);
        encCpid = URLEncoder.encode(encCpid, "UTF-8");
        return encCpid;
    }

    // 解密CPID
    public static String decCpid(String encCpid) throws UnsupportedEncodingException {
        if(encCpid.indexOf("+")>=0||encCpid.indexOf("=")>=0){
            encCpid = URLEncoder.encode(encCpid, "UTF-8");
        }
//		String cp_id = URLEncoder.encode(encCpid, "UTF-8");

        String	cp_id = URLDecoder.decode(encCpid, "UTF-8");
        cp_id = encry.decryptStr(cp_id);
        return cp_id;
    }

    // 方案审查专用加解密工具
    public static DESUtil jyfaEncry = new DESUtil("JYFA_CVT");

    // 指定加密CPID
    public static String encCpid(String cpid, DESUtil desUtil) throws UnsupportedEncodingException {
        String encCpid = desUtil.encryptStr(cpid);
        encCpid = URLEncoder.encode(encCpid, "UTF-8");
        return encCpid;
    }

    // 指定解密CPID
    public static String decCpid(String encCpid, DESUtil desUtil) throws UnsupportedEncodingException {
        if (encCpid.indexOf("+") >= 0 || encCpid.indexOf("=") >= 0) {
            encCpid = URLEncoder.encode(encCpid, "UTF-8");
        }

        String cp_id = URLDecoder.decode(encCpid, "UTF-8");
        cp_id = desUtil.decryptStr(cp_id);
        return cp_id;
    }

    // 指定解密XZID
    public static String decXzid(String encCpid, DESUtil desUtil) throws UnsupportedEncodingException {
        if (encCpid.indexOf("+") >= 0 || encCpid.indexOf("=") >= 0) {
            encCpid = URLEncoder.encode(encCpid, "UTF-8");
        }
        String xzId = URLDecoder.decode(encCpid, "UTF-8");
        xzId = desUtil.decryptStr(xzId);
        return xzId;
    }

}
