package com.adc.da.communal.Utils;

import org.apache.commons.lang3.time.DateFormatUtils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author ZhengZhiwei
 * @description
 * @date create at 11:25 2018/4/9
 * @modified by
 */
public class DateUtils{
    /**
     * @author ZhengZhiwei
     * @describtion  时间转换为字符串 (例: 2分钟前，1天前......)
     * @param
     * @date create at 11:29 2018/4/9
     * @modified by
     */
    public static String dateToString(Date date) {
        Date u = date;
        Date n = new Date();

        long between = n.getTime() - u.getTime() ;

        long day = between / (24 * 60 * 60 * 1000);
        long hour = (between / (60 * 60 * 1000) - day * 24);
        long min = ((between / (60 * 1000)) - day * 24 * 60 - hour * 60);
        long s = (between / 1000 - day * 24 * 60 * 60 - hour * 60 * 60 - min * 60);
        String timeGap = day < 5?(day == 0 ? (hour == 0 ? (min == 0 ? (String.valueOf(s) + "秒前"): String.valueOf(min) + "分钟前"): String.valueOf(hour) + "小时前") : String.valueOf(day) + "天前"):getDate("yyyy-MM-dd ",date);
        return timeGap;
    }
    /**
     * @author ZhengZhiwei
     * @describtion 得到日期字符串 格式（yyyy-MM-dd） pattern可以为："yyyy-MM-dd" "HH:mm:ss" "E"
     * @param
     * @date create at 11:45 2018/4/9
     * @modified by
     */
    public static String getDate(String pattern,Date date) {
        return DateFormatUtils.format(date, pattern);
    }

    public static Date stringToDate(String pattern,String strDate){
        //注意：SimpleDateFormat构造函数的样式与strDate的样式必须相符
        SimpleDateFormat simpleDateFormat=new SimpleDateFormat(pattern); //加上时间
        //必须捕获异常
        try {
            Date date=simpleDateFormat.parse(strDate);
            return date;
        } catch(ParseException px) {
            px.printStackTrace();
        }
        return null;
    }
}
