package com.adc.da.communal.file.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.web.multipart.MultipartFile;

/**
 * 文件上传入参VO
 *
 * @author 韩磊
 * @version V1.0
 * @date 2019-03-20 16:12
 **/
@Data
public class FileUploadQueryVO {

    /**
     * 名称
     */
    @ApiModelProperty(value = "名称")
    private String title;

    /**
     * 页数
     */
    @ApiModelProperty(value = "页数")
    private String pageNum;

    /**
     * 图片数
     */
    @ApiModelProperty(value = "图片数")
    private String chartsNum;

    /**
     * 作者
     */
    @ApiModelProperty(value = "作者")
    private String author;

    /**
     * 模块分类
     * 1：分析报告页面中的 "公告"栏
     * 2：分析报告页面中的 "新能源"栏
     * 3：政策研究页面
     * 4：资源共享页面(1级菜单)中的 会议资料(2级菜单)
     */
    @ApiModelProperty(value = "模块分类，1：分析报告页面中的 \"公告\"栏\n  " +
            "2：分析报告页面中的 \"新能源\"栏\n   " +
            "3：政策研究页面\n  " +
            "4：资源共享页面(1级菜单)中的 会议资料(2级菜单)")
    private int type;

    /**
     * 主要内容
     */
    @ApiModelProperty(value = "主要内容")
    private String content;

    /**
     * 置顶
     */
    @ApiModelProperty(value = "置顶 1：置顶，0 ：不置顶")
    private Integer top = 0;
    
    /**
     * 主要内容
     */
    @ApiModelProperty(value = "上传日期")
    private String uploadDate;
}
